/**
 * @fileOverview
 * @name kth.puddingto.introductionMain.js
 * @author Kim il (blaxtar@kthcorp.com)
 * @version 20120611
 * @lastModified 2012-06-11
 * @created 2012-06-08
 * @description
 * <pre>
 * Pudding.To > 소개
 *
 * classes:
 * - {@link kth.puddingto.Introduction} 소개 페이지
 * 
 * </pre>
 */
/*jslint browser:true devel:true white:false plusplus:false */
/*global window:true $:true kth:true */
(function(global) {

/**
 * @class
 * @name kth.puddingto.Introduction
 * @param {object} options Options
 * @example
kth.puddingto.Introduction({
	//
});
 */
kth.getPackage('kth.puddingto.Introduction', (function(NAME, Introduction) {
	var /* private static constants */
		_INSTANCE = null;
	
	/**
	 * @constructor
	 * @ignore
	 */
	Introduction = function Introduction(options) {
		if (_INSTANCE) {
			return _INSTANCE;
		} else if (!(this instanceof Introduction)) {
			return (_INSTANCE = new Introduction(options));
		} else {
			_INSTANCE = this;
		}
		this._init(options);
	};
	Introduction.prototype = /** @lends kth.puddingto.Introduction.prototype */ {
		options: {},

		_init: function(options) {
			var options = this.options = $.extend(this.options, options);
			var locale = PuddingTo.locale,
				url;
			
			url =  {
				en: 'http://help.paran.com/faq/global/english/mIndex.jsp?nodeId=NODE0000001077&TBID=TBOX20120119000000',
				ko: 'http://help.paran.com/faq/global/korean/mIndex.jsp?nodeId=NODE0000001075&TBID=TBOX20120117000000',
				ja: 'http://help.paran.com/faq/global/english/mIndex.jsp?nodeId=NODE0000001077&TBID=TBOX20120119000000' /* @TODO 일본어 버전 '도움말/고객센터' 링크 */
			}[locale];
			
			$('#p2-help-about').attr('href', url);
			
			url =  {
				en: 'http://blog.pudding.to',
				ko: 'http://blog.pudding.to/ko/',
				ja: 'http://blog.pudding.to' /* @TODO 일본어 버전 '푸딩.투 블로그' 링크 */
			}[locale];
			
			$('#p2-help-blog').attr('href', url);
			
			url = {
				en: 'http://blog.pudding.to/terms-of-service',
				ko: 'http://blog.pudding.to/ko/terms-of-service/',
				ja: 'http://blog.pudding.to/terms-of-service-jp/'
			}[locale];
			
			$('#p2-help-terms').attr('href', url);

			url = {
				en: 'http://blog.pudding.to/privacy-policy',
				ko: 'http://blog.pudding.to/ko/privacy-policy/',
				ja: 'http://blog.pudding.to/privacy-policy-jp/'
			}[locale];
				
			$('#p2-help-privacy').attr('href', url);
			
			$('a').click(function(event) {
				event.preventDefault();
				
				var $this = $(this),
					call  = $this.data('call'),
					href  = $this.attr('href'),
					url;
			
				if (call == 'browser') {
					url = PuddingTo.urlFor(PuddingTo.consts.CALL_SAFARI, {
						url: encodeURIComponent(href)
					});
				} else if (call == 'help') {
					url = PuddingTo.urlFor(PuddingTo.consts.CALL_HELP, {
						title: encodeURIComponent($this.text()),
						url  : encodeURIComponent(href)
					});
					PuddingTo.API.showLoader();
				}
				
				console.log(url);
				location.href = url;
			});
		}
	};
	return Introduction;
})('kth.puddingto.Introduction'))();

})(window);