/**
 * @fileOverview
 * @name kth.puddingto.kissMatrics.js
 * @author Kim il (blaxtar@kthcorp.com)
 * @version 20120808
 * @lastModified 2012-08-08
 * @created 2012-08-07
 * @description
 * <pre>
 * Pudding.to > Kiss Matrics Manager
 *
 * classes:
 * - {@link kth.puddingto.KissMatricsLogger} KissMatricsLogger Description
 * 
 * </pre>
 */
/*jslint browser:true, devel:true, white:false, nomen: true, plusplus:false, sloppy:true */
(function(global, $) {

/**
 * KissMatricsLogger Constructor Description
 * @class KissMatricsLogger Description
 * @name kth.puddingto.KissMatricsLogger
 * @param {object} options Options
 * @example
kth.puddingto.KissMatricsLogger({
	//
});
 */
kth.getPackage('kth.puddingto.KissMatricsLogger', (function(NAME) {
	var /* private static constants */
		_INSTANCE = null;

	/**
	 * @constructor
	 * @ignore
	 */
	function KissMatricsLogger(options, instance) {
		if (_INSTANCE) {
			instance = _INSTANCE;
		} else if (!(this instanceof KissMatricsLogger)) {
			instance = new KissMatricsLogger(options);
		} else {
			_INSTANCE = this;
			this.options = $.extend($.extend({}, this.options), options);
			this._init();
		}
		return instance;
	}
	KissMatricsLogger.prototype = /** @lends kth.puddingto.KissMatricsLogger.prototype */ {
		options: {
			clickSelector: '[data-kms=button]',
			dataMessageKey: 'kms-message'
		},

		_init: function() {
			$(function () {
				if ($(this.options.clickSelector).length) {
					$('body').on('click', this.options.clickSelector, this._onClick.bind(this));					
				}
			}.bind(this));
		},
		
		_onClick: function(e) {
			var message = $(e.target).closestData(this.options.dataMessageKey);
			if (message) {
				this.log(message);
			}
		},
		
		log: function(message) {
			if (!message) {
				return false;
			}
			
			if ($.os.android) {
				window.puddingtoKissMatrics.getKissMatricsStatus(message);
			} else {
				console.log(NAME + '.log:', message);
			}
			return true;
		}
	};
	return KissMatricsLogger;
}('kth.puddingto.KissMatricsLogger')))();

}(window, Zepto));