/**
 * @fileOverview
 * @name kth.puddingto.suggestedFriends.js
 * @author Kim il (blaxtar@kthcorp.com)
 * @version 20120806
 * @lastModified 2012-08-06
 * @created 2012-07-26
 * @description
 * <pre>
 * Pudding.to > Suggested Friends
 *
 * namespaces:
 * - {@link kth.puddingto.suggestedFriends} Utilities for Suggested Friends page 
 * </pre>
 */
/*jslint browser:true, devel:true, white:false, nomen: true, plusplus:false, sloppy:true */
(function(global, $) {

/**
 * Utilities for Suggested Friends page
 * @namespace Suggested Friends
 * @name kth.puddingto.suggestedFriends
 * @example
kth.puddingto.suggestedFriends.init();
kth.puddingto.suggestedFriends.getFollowingFriends();
 */
kth.getPackage('kth.puddingto.suggestedFriends', (function(){
	return {
		init: function(options) {
			switch (PuddingTo.params[$('[data-list]').data('list-option')]) {
				case 'first':
					$('[data-i18n=suggested-first-friends]').show();
					break;
				case 'similar':
					$('[data-i18n=none-suggested-friends]').data('i18n', 'none-suggested-similar-friends');
					break;
			} 
		},
		
		getFollowingFriends: function(callback) {
			var followingFriends = $('[data-link=follow].ing').map(function(index, element) {
				return {
					'user_id': $(element).closestData('user-id')
				};
			});
	
			if ($.isFunction(callback = (typeof callback === 'string') ? kth.getPackage(callback) : callback)) {
				try {
					callback.call(null, followingFriends);
				} catch (e) {
					this.onFollowingFriendsGet.call(this, followingFriends);	
				}
			} else {
				this.onFollowingFriendsGet.call(this, followingFriends);
			}
			return followingFriends; 
		},
		
		onFollowingFriendsGet: function(followingFriends) {
			console.log('following friends:', String(followingFriends.length), followingFriends);
			try {
				window.puddingtoFollow.getFollowSatus(String(followingFriends.length));	
			} catch (e) {
				console.log('not android!');
			}
		}
	};
}())).init();

}(window, Zepto));