(function(global) {
    
    //weinre
    //(function(e){e.setAttribute("src","http://oui.kthcorp.com:8080/target/target-script-min.js#puddingto");document.getElementsByTagName("body")[0].appendChild(e);})(document.createElement("script"));
    
    // App에서 직접 화면 스크롤을 제어할 때가 있어 정의함
    global.scrollTop = function() {
        scrollTo(0, 0);
    };
    
    
    // Function#bind를 지원하지 않으면 직접 구현한다.
    if (!Function.prototype.bind) {
        Function.prototype.bind = function(context) {
            if (typeof this !== 'function') {
                throw new TypeError('Function.prototype.bind must be called by Function');
            }

            var slice   = Array.prototype.slice,
                params  = slice.call(arguments, 1),
                fToBind = this,
                noop    = function() {},
                fBound  = function() {
                    return fToBind.apply(this instanceof noop ? this : context || window, params.concat(slice.call(arguments)));
                };

            noop.prototype   = this.prototype;
            fBound.prototype = new noop();

            return fBound;
        };
    }

    // Zepto.js 확장
    (function extendZepto() {
        // 현재 엘리먼트 기준으로 부모 방향으로 해당 키의 data 속성을 찾는다.
        $.fn.closestData = function(key) {
            return this.data(key) || this.closest('[data-' + key + ']').data(key);
        };

        // fadeOut 애니메이션 구현
        $.fn.fadeOut = function(callback) {
            return this.animate({
                duration: 0,
                opacity: 0
            }, {
                complete: function() {
                    $(this).remove();
                    if (callback) {
                        callback();
                    }
                }
            });
        };
    }());
    
    // 날짜 표시 형식
    function formatTime(time) {
        var now     = new Date(),
            created = new Date(time * 1000),
            years,
            months,
            value,
            diff,
            i18n = PuddingTo.i18n,
            result = '';

        diff = Math.floor((now - created) / 1000);

        if (diff <= 60) {
            result = i18n.TIME_JUST_NOW;
        } else if (diff <= 3600) { // 60 * 60
            value = Math.floor(diff / 60);
            result = value.toString() + (value > 1 ? i18n.TIME_MINUTES_AGO : i18n.TIME_MINUTE_AGO);
        } else if (diff <= 86400) { // 60 * 60 * 24
            value = Math.floor(diff / 3600);
            result = value.toString() + (value > 1 ? i18n.TIME_HOURS_AGO : i18n.TIME_HOUR_AGO);
        } else if (diff <= 604800) { // 60 * 60 * 24 * 7
            value = Math.floor(diff / 86400);
            result = value.toString() + (value > 1 ? i18n.TIME_DAYS_AGO : i18n.TIME_DAY_AGO);
        } else if (diff <= 2419200) { // 60 * 60 * 24 * 7 * 4
            value = Math.floor(diff / 604800);
            result = value.toString() + (value > 1 ? i18n.TIME_WEEKS_AGO : i18n.TIME_WEEK_AGO);
        } else {
            diff = (now.getFullYear() * 12 + now.getMonth()) - (created.getFullYear() * 12 + created.getMonth());

            years  = Math.floor(diff / 12).toString();
            months = (diff % 12).toString();

            if (years) {
                result = years + (years > 1 ? i18n.TIME_YEARS : i18n.TIME_YEAR);
            }

            if (months) {
                result += months + (months > 1 ? i18n.TIME_MONTHS_AGO : i18n.TIME_MONTH_AGO);
            }
        }

        return result;
    }
    
    var consts,
        server,
        routes,
        params,
        links;
        
    consts = {
        // App 통신에 사용할 사용자 프로토콜 정의
        CALL_HELP      : 'puddingsns://GOHELP?title={{title}}&url={{url}}',
        CALL_LOGIN_OK  : 'puddingsns://LOGINOK?token={{token}}&user_id={{uid}}&user_name={{username}}&profile_picture={{profile_picture}}',
        CALL_PROFILE   : 'puddingsns://GOPROFILE?user_id={{target_id}}&token={{token}}',
        CALL_PHOTO     : 'puddingsns://PHOTO?photo_id={{target_id}}&token={{token}}',
        CALL_POI       : 'puddingsns://SELECTPOI?id={{location_id}}&name={{location_name}}&latitude={{location_latitude}}&longitude={{location_longitude}}',
        CALL_POI_SELECT: 'puddingsns://SELECTEDPOI?id={{location_id}}&name={{location_name}}&latitude={{location_latitude}}&longitude={{location_longitude}}',
        CALL_REQUEST   : 'https://request?url={{url}}',
        CALL_SAFARI    : 'puddingsns://GOSAFARI?url={{url}}',
        CALL_SNS       : 'puddingsns://GOSNS?url={{url}}',
        CALL_TAG       : 'puddingsns://SELECTTAG?type={{type}}&title={{title}}{{#poi}}&poi_id={{poi}}{{/poi}}',

        // 사진이 없을 경우 기본으로 사용할 이미지
        DEFAULT_PROFILE: '../img/profile_default_img.png',
        DEFAULT_PHOTO  : '../img/photo_noimage_default.png',

        // 유효성 검사에 사용할 정규식
        REGEX_EMAIL    : /^[_0-9a-zA-Z\-]+(\.[_0-9a-zA-Z\-]+)*@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
        REGEX_PASSWORD : /^[\x20-\x7E]+$/i,
        REGEX_USERNAME : /^[_a-z0-9]+$/i,

        URL_FB_LOGIN   : 'https://www.pudding.to/user/facebook/init.kth?client_id={{client_id}}&type=login',
        URL_FB_LINK    : 'https://www.pudding.to/external/sns/facebook/start.kth?client_id={{client_id}}&token={{token}}',
        URL_TW_LINK    : 'https://www.pudding.to/external/sns/twitter/start.kth?client_id={{client_id}}&token={{token}}',
        URL_LOGIN_OK   : 'https://LOGINOK?token={{token}}&user_id={{uid}}&user_name={{username}}&profile_picture={{profile_picture}}',

        // 페이지 내에서 다른 페이지를 호출할 경우 사용한다.
        PATH_FIND_FRIENDS         : 'findFriends.html?token={{token}}&user_id={{user_id}}',
        PATH_FIND_FRIENDS_FACEBOOK: 'findFriendsFacebook.html?token={{token}}&user_id={{user_id}}&site_id={{site_id}}',
        PATH_FIND_FRIENDS_SEARCH  : 'findFriendsSearch.html?token={{token}}&user_id={{user_id}}',
        PATH_FORGOT_EMAIL         : 'forgetEmail.html?client_id={{client_id}}',
        PATH_FORGOT_EMAIL_LIST    : 'forgetEmailList.html?client_id={{client_id}}&name={{name}}',
        PATH_FORGOT_EMAIL_DETAIL  : 'forgetEmailDetail.html?client_id={{client_id}}&id={{id}}',
        PATH_FORGOT_PASSWORD      : 'forgetPassword.html?client_id={{client_id}}',
        PATH_LOGIN                : 'logIn.html?client_id={{client_id}}',
        PATH_MUTUAL_FRIEND        : 'mutualFriend.html?token={{token}}&user_id={{user_id}}&target_id={{target_id}}',
        PATH_SIGNUP               : 'singupEmail.html?client_id={{client_id}}',
    };
    
    // 서버 주소
    server = 'https://service.pudding.to/v1/';

    // API 형식 정의
    routes = {
        'get user/blocks'           : 'user/{{user_id}}/blocks',
        'get user/connected/users'  : 'user/connected/{{site_id}}/users',
        'get user/connected/friends': 'user/connected/{{site_id}}/friends',
        'get user/duplicate'        : 'user/duplicate email,username',
        'get user/external/sns'     : 'user/external/sns',
        'get user/familiar'         : 'user/familiar',
        'get user/familiar/with'    : 'user/familiar/{{target_id}}',
        'get user/feed/my'          : 'user/feed/my',
        'get user/feed/follower'    : 'user/feed/follower',
        'get user/follows'          : 'user/{{owner_id}}/follows?search={{search}}',
        'get user/followings'       : 'user/{{owner_id}}/followings?search={{search}}',
        'get user/locations'        : 'user/{{owner_id}}/locations',
        'get user/musics'           : 'user/{{owner_id}}/musics',
        'get user/reportInfo'       : 'user/reportInfo',
        'get user/suggest'          : 'user/suggest',
        'get user/tags'             : 'user/{{owner_id}}/tags',
        'get user/tags/count'       : 'user/{{owner_id}}/tags/count',

        'get photo/likes'           : 'photo/{{photo_id}}/likes',
        'get photo/location/search' : 'photo/location/search?latitude={{latitude}}&longitude={{longitude}}&query={{query}}',
        'get photo/popular'         : 'photo/popular',
        'get photo/reportInfo'      : 'photo/reportInfo',

        'get find'                  : 'find?client_id={{client_id}}',
        'get lookup'                : 'lookup/{{user_id}}?client_id={{client_id}}',
        'get register'              : 'register?client_id={{client_id}}&terminal={{terminal}}&os={{os}}',
        
        'post user/ban'             : 'user/{{target_id}}/ban',
        'post user/connected'       : 'user/connected/{{site_id}}/friends/{{target_id}}',
        'post user/follow'          : 'user/{{target_id}}/follow',
        'post user/report'          : 'user/{{target_id}}/report client_id,reason',
        'post user/search'          : 'user/search name',
        'post user/search/email'    : 'user/search/email name',
        'post user/unblock'         : 'user/{{target_id}}/unblock',
        'post user/unfollow'        : 'user/{{target_id}}/unfollow',

        'post photo/report'         : 'photo/{{target_id}}/report client_id,reason',

        'post authorize'            : 'authorize?timeStamp={{timeStamp}} client_id,email,password,fb,uid,terminal,os',
        'post register'             : 'register client_id,email,username,password,fb,uid,register_id,terminal,os',
        'post mapping'              : 'mapping client_id,email,password,fb,register_id',
        'post send'                 : 'send client_id,find_key,email',
        
        'delete user/external/sns'  : 'user/external/sns/{{site_id}}?client_id={{client_id}}&token={{token}}',
        
        'get suggestions/people/samezone'      : 'suggestions/people/samezone?timezone={{timezone}}',
        'get suggestions/people/hot'           : 'suggestions/people/hot',
        'get suggestions/people/profileChanged': 'suggestions/people/profileChanged',
        'get suggestions/people/similar'       : 'suggestions/people/similar',
        'get suggestions/people/first'         : 'suggestions/people/first?timezone={{timezone}}'
    };

    /*
        Function: parseQueryString

        주소에 붙는 쿼리 문자열을 파싱하여 저장해 둔다.
    */
    function parseQueryString() {
        var query  = location.search.substr(1),
            regex  = /([^&=]+)=?([^&]*)/g,
            result = {},
            matches;

        while (matches = regex.exec(query)) {
            result[matches[1]] = decodeURIComponent(matches[2]);
        }

        return result;
    }

    params = parseQueryString();
    
    /** 
     * 원본 객체에서 지정된 키의 값들을 URIComponent 인코딩 처리 후 반환
     * @function getURIComponentEncodedObject
     * @author Il, Kim (blaxtar@kthcorp.com)
     * @version 2012-09-14
     * @param {object} object 원본 객체
     * @param {array|string} [keys] 인코딩 처리할 값들의 키 목록 또는 키, 생략시 원본 객체 전체의 값을 처리
     * @return {object} 인코딩 처리 된 값들이 저장된 새로운 객체
     */ 
	function getURIComponentEncodedObject(object, keys) {
		var uriEncodedParams = {}, 
			prop;
			
		if ((typeof keys === 'string')) {
			if (object[keys]) {
				keys = new Array(keys);	
			} else {
				return {};
			}
		}
		
		keys = keys || object;
		for (prop in keys) {
			prop = $.isArray(keys) ? keys[prop] : prop;
			if (object[prop]) {
        		uriEncodedParams[prop] = encodeURIComponent(object[prop]).replace(/'/g,"%27");
        	}
		}
    	return uriEncodedParams;
	}
	
	/* 
	 * API URL에 타임스탬프를 붙여 POST 요청 응답의 캐싱을 방지
	 * iOS 6에서 동일한 URL 및 폼 데이터를 이용해 POST 요청을 하는 경우 응답을 캐시하는 문제로 인한 로그인 에러
	 * (http://stackoverflow.com/questions/12506897/is-safari-on-ios-6-caching-ajax-results)
	 */
	function getTimeStampObject(url) {
		var data;
		if (url.indexOf('timeStamp')) {
			data = {};
			data.timeStamp = new Date().getTime();
		}
		return data;
	}
	
    /*
        Function: urlFor

        Parameters:

            key  - 서버 API
            data - 서버 API 템플릿을 만들기 위한 파라미터
    */
    function urlFor(key, data) {
    	// params를 덮어쓰면 곤란한 경우가 있어 빈 개체에 추가한다.
        return Mustache.to_html(key, $.extend({}, params, data, 
			/* params 중 검색어(search)는 encodeURIComponent 처리 
			 * http://its.kthcorp.com/browse/PUDDINGTO-1468
			 * by Il, Kim (blaxtar@kthcorp.com) 2012-09-14
			 */ 
			getURIComponentEncodedObject(params, ['search', 'query']),
			/* API URL에 타임스탬프를 붙여 POST 요청 응답의 캐싱을 방지
			 * http://its.kthcorp.com/browse/PUDDINGTO-1521
			 * by Il, Kim (blaxtar@kthcorp.com) 2012-09-24
			 */
			getTimeStampObject(key)
        ));
    }

    /*
        Class: API
        
        Usage:
            var api = new API();
            api.call();
            
            or
            
            API.call();
    */
    function API(route, options) {
        $.extend(this, API.setOptions(route, options));
        $.extend(this, API.setData(route, this.data));
        
        API.apis.push(this);
    }

    API.prototype.call = function(options) {
        API.call(this, options);
    };

    API.apis = [];

    API.setOptions = function(route, options) {
        var parts  = route.split(/\s+/),
            method = parts[0],
            data;

        if (!options) {
            options = {};
        }

        if (!options.data) {
            options.data = {};
        }

        options.route  = route;
        options.method = method;
        
        return options;
    };
    
    API.setData = function(route, oldData, newData) {
        var parts    = routes[route].split(/\s+/),
            formData = {};
        
        if (!newData) {
            newData = {};
        }
        
        if (parts[1]) {
            parts[1].split(',').forEach(function(key) {
                var value = newData[key] || oldData[key] || params[key];
                
                // client_id 값은 기본으로 넣는다.
                if (key == 'client_id' || value) {
                    formData[key] = value;
                }
            });
        }
        
        if (params.token) {
            oldData.token = formData.token = params.token;
        }

        return {
            url     : server + urlFor(parts[0], oldData),
            formData: formData
        };
    };
    
    API.call = function(route, options) {
        var context = {},
            success,
            rawSuccess,
            error,
            complete,
            ajaxOptions;
        
        if (route instanceof API) {
            context = route;

            $.extend(context, options);
        } else {
            if (!options) {
                options = {};
            }
            $.extend(context, API.setOptions(route, options));
            $.extend(context, API.setData(route, options.data));
        }
        
        console.log(context, context.url, context.formData);
        
        ajaxOptions = {
            type    : context.method,
            url     : context.url,
            data    : context.formData,
            dataType: 'json',
            global  : !(context.global === false)
        };
        
        // AJAX 호출 후 200 응답일 경우 콜백 함수 처리
        if (context.success) {
            // meta 처리가 필요없을 경우
            ajaxOptions.success = function(json) {
                var code     = json.meta.code,
                    message  = json.meta.error_message,
                    response = json.response;
                
                if (code == 200) {
                    context.success.call(context, response);
                } else {
                    alert(message);
                    if ($.isFunction(context.error)) {
                    	context.error.call(context, message);	
                    }
                }
            };
        } else if (context.rawSuccess) {
            // meta 처리를 직접 할 경우
            ajaxOptions.success = context.rawSuccess.bind(context);
        }

        error    = context.error;
        complete = context.complete;

        // AJAX 호출 실패
        if (error) {
            ajaxOptions.error = error.bind(context);
        }
        
        // AJAX 호출 완료
        if (complete) {
            ajaxOptions.complete = complete.bind(context);
        }
        
        $.ajax(ajaxOptions);
    };
    
    API.showLoader = function() {
        // 안드로이드는 App에서 로더를 표시한다.
        if ($.os.android) {
            window.puddingto.openLoadingDialog();
        } else {
            var loader = $('#p2-global-loader');
        
            if (!loader.length) {
                loader = $('<div class="scLod" id="p2-global-loader"><span class="lod">' + PuddingTo.i18n.LOADING + '</span></div>');
                loader.appendTo('body');
            }
            
            loader.show();
        }
    };
    
    API.hideLoader = function() {
        // 안드로이드는 App에서 로더를 감춘다.
        if ($.os.android) {
            window.puddingto.closeLoadingDialog();
        } else {
            $('#p2-global-loader').remove();
        }
    };
    
    // global = true 옵션일 경우 AJAX 시작 후 종료까지 로더를 표시한다.
    $(document)
        .on('ajaxStart', API.showLoader)
        .on('ajaxStop', 
                function() {
                    API.hideLoader();
                    //새소식 페이지처럼 로더가 아닌 기본 화면을 보여줄 경우
                   $('body').removeClass('bg3');
                }
        );
    
    links = {
        // 차단하기
        ban: function(element) {
            if (!confirm(PuddingTo.i18n.CONFIRM_BAN_USER)) {
                return;
            }

            API.call('post user/ban', {
                data: {
                    target_id: element.closestData('user-id')
                },
                global: false,
                success: function(data) {
                    var list      = element.closest('[data-user-id]'),
                        container = list.closest('[data-list]');
                        
                    list.fadeOut(function() {
                        if (!$('[data-user-id]', container).length) {
                            container.addClass('p2-none');
                        }
                    });
                }
            });
        },
        
        // 이메일 찾기 상세 페이지로 연결
        'email-detail': function(element) {
            var url = urlFor(consts.PATH_FORGOT_EMAIL_DETAIL, {
                id: encodeURIComponent(element.closestData('user-id'))
            });
            console.log(url);
            location.href = url;
        },
        
        // 친구 찾기 페이지로 연결
        'find-friends': function(element) {
            var html,
                url;
                
            html = urlFor(consts.PATH_FIND_FRIENDS);
            
            url = urlFor(consts.CALL_REQUEST, {url: encodeURIComponent(html)});

            console.log(url);
            location.href = url;
        },
        
        // 팔로우 / 언팔로우
        follow: function(element) {
            var parent    = element.parent(),
                following = element.hasClass('ing');

            element.hide();
            parent.addClass('lod');
            
            if (!following) {
                // Kiss Matrics Logging
                if (kth.puddingto.KissMatricsLogger) {
                    kth.puddingto.KissMatricsLogger().log(element.closestData('kms-message'));
                }
            }
            
            API.call(following ? 'post user/unfollow' : 'post user/follow', {
                data: {
                    target_id: element.closestData('user-id')
                },
                global: false,
                success: function(response) {
                    var container = element.closest('[data-list]'),
                    	status,
                        gaCategory,
                        gaAction,
                        gaLabel;
                    
                    if (following) {
                        element.removeClass('ing')
                               .addClass('add')
                               .find('span')
                               .text(PuddingTo.i18n.FOLLOW);
                       gaAction = 'follow';
                    } else {
                        status = response && response.follow && response.follow.status;
                        if (status === 'followRequested') {
                            element.find('span')
                                .addClass('req')
                                .html(PuddingTo.i18n.FOLLOW_REQUESTED)
                                .unwrap();
                        } else {
                            element.removeClass('add')
                               .addClass('ing')
                               .find('span')
                               .html(PuddingTo.i18n.FOLLOWING);
						    gaAction = 'unfollow';	
                        }
                    }
                    
                    // GA
                    gaCategory = element.closestData('ga-category');
                    gaLabel = element.closestData('ga-label');

                    console.log(gaCategory, gaLabel);
                    global._gaq.push(['_trackEvent', gaCategory, gaAction, gaLabel]);
                    
                    // 모두 팔로우 했는지 여부를 알아본다.
                    if (!container.find('.add').length && container.find('.p2-all-followed-text').length) {
                        container.find('ul').empty();
                        container.addClass('p2-all-followed');
                    }
                },
                complete: function() {
                    parent.removeClass('lod');
                    element.show();
                }
            });
        },
        
        // 초대하기
        invite: function(element){
            var parent = element.parent();

            if (element.hasClass('inv')) {
                element.hide();
                parent.addClass('lod');

                API.call('post user/connected', {
                    data: {
                        site_id  : element.data('site'),
                        target_id: element.closestData('user-id')
                    },
                    success: function(data) {
                        element.removeClass('inv')
                               .addClass('invd')
                               .html(PuddingTo.i18n.INVITED);
                        
                       // GA 통계 코드
                       if (params.site_id == 'FB') {
                           _gaq.push(['_trackEvent', 'find_result', 'invite', 'friend_fb']);
                       } else if (params.site_id == 'TW') {
                           _gaq.push(['_trackEvent', 'find_result', 'invite', 'friend_twt']);
                       }
                    },
                    complete: function() {
                        parent.removeClass('lod');
                        element.show();
                    }
                });
            }
        },
        
        // 함께 아는 친구
        'mutual-friends': function(element) {
            var html,
                url;
                
            html = urlFor(consts.PATH_MUTUAL_FRIEND, {
                target_id: element.closestData('user-id')
            });
            
            url = urlFor(consts.CALL_REQUEST, {url: encodeURIComponent(html)});
            
            console.log(url);
            location.href = url;
        },
        
        // 현재 위치
        location: function(element) {
            var url = urlFor(consts.CALL_POI, getURIComponentEncodedObject({
                location_id  : element.closestData('location-id'),
                location_name: element.closestData('location-name'),
                location_latitude: element.closestData('location-latitude'),
                location_longitude: element.closestData('location-longitude')
            }));
            console.log(url);
            location.href = url;
        },
        
        // 위치 선택
        'location-select': function(element) {
            var url = urlFor(consts.CALL_POI_SELECT, getURIComponentEncodedObject({
                location_id  : element.closestData('location-id'),
                location_name: element.closestData('location-name'),
                location_latitude: element.closestData('location-latitude'),
                location_longitude: element.closestData('location-longitude')
            }));
            console.log(url);
            location.href = url;
        },
        
        // 사진 보기
        photo: function(element) {
            var url = urlFor(consts.CALL_PHOTO, {
                target_id: encodeURIComponent(element.closestData('photo-id'))
            });
            console.log(url);
            location.href = url;
        },
        
        // 프로필 보기
        profile: function(element) {
            var url = urlFor(consts.CALL_PROFILE, {
                target_id: encodeURIComponent(element.closestData('user-id'))
            });
            console.log(url);
            location.href = url;
        },
        
        // 차단 해제
        unblock: function(element) {
            API.call('post user/unblock', {
                data: {
                    target_id: element.closestData('user-id')
                },
                success: function(data) {
                    var list      = element.closest('[data-user-id]'),
                        container = list.closest('[data-list]');
                        
                    list.fadeOut(function() {
                        if (!$('[data-user-id]', container).length) {
                            container.addClass('p2-none');
                        }
                    });
                }
            });
            element.addClass('disabled');
        }
    };
    
    // data-i18n 속성이 있는 엘리먼트에 다국어 처리를 한다.
    function initI18n() {
        $('[data-i18n]').each(function() {
            var tagName = this.tagName.toLowerCase(),
                key     = this.getAttribute('data-i18n').toUpperCase().replace(/-/g, '_'),
                value   = PuddingTo.i18n[key];

            if (!value) return;

            if (tagName == 'input') {
                this.placeholder = value;
            } else {
                this.innerHTML = value;
            }
        });
    }
    
    // data-link 속성이 있는 엘리먼트에 이벤트를 연결한다.
    function initLinks() {
        $('[data-link]').live('click', function(event) {
            event.preventDefault();
        
            var $this = $(this),
                link  = $this.data('link');
        
            if ($this.hasClass('p2-loading') || !link || !links[link] || $this.hasClass('disabled')) {
                return;
            }
        
            links[link]($this);
        });
    }
    
    function initMisc() {
        // data-prevent-scroll 속성이 있는 입력 필드에 촛점이 맞춰졌을 때 화면이 올라가는 것을 막는다.
        $('[data-prevent-scroll]').focus(function() {
            scrollTo(0, 0);
        });
    }
    
    // Google Analytics 초기화
    function initGA() {
        /** @deprecated 2012-08-09 
         *  GA 코드를 더이상 하용하지 않음
        // GA 는 cookie를 구워야 하므로, 로컬 파일 환경에서 동작하지 않음.
        global._gaq = {
            push : function () {
                var args = arguments[0];
                console.log('google analytics {{ ');
                console.log(args);
                //alert(args[0] + ' ' + args[1]);
                console.log('}} google analytics');
                if($.os.android) {  //안드로이드
                    switch(args[0]) {
                        case '_trackPageview' :
                            args[1] = '/puddingto_android' + args[1];  //안드로이드는 주소 앞에 /puddingto_android 추가됨
                            global.puddingtoGA.sendGoogleLogMSG.apply(global.puddingtoGA, [].slice.call(args,1));  //pageview
                            break;
                        case '_trackEvent' :
                            global.puddingtoGA.sendGoogleLogEvent.apply(global.puddingtoGA, [].slice.call(args,1)) //event
                            break;
                    }
                } else {	//아이폰
                    (function ($iframe, args) {
                        var api;
                        
                        $iframe.addClass('api');
                        $iframe.hide();
                        
                        $(window).on('pagehide', function () {  //페이지 벗어났을 시 제거 
                            $('iframe.api').remove();
                        });
                        
                        $iframe.on('load', function() {
                            console.log('iframe_sent :'+ this.src);
                        });
                        
                        $('body').append($iframe);
                        // console.log('GA iframe inited');
                        switch(args[0]) {
                            case '_trackPageview' :
                                api = 'puddingsns://GA_trackPageview/pudto-iphone'+args[1];
                                break;
                            case '_trackEvent' :
                                api =  'puddingsns://GA_trackEvent/'+[].slice.call(args,1).join('/');
                                break;
                        }
                        
                        try {
                            $iframe.attr('src', api);
                        } catch (e) {
                        }
                        console.log(api);
                    }($('<iframe></iframe>'), args))
                }
            },
            length : 0
        };
        */
        // GA를 더이상 사용하지 않으므로 관련된 코드에서의 에러를 막기 위해 재정의
        global._gaq = {
            push: function(){},
            length : 0	
        }
    }
    
    // _gaq가 먼저 선언되어 있어야 하므로 init 전에 실행한다.
    initGA();

    function init() {
        initI18n();
        initLinks();
        initMisc();
    }
    
    // 초기화 함수 실행
    $(init);
    
    // PuddingTo 네임스페이스 노출
    global.PuddingTo = {
        API       : API,
        consts    : consts,
        params    : params,
        urlFor    : urlFor,
        formatTime: formatTime
    };
}(this));