(function(global, _dev_locale) {
	var LOCALE = {
			ENGLISH: 'en',
			KOREAN: 'ko',
			JAPANESE: 'ja'
		},
		
		STYLESHEET = {
			LINK: '<link rel="stylesheet" type="text/css" href="{{href}}">',
			HREF: ['ja']
		},
		
		MESSAGES = {
			'en' : {
				AGREE_TERMS: 'Agree',
				ALL: 'All',
				FACEBOOK_VERIFIED: 'Facebook account successfully verified!',
				BACK_TO_TOP: 'Back to Top',
				BAN: 'Ignore',
				BLOCK: 'Block',
				CONFIRM_BAN_USER: 'Don\'t you want to get a recommendation about this user again?',
				CONNECT: 'Connect',
				DISCONNECT_FB: 'Disconnect Pudding.to from Facebook account?',
				DISCONNECT_TW: 'Disconnect Pudding.to from Twitter account?',
				DONE: 'Done',
				EMAIL: 'E-mail',
				EMAIL_CONFIRM: '{{email}}\nWould you like to sign up with this email address?',
				EMAIL_DUPLICATED: 'The E-mail already exists.',
				EMAIL_INVALID: 'Invalid email. Please try again.',
				EMAIL_REQUIRED: 'Please enter your email.',
				EMOTIONS: ['Happy', 'Joyful', 'lonely', 'Stormy heart', 'Hearts-a-flutter', 'Everyday', 'Dot Dot Dot', 'Awesome!', 'OMG', 'Yummy', 'Traveling', 'Partying', 'Self-Shot', 'Pet Lover', 'Photo by'],
				ENTER_EMAIL: 'Enter the Email account you used when registering.',
				ENTER_NICKNAME: 'Please enter your username or real name.',
				FILL_EMAIL: 'Your E-mail address',
				FILL_FIELDS: 'You must fill in all the blanks.',
				FILL_PASSWORD: 'Your Password',
				FILL_USERNAME: '2-15 characters, numbers',
				FIND_FRIENDS: 'Find friends from facebook and twitter to share the fun.',
				FIND_FRIENDS_BUTTON: 'Find Friends',
				FOLLOW: 'Follow',
				FOLLOWER_SKYROCKETING: 'Suggested popular photomate',
				FOLLOWING: 'Following',
				FORGOT_EMAIL: 'Forgot E-mail',
				FORGOT_PASSWORD: 'Forgot Password',
				FRIENDS_IN_PUDDING: 'Friends using Pudding.to',
				FRIENDS_MAYKNOW_TITLE: 'Find your friends',
				HELP_ABOUT: 'Help',
				HELP_APPS: 'Other Apps from pudding',
				HELP_PUDDING_CAMERA: 'Pudding Camera',
				HELP_PUDDING_FACE: 'Korean Celeb Face Match',
				HELP_BLOG: 'Pudding.to blog',
				HELP_TERMS: 'Terms of Service',
				HELP_PRIVACY: 'Privacy Policy',
				INVITE: 'Invite',
				INVITE_FRIENDS: 'Invite other friends',
				INVITED: 'Invited',
				LINK_MUTUAL_FRIENDS: '<a href="/" data-link="mutual-friends"><em>{{count}}</em> Mutual friends</a>',
				LOADING: 'Loading',
				LOADING_FRIENDS: 'Loading your friends list…',
				LOGIN: 'Log in',
				LOGIN_WITH_FACEBOOK: 'Log in with facebook',
				MAYKNOW_ALL_FOLLOWED: 'Awesome! You\'ve followed all your may know friends.<br>By getting more friends, you can find more photomates.',
				MUTUAL_FRIEND_HEADER: 'You have <em>{{count}}</em> mutual friends with {{name}}.',
				NICKNAME_OR_NAME: 'Username or Real Name',
				NONE_BLOCKS: 'There are no blocked users.',
				NONE_FEED_MY: 'New comments and likes for your photo will appear here.',
				NONE_FEED_FOLLOWER: 'The people you follow<br>haven\'t updated anything recently.',
				NONE_FOLLOWS: 'You have no followers.',
				NONE_FOLLOWINGS: 'You have no followings.',
				NONE_FRIENDS: 'Your friends aren\'t yet on Pudding.to.<br>Invite them.',
				NONE_FRIENDS_TO_INVITE: 'No friends to invite.',
				NONE_LOCATIONS_MINE: 'No Location tag.<br>Add Location you are when you<br>upload a photo.',
				NONE_LOCATIONS_OTHERS: 'No Location tag.',
				NONE_MAYKNOW_1: 'Find more friends by connecting to<br>Facebook and Twitter.<br>Make new photomates with Pudding.to!',
				NONE_MAYKNOW_2: 'Not finding anyone you know?<br>Find more friends by connecting to<br>Facebook and Twitter.<br>Make new photomates with Pudding.to!',
				NONE_MUSICS_MINE: 'No Music tag.<br>Add music you like when you<br>upload a photo.',
				NONE_MUSICS_OTHERS: 'No Music tag.',
				NONE_POPULAR_PHOTOS: 'No popular photos yet.',
				NONE_SUGGESTED_FRIENDS: '<p class="cn1">You have no suggested friends.</p><p class="cn2">Suggested friends are updated everyday.</p>',
				NONE_TAGS_MINE: 'Add #tag when you upload a photo<br>to find your photo mate.<br>E.g. #cat, #paris',
				NONE_TAGS_OTHERS: 'No # tag.',
				NONE_USER: '\'{{name}}\' does not exist!',
				PASSWORD: 'Password',
				PASSWORD_INVALID: 'Please check your password. (more 6 characters)',
				PASSWORD_REQUIRED: 'Please enter your password. (more 6 characters)',
				PHOTO_UNIT: '{{count}} photo',
				PHOTOS_UNIT: '{{count}} photos',
				POPULAR_PHOTO: 'Awesome! Selected as Popular Photo!',
				PRIVACY_POLICY: 'Privacy Policy',
				REPORT: 'Report',
				REPORT_SUCCEEDED: 'We\'ve recived a report. We will check up as soon as possible.',
				SEARCH_FRIENDS: 'Find Friends',
				SEARCH_FRIENDS_DIRECTLY: 'Search (Username or Full name)',
				SEARCH_RESULT: '',
				SEE_MORE: 'See more',
				SENT_FORGOT_PASSWORD: '\'Reset Password\' link has been sent to {{email}}',
				SERVER_ERROR: 'We are unable to load information, please try again later.',
				SHOW_TERMS: '<a href="/">Terms of Service / Privacy Policy</a>',
				SIGNUP: 'Sign up',
				SIGNUP_WITH_FACEBOOK: 'Sign up with facebook',
				SIGNUP_WITH_ANOTHER_EMAIL: 'Try another E-mail account',
				SNS_DESC: 'If you connect your account to twitter or facebook, you can export your photos to your twitter and facebook account from Pudding.to.',
				SUGGESTED_FRIENDS: 'Suggested users based on tag, music, and more.',
				TERM_REQUIRED: 'Term agreement required',
				TERMS_OF_SERVICE: 'Terms of Service',
				TIME_JUST_NOW: 'Just Now',
				TIME_SECOND_AGO: ' second ago',
				TIME_SECONDS_AGO: ' seconds ago',
				TIME_MINUTE_AGO: ' minute ago',
				TIME_MINUTES_AGO: ' minutes ago',
				TIME_HOUR_AGO: ' hour ago',
				TIME_HOURS_AGO: ' hours ago',
				TIME_DAY_AGO: ' day ago',
				TIME_DAYS_AGO: ' days ago',
				TIME_WEEK_AGO: ' week ago',
				TIME_WEEKS_AGO: ' weeks ago',
				TIME_MONTH_AGO: ' month ago',
				TIME_MONTHS_AGO: ' months ago',
				TIME_YEAR: 'year',
				TIME_YEARS: 'years',
				UNBLOCK: 'Unblock',
				USERNAME: 'Username',
				USERNAME_DUPLICATED: 'The username already exists.',
				USERNAME_INVALID: 'Please check your user name.',
				USERNAME_REQUIRED: 'Please enter your username. (2-15 characters, numbers,_)',
				WELCOME: 'Welcome {{nickname}} !<br>Find friends and enjoy Pudding.to together!',
				WRITE_COMMENT: 'Write comment',
				YOU: 'You!'
			},
			'ko': {
				AGREE_TERMS: '약관동의',
				ALL: '전체',
				FACEBOOK_VERIFIED: '페이스북 인증에 성공 하셨습니다.',
				BACK_TO_TOP: '맨 위로',
				BAN: '추천무시',
				BLOCK: '차단',
				CONFIRM_BAN_USER: '이 이용자를 다시는 추천받지 않으시겠습니까?',
				CONNECT: '연결',
				DISCONNECT_FB: '페이스북 계정 연동을 해제하시겠습니까?',
				DISCONNECT_TW: '트위터 계정 연동을 해제하시겠습니까?',
				DONE: '완료',
				EMAIL: '이메일',
				EMAIL_CONFIRM: '{{email}}\n위 이메일로 가입하시겠습니까?',
				EMAIL_DUPLICATED: '이미 사용중인 이메일 입니다.',
				EMAIL_INVALID: '이메일을 정확하게 입력해 주세요.',
				EMAIL_REQUIRED: '이메일을 입력해 주세요.',
				EMOTIONS: ['기분좋은', '신나는', '외로운', '눈물나는', '두근두근', '일상의', '생각에 잠긴', 'oh~!', '대~박!', '냠냠', '여행중', '특별한 날', '셀카', 'Pet Lover', 'Photo by'],
				ENTER_EMAIL: '가입시 입력한 이메일을 입력해 주세요.',
				ENTER_NICKNAME: '가입한 닉네임이나 이름을 입력해 주세요.',
				FILL_EMAIL: 'abc@abc.com',
				FILL_FIELDS: '입력되지 않은 정보가 있습니다.',
				FILL_PASSWORD: '6자 이상 입력',
				FILL_USERNAME: '2~15자의 영문,숫자',
				FIND_FRIENDS: '친구를 찾아보세요!',
				FIND_FRIENDS_BUTTON: '친구찾기',
				FOLLOW: '팔로우',
				FOLLOWER_SKYROCKETING: '팔로워가 급상승한 친구!',
				FOLLOWING: '팔로잉',
				FORGOT_EMAIL: '이메일 찾기',
				FORGOT_PASSWORD: '비밀번호 찾기',
				FRIENDS_IN_PUDDING: '푸딩.투를 이용중인 친구',
				FRIENDS_MAYKNOW_TITLE: '친구를 찾아보세요',
				HELP_ABOUT: '도움말/고객센터',
				HELP_APPS: '푸딩의 다른 앱 보기',
				HELP_PUDDING_CAMERA: '푸딩카메라',
				HELP_PUDDING_FACE: '푸딩 얼굴인식',
				HELP_BLOG: '푸딩.투 블로그',
				HELP_TERMS: '서비스 약관',
				HELP_PRIVACY: '개인정보 보호정책',
				INVITE: '초대',
				INVITE_FRIENDS: '다른 친구 초대하기',
				INVITED: '초대완료',
				LINK_MUTUAL_FRIENDS: '<a href="/" data-link="mutual-friends">함께 아는 친구 <em>{{count}}</em>명</a>',
				LOADING: '로드중',
				LOADING_FRIENDS: '친구를 불러오고 있습니다.',
				LOGIN: '로그인',
				LOGIN_WITH_FACEBOOK: '페이스북으로 로그인하기',
				MAYKNOW_ALL_FOLLOWED: '알만한 친구를 모두 팔로잉했어요.<br><br><strong>추천 친구</strong>에서 나와 어울릴만한<br>친구들을 만나보세요!',
				MUTUAL_FRIEND_HEADER: '{{name}} 님과 함께 아는 친구 {{count}}명',
				NICKNAME_OR_NAME: '닉네임,이름',
				NONE_BLOCKS: '차단된 이용자가 없습니다.',
				NONE_FEED_MY: '새 소식이 없습니다.<br>내 사진의 좋아요와 댓글 업데이트 소식을<br>알려드려요.',
				NONE_FEED_FOLLOWER: '내 팔로잉의 소식이 없습니다.<br>내 팔로잉에게 생긴 새로운 소식을<br>알려드려요.',
				NONE_FOLLOWS: '팔로워 친구가 한 명도 없네요.',
				NONE_FOLLOWINGS: '팔로잉 친구가 한 명도 없네요.',
				NONE_FRIENDS: '친구가 없습니다.',
				NONE_FRIENDS_TO_INVITE: '초대할 친구가 없습니다.',
				NONE_LOCATIONS_MINE: '장소태그가 없습니다.<br>사진을 올릴 때, 장소를 넣어 보세요.',
				NONE_LOCATIONS_OTHERS: '장소태그가 없습니다.',
				NONE_MAYKNOW_1: '페이스북, 트위터 연결을 하거나<br>푸딩.투에서 친구들을 팔로우하면<br>알만한 친구를 더 많이 만날 수 있어요.',
				NONE_MAYKNOW_2: '알만한 친구가 없다고 실망하지 마세요.<br><br>페이스북, 트위터 연결을 하거나<br>푸딩투 팔로우를 많이 할 수록<br>반가운 친구를 매일 찾아드립니다.',
				NONE_MUSICS_MINE: '음악태그가 없습니다.<br>사진을 올릴 때, 음악을 넣어 보세요.',
				NONE_MUSICS_OTHERS: '음악태그가 없습니다.',
				NONE_POPULAR_PHOTOS: '인기사진이 없습니다.',
				NONE_SUGGESTED_FRIENDS: '<p class="cn1">추천친구가 없습니다.</p><p class="cn2">내일은 더 멋진 회원들과<br> 당신의 감성과 사진을 공유할 수 있습니다.<br><br>추천 친구는 매일 업데이트 됩니다.</p>',
				NONE_TAGS_MINE: '#태그가 없습니다.<br>사진을 올릴 때, #태그를 입력해 보세요.',
				NONE_TAGS_OTHERS: '#태그가 없습니다.',
				NONE_USER: '‘{{name}}’ 닉네임이나 이름을<br>가진 사람이 없습니다.',
				PASSWORD: '비밀번호',
				PASSWORD_INVALID: '비밀번호를 6자이상 입력해주세요.',
				PASSWORD_REQUIRED: '비밀번호를 입력해주세요. (6자 이상)',
				PHOTO_UNIT: '{{count}} 장',
				PHOTOS_UNIT: '{{count}} 장',
				POPULAR_PHOTO: '인기사진에 뽑혔어요~!',
				PRIVACY_POLICY: '개인정보 보호정책',
				REPORT: '신고하기',
				REPORT_SUCCEEDED: '신고가 접수되었습니다. 빠른시일내에 검토하여 처리하도록 하겠습니다.',
				SEARCH_FRIENDS: '친구 찾기',
				SEARCH_FRIENDS_DIRECTLY: '직접찾기 (닉네임, 이름)',
				SEARCH_RESULT: '검색 결과',
				SEE_MORE: '더보기',
				SENT_FORGOT_PASSWORD: '{{email}}로 비밀번호를 재설정할 수 있는 링크를 보내드렸습니다.',
				SERVER_ERROR: '정보를 불러올 수 없습니다. 잠시 후 다시 시도해 주세요.',
				SHOW_TERMS: '<a href="/">약관/개인 정보취급방침</a> 동의',
				SIGNUP: '가입하기',
				SIGNUP_WITH_FACEBOOK: '페이스북으로 푸딩가입',
				SIGNUP_WITH_ANOTHER_EMAIL: '다른 이메일로 가입하기',
				SUGGESTED_FRIENDS: '태그,음악,장소가 같거나 인기 많은 친구',
				SNS_DESC: '연동을 설정하면 푸딩.투에 올린 사진이 트위터, 페이스북에도 함께 보여집니다.',
				TERM_REQUIRED: '약관/개인 정보취급방침\n동의에 체크해주세요.',
				TERMS_OF_SERVICE: '서비스 약관',
				TIME_JUST_NOW: '방금 전',
				TIME_SECOND_AGO: '초 전',
				TIME_SECONDS_AGO: '초 전',
				TIME_MINUTE_AGO: '분 전',
				TIME_MINUTES_AGO: '분 전',
				TIME_HOUR_AGO: '시간 전',
				TIME_HOURS_AGO: '시간 전',
				TIME_DAY_AGO: '일 전',
				TIME_DAYS_AGO: '일 전',
				TIME_WEEK_AGO: '주 전',
				TIME_WEEKS_AGO: '주 전',
				TIME_MONTH_AGO: '개월 전',
				TIME_MONTHS_AGO: '개월 전',
				TIME_YEAR: '년',
				TIME_YEARS: '년',
				UNBLOCK: '차단 해제',
				USERNAME: '닉네임',
				USERNAME_DUPLICATED: '이미 사용중인 닉네임 입니다. (2~15자 이내의 영문,숫자,_)',
				USERNAME_INVALID: '닉네임은 15자 이내의 영문,숫자,_로 입력해 주세요.',
				USERNAME_REQUIRED: '닉네임을 입력해 주세요. (2~15자 이내의 영문,숫자,_)',
				WELCOME: '{{nickname}}님, 환영합니다!<br>푸딩.투를 함께 즐길 친구들을 찾아보세요!',
				WRITE_COMMENT: '댓글 작성',
				YOU: 'You!'
			},
			'ja': {
				AGREE_TERMS: '利用規約に同意',
				ALL: '全て',
				FACEBOOK_VERIFIED: 'Facebook認證に成功しました。',
				BACK_TO_TOP: 'TOPへ',
				BAN: 'おすすめキャンセル',
				BLOCK: 'ブロック',
				CONFIRM_BAN_USER: 'のユーザのおすすめ表示をやめますか？',
				CONNECT: '連結',
				DISCONNECT_FB: 'Facebookアカウントの連結を解除しますか？',
				DISCONNECT_TW: 'Twitterアカウントの連結を解除しますか？',
				DONE: '完了',
				EMAIL: 'Eメール',
				EMAIL_CONFIRM: '{{email}}\nこのEメールでよろしいですか?',
				EMAIL_DUPLICATED: 'すでに使用中のEメールです。',
				EMAIL_INVALID: '正確なEメールアドレスを入力してください。',
				EMAIL_REQUIRED: 'Eメールアドレスを入力してください。',
				EMOTIONS: ['ハッピー', 'ウキウキ', 'さびしい', 'シクシク', 'トキメキ', '日常の', '考え中', 'oh~!', 'サイコー!!', 'ペコペコ', '旅の思い出', '特別な日', '自分撮り', 'Pet Lover', 'Photo by'],
				ENTER_EMAIL: '会員登録時のEメール情報を入力してください。',
				ENTER_NICKNAME: '会員登録時のニックネームや名前を入力してください。',
				FILL_EMAIL: 'abc@abc.com',
				FILL_FIELDS: '入力された情報がありません。',
				FILL_PASSWORD: '6文字以上入力',
				FILL_USERNAME: '2~15文字の英・数字',
				FIND_FRIENDS: '友達を探して見ましょう。',
				FIND_FRIENDS_BUTTON: '友達を探す',
				FOLLOW: 'フォロー',
				FOLLOWER_SKYROCKETING: 'フォローが急上昇中のユーザ!',
				FOLLOWING: 'フォロー中',
				FORGOT_EMAIL: 'Eメールを探す',
				FORGOT_PASSWORD: 'パスワードを探す',
				FRIENDS_IN_PUDDING: 'pudding.toを利用中の友たち',
				FRIENDS_MAYKNOW_TITLE: '友たちを探してみましょう。',
				HELP_ABOUT: 'ヘルプデスク',
				HELP_APPS: 'puddingシリーズのアプリを見る',
				HELP_PUDDING_CAMERA: 'pudding camera',
				HELP_PUDDING_FACE: '韓流スターマッチング',
				HELP_BLOG: 'pudding.to ブログ',
				HELP_TERMS: '利用規約',
				HELP_PRIVACY: '個人情報の保護について',
				INVITE: '招待',
				INVITE_FRIENDS: '友達を招待',
				INVITED: '招待完了',
				LINK_MUTUAL_FRIENDS: '<a href="/" data-link="mutual-friends">一緒に知っている友人 <em>{{count}}</em>名</a>',
				LOADING: '読み込み',
				LOADING_FRIENDS: '友たちを読み込み中',
				LOGIN: 'ログイン',
				LOGIN_WITH_FACEBOOK: 'Facebookからログイン',
				MAYKNOW_ALL_FOLLOWED: '知り合いの友達と全員フォローしました。<br><br><strong>おすすめユーザから</strong>新たな友達に出会う機会を<br>見逃さないでください。',
				MUTUAL_FRIEND_HEADER: '{{name}} さんと一緒に知っている友人 {{count}}名',
				NICKNAME_OR_NAME: 'ニックネームや名前',
				NONE_BLOCKS: 'ブロックしたユーザはいません。',
				NONE_FEED_MY: 'ニュースがありません。<br>投稿した写真に関する新たないいね！やコメント情報を<br>表示します。',
				NONE_FEED_FOLLOWER: 'フォロー中のニュースがありません。<br>フォロー中に関する新たなニュースを<br>表示します。',
				NONE_FOLLOWS: '現在フォロワーがいません。',
				NONE_FOLLOWINGS: '現在フォロー中のユーザがいません。',
				NONE_FRIENDS: '友たちがいません。',
				NONE_FRIENDS_TO_INVITE: '招待する友達がいません。',
				NONE_LOCATIONS_MINE: '場所タグがありません。<br>写真登録の時に場所を入れてみましょう',
				NONE_LOCATIONS_OTHERS: '場所タグがありません。',
				NONE_MAYKNOW_1: 'Facebook、Twitterとの連結や<br>pudding.toで友人をフォローすると<br>お互いに知り合いの友たちを出会うことができます。',
				NONE_MAYKNOW_2: '知り合いの友たちがいなくても大丈夫!<br><br>Facebook、Twitterとの連結や<br>pudding.toでフォローを重ねることで<br>毎日新たな友達を出会うチャンスも増えます。',
				NONE_MUSICS_MINE: '音楽タグがありません。<br>写真登録の時に音楽を入れてみましょう。',
				NONE_MUSICS_OTHERS: '音楽タグがありません。',
				NONE_POPULAR_PHOTOS: '人気写真がありません。',
				NONE_SUGGESTED_FRIENDS: '<p class="cn1">今日のおすすめユーザを全員フォローしました。</p><p class="cn2">明日はもっと素敵なユーザと一緒に<br>あなたの気持ちと写真を共有することができます。<br><br>おすすめユーザは毎日アップデートされます。</p>',
				NONE_TAGS_MINE: '#タグがありません。<br>写真登録の時に#タグを入力してみましょう。',
				NONE_TAGS_OTHERS: '#タグがありません。',
				NONE_USER: '‘{{name}}’ ニックネームや名前を持つ<br>ユーザがいません。',
				PASSWORD: 'パスワード',
				PASSWORD_INVALID: 'パスワードを6文字以上に入力してください。',
				PASSWORD_REQUIRED: 'パスワードを入力してください。(6文字以上)',
				PHOTO_UNIT: '{{count}} 枚',
				PHOTOS_UNIT: '{{count}} 枚',
				POPULAR_PHOTO: '人気写真に選定されました！',
				PRIVACY_POLICY: '個人情報の保護',
				REPORT: '申告する',
				REPORT_SUCCEEDED: '申告完了しました。早く検討し処理します。',
				SEARCH_FRIENDS: '友人を探す',
				SEARCH_FRIENDS_DIRECTLY: 'ニックネームと名前から探す',
				SEARCH_RESULT: '検索結果',
				SEE_MORE: 'もっと見る',
				SENT_FORGOT_PASSWORD: '{{email}}でパスワードの再設定に関するリンクを転送しました。',
				SERVER_ERROR: '情報の読み込みに失敗しました。再び試してください。',
				SHOW_TERMS: '<a href="/">利用規約/個人情報取り扱い</a> 同意',
				SIGNUP: '会員登録',
				SIGNUP_WITH_FACEBOOK: 'Facebookから会員登録',
				SIGNUP_WITH_ANOTHER_EMAIL: 'ほかのEメールで会員登録',
				SUGGESTED_FRIENDS: 'タグ、音楽、場所が似通うユーザや人気ユーザ',
				SNS_DESC: '共有設定をするとpudding.toに投稿した写真がTwitter、Facebookにも自動的に投稿ができます。',
				TERM_REQUIRED: '利用規約/個人情報取り扱い\n同意にチェックしてください。',
				TERMS_OF_SERVICE: '利用規約',
				TIME_JUST_NOW: 'すぐ前',
				TIME_SECOND_AGO: '秒前',
				TIME_SECONDS_AGO: '秒前',
				TIME_MINUTE_AGO: '分前',
				TIME_MINUTES_AGO: '分前',
				TIME_HOUR_AGO: '時間前',
				TIME_HOURS_AGO: '時間前',
				TIME_DAY_AGO: '日前',
				TIME_DAYS_AGO: '日前',
				TIME_WEEK_AGO: '週前',
				TIME_WEEKS_AGO: '週前',
				TIME_MONTH_AGO: 'ヶ月前',
				TIME_MONTHS_AGO: 'ヶ月前',
				TIME_YEAR: '年',
				TIME_YEARS: '年',
				UNBLOCK: 'ブロック解除',
				USERNAME: 'ユーザ名 ',
				USERNAME_DUPLICATED: 'すでに利用中のニックネームです。(2~15文字以内の英語、数字、_)',
				USERNAME_INVALID: 'ニックネームは15文字以内の英語、数字、_で入力してください。',
				USERNAME_REQUIRED: 'ニックネームを入力してください。(2~15文字以内の英語、数字、_)',
				WELCOME: '{{nickname}}さん!　pudding.toの世界へようこそ！<br>pudding.toで新たな友人を探してみましょう。',
				WRITE_COMMENT: 'コメント',
				YOU: 'You!'
			}
		};
	
	var locale = (function() {
		var language = navigator.language,
			locale;
			
		if ($.os.android) {
			if (navigator.userAgent.indexOf('ko-kr') > -1) {
				locale = LOCALE.KOREAN;	
			} else if (navigator.userAgent.indexOf('ja-jp') > -1) {
				locale = LOCALE.JAPANESE;
			} else {
				locale = LOCALE.ENGLISH;
			}
		} else {
			locale = {
				'ko': LOCALE.KOREAN,
				'en': LOCALE.ENGLISH,
				'ja': LOCALE.JAPANESE
			}[language.substr(0, 2)] || LOCALE.ENGLISH;
		}
		return _dev_locale || locale;			
	})();
	
	if (STYLESHEET.HREF.indexOf(locale) > -1) { (function() {
		var link = $('link'),
			styleSheetHref = link.attr('href').split('.css')[0] + '_' + locale + '.css';

		$('link').after(Mustache.to_html(STYLESHEET.LINK, {
			href: styleSheetHref
		}));
	})(); }
	
	PuddingTo.locale = locale;
	PuddingTo.i18n   = MESSAGES[locale];
})(window);
