(function(global) {
    PuddingTo.call = {
        // 뒤로
        back: function(event) {
            event.preventDefault();

            $(this).addClass('on');
            history.back();
        },

        // 닫기
        close: function(event) {
            event.preventDefault();

            $(this).addClass('on');
            location.href = 'puddingsns://CLOSE';
            console.log('puddingsns://CLOSE');
        },

        // 로그인
        login: function(event) {
            event.preventDefault();
            
            // 로딩중이면 더 실행하지 않는다.
            if (PuddingTo.waiting) return;

            var $email    = $('[name=email]'),
                $password = $('[name=password]'),
                email     = $email.val().trim(),
                password  = $password.val().trim(),
                options   = $(event.target).closestData('options');
                // element   = $(event.target).closest('[data-options]'),
                // options   = element.attr('data-options');

            // 2010.10.13
            // 실시간 항목 체크를 하지 않는다.

            if (!email.length) {
                alert(PuddingTo.i18n['EMAIL_REQUIRED']);
                return;
            }

            // 이메일은 소문자로 바꾼다.
            // email = email.toLowerCase();
            // $email.val(email);

            if (!email.match(PuddingTo.consts.REGEX_EMAIL)) {
                alert(PuddingTo.i18n['EMAIL_INVALID']);
                return;
            }

            if (!password.length) {
                alert(PuddingTo.i18n['PASSWORD_REQUIRED']);
                return;
            }

            // 비밀번호는 소문자로 바꾼다.
            password = password.toLowerCase();
            $password.val(password);

            var params = {
                email    : email,
                password : password.toLowerCase(),
                client_id: PuddingTo.params.client_id
            };

            if (options == 'mapping') {
                params.register_id = PuddingTo.params.register_id;
                params.fb          = PuddingTo.params.fb;
                params.uid         = PuddingTo.params.uid;
            }

            PuddingTo.waiting = true;
            // 1초 있으면 Pudding.waiting 을 풀어 줌. - 실패한 것으로 간주
            window.setTimeout(function () {
                PuddingTo.waiting = false;
            }, 3000);
            PuddingTo.API.call(options == 'mapping' ? 'post mapping' : 'post authorize', {
                data   : params,
                rawSuccess: function(json) {
                    var code     = json.meta.code,
                        message  = json.meta.error_message,
                        response = json.response;

                    console.log(json.meta);

                    if (code == '200') {
                        location.href = PuddingTo.urlFor(PuddingTo.consts[$.os.android ? 'CALL_LOGIN_OK' : 'URL_LOGIN_OK'], response);
                    } else if (code == '211') {
                        if (confirm(message)) {
                            location.href = PuddingTo.urlFor(PuddingTo.consts.PATH_SIGNUP) + '&email=' + email;
                        }
                    } else if (code == '212') {
                        if (confirm(message)) {
                            if ($.os.android) {
                                global.puddingtoFBLogin.facebookLogin.apply(global.puddingtoFBLogin, []);
                            } else {
                                location.href = PuddingTo.urlFor(PuddingTo.consts.URL_FB_LOGIN);
                            }
                        }
                    } else if (code == '213') {
                        if (confirm(message)) {
                            location.href = PuddingTo.urlFor(PuddingTo.consts.PATH_FORGOT_PASSWORD);
                        }
                    } else {
                        alert(message);
                    }
                }
            });
        }
    };

    $('[data-call]').each(function() {
        var tagName = this.tagName.toLowerCase(),
            action  = this.getAttribute('data-call'),
            handler = PuddingTo.call[action];

        if (!handler) {
            return;
        }
        
        if (action == 'duplicate') {
            this.onblur = handler;
        } else if (tagName == 'a' || tagName == 'button') {
            this.onclick = handler;
        } else if (tagName == 'form') {
            this.onsubmit = handler;
        }
    });
    
    $('[name=email]').val(PuddingTo.params.email);
    $('[name=password]').val(PuddingTo.params.password);
    
    $('[data-link]').on('click', function(event) {
        event.preventDefault();

        var link = $(this).data('link').toUpperCase().replace(/-/g, '_'),
            url  = PuddingTo.urlFor(PuddingTo.consts[link]);

        console.log(url);
        location.href = url;
    });
})(window);
