(function(global) {
    PuddingTo.call = {
        back: BACK, //뒤로
        close: CLOSE, // 닫기
        signup: SIGNUP, // 회원가입
        duplicate: DUPLICATE, // 중복 체크
        validatePassword: VALIDATE_PASSWORD //validate
    };

    $('[data-call]').each(function() {
        var tagName = this.tagName.toLowerCase(),
            action  = this.getAttribute('data-call'),
            handler = PuddingTo.call[action];

        if (!handler) {
            return;
        }

        if (action == 'duplicate' || action === 'validatePassword') {
            this.onblur = handler;
        } else if (tagName == 'a' || tagName == 'button') {
            this.onclick = handler;
        } else if (tagName == 'form') {
            this.onsubmit = handler;
        }
    });
    
    var email = $('[name=email]'),
        terms = $('[name=agreed-terms]');
        
    $('[name=email]').val(PuddingTo.params.email);
    $('[name=username]').val(PuddingTo.params.username);
    $('[name=password]').val(PuddingTo.params.password);
    
    if (terms.length) {
        terms.get(0).checked = PuddingTo.params.agreed_terms == 'true';

        terms.click(function() {
            PuddingTo.params.agreed_terms = this.checked;
        });
    }
    
    // 가입 전에 서버에서 등록 코드를 가져온다.
    if (!PuddingTo.params.register_id) {
        PuddingTo.API.call('get register', {
            success: function(data) {
                PuddingTo.params.register_id = data;
            }
        });
    }

    // 약관동의 클릭 처리
    $('[data-i18n=show-terms]').on('click', 'a', function(event) {
        event.preventDefault();

        // var redirectUrl = encodeURIComponent(location.protocol + '//' + location.pathname);
        var redirectUrl = encodeURIComponent(location.pathname);

        PuddingTo.params.email    = $('[name=email]').val().trim();
        PuddingTo.params.username = $('[name=username]').val().trim();
        PuddingTo.params.password = $('[name=password]').val().trim();

        location.href = 'termsService.html?' + $.param(PuddingTo.params) + '&redirect_url=' + redirectUrl;
    });
    
    function BACK(event) {
        event.preventDefault();

        $(this).addClass('on');
        history.back();
    }

    function CLOSE (event) {
        event.preventDefault();

        $(this).addClass('on');
        location.href = 'puddingsns://CLOSE';
        console.log('puddingsns://CLOSE');
    }

    function SIGNUP (event) {
        event.preventDefault();

        // 로딩중이면 더 실행하지 않는다.
        if (PuddingTo.waiting) return;

        var $email    = $('[name=email]'),
            $username = $('[name=username]'),
            $password = $('[name=password]'),
            $terms    = $('[name=agreed-terms]'),
            email     = ($email.length ? $email.val() : PuddingTo.params.email).trim();
            username  = $username.val().trim(),
            password  = $password.val().trim(),
            element   = $(event.target).closest('[data-options]'),
            options   = element.attr('data-options');

        // 페이스북으로 가입할 경우 이메일이 없을 경우가 있다.
        if ($email && !email.length) {
            alert(PuddingTo.i18n['FILL_FIELDS']);
            $email.focus();
            return;
        }

        // 이메일은 소문자로 바꾼다.
        // email = email.toLowerCase();
        // $email.val(email);

        if (!email.match(PuddingTo.consts.REGEX_EMAIL)) {
            $email.next().get(0).className = 'avb';
            alert(PuddingTo.i18n['EMAIL_INVALID']);
            return;
        }

        if (!username.length) {
            alert(PuddingTo.i18n['FILL_FIELDS']);
            $username.focus();
            return;
        }

        // 닉네임을 소문자로 바꾼다.
        // username = username.replace(/\s/g, '').toLowerCase();
        username = username.replace(/\s/g, '');
        $username.val(username);

        if (username.length < 2 || username.length > 15) {
            $username.next().get(0).className = 'avb';
            alert(PuddingTo.i18n['USERNAME_INVALID']);
            return;
        }

        if (!username.match(PuddingTo.consts.REGEX_USERNAME)) {
            $username.next().get(0).className = 'avb';
            alert(PuddingTo.i18n['USERNAME_INVALID']);
            return;
        }

        if (!password.length) {
            alert(PuddingTo.i18n['FILL_FIELDS']);
            $password.focus();
            return;
        } else if (!VALIDATE_PASSWORD()) {
        	alert(PuddingTo.i18n['PASSWORD_INVALID']);
        	$password.focus();
        	return;
        }
        
        if ($terms && !$terms.is(':checked')) {
            alert(PuddingTo.i18n['TERM_REQUIRED']);
            return;
        }

        if(!confirm(Mustache.to_html(PuddingTo.i18n.EMAIL_CONFIRM, {email: email}))) {
            return;
        }

        var data = {
            email      : email,
            username   : username,
            password   : password,
            client_id  : PuddingTo.params.client_id,
            register_id: PuddingTo.params.register_id,
        };

        if (options == 'fb') {
            data.register_id = PuddingTo.params.register_id;
            data.fb          = PuddingTo.params.fb;
            data.uid         = PuddingTo.params.uid;
        }

        PuddingTo.waiting = true;
        // 3초 있으면 Pudding.waiting 을 풀어 줌. - 실패한 것으로 간주
        window.setTimeout(function () {
            PuddingTo.waiting = false;
        }, 3000);

        PuddingTo.API.call('post register', {
            data   : data,
            success: function(data) {
                _gaq.push(['_trackPageview', '/signup_ok']);
                location.href = PuddingTo.urlFor(PuddingTo.consts[$.os.android ? 'CALL_LOGIN_OK' : 'URL_LOGIN_OK'], data);
            }
        });
    }

    function VALIDATE_PASSWORD (event) {
        var $password = $('[name=password]'),
            password = $password.val().trim();
            aux = $password.next().get(0);

        if (password.length < 6 || password.length > 64) {
            aux.className = 'avb';
            aux.onclick = function() {
                alert(PuddingTo.i18n['PASSWORD_INVALID']);
            };
            return false;
        }

        if (!password.match(PuddingTo.consts.REGEX_PASSWORD)) {
            aux.className = 'avb';
            aux.onclick = function() {
                alert(PuddingTo.i18n['PASSWORD_INVALID']);
            };
            return false;
        }
        aux.className = 'imb';
        aux.onclick = function () {};
        return true;
    }

    function DUPLICATE (event){
        var $this  = $(this),
            key    = $this.attr('name'),
            value  = $this.val().trim(),
            aux    = $this.next().get(0),
            params = {};

        aux.onclick = null;

        if (!value) {
            aux.className = '';
            // alert(PuddingTo.i18n[key.toUpperCase() + '_REQUIRED']);
            return;
        }

        //이전 값 체크로직. 기존과 같으면 다시 체크하지 않는다.
        var beforeValue = $(this).data('before-value') || ''
        if (beforeValue === value) {
            return;
        }
        $(this).data('before-value', value);

        if (key == 'email') {
            // 이메일은 소문자로 바꾼다.
            // value = value.toLowerCase();
            // $this.val(value);

            if (!value.match(PuddingTo.consts.REGEX_EMAIL)) {
                aux.className = 'avb';
                aux.onclick = function() {
                    alert(PuddingTo.i18n['EMAIL_INVALID']);
                };
                return;
            }
        } else if (key == 'username') {
            // 닉네임을 소문자로 바꾼다.
            // value = value.replace(/\s/g, '').toLowerCase();
            value = value.replace(/\s/g, '');
            $this.val(value);

            if (value.length > 15) {
                aux.className = 'avb';
                aux.onclick = function() {
                    alert(PuddingTo.i18n['USERNAME_INVALID']);
                };
                return;
            }

            if (!value.match(PuddingTo.consts.REGEX_USERNAME)) {
                aux.className = 'avb';
                aux.onclick = function() {
                    alert(PuddingTo.i18n['USERNAME_INVALID']);
                };
                return;
            }
        }

        params[key] = value;
        
        PuddingTo.API.call('get user/duplicate', {
            data   : params,
            global : false,
            success: function(data) {
                var className = 'imb';
                
                if (data == 'yes') {
                    className = 'avb';
                    aux.onclick = function() {
                        alert(PuddingTo.i18n[key.toUpperCase() + '_DUPLICATED']);
                    }
                }
                aux.className = className;
            }
        });
    }
})(window);