(function(global) {
    var container = $('#p2-sns-container'),
        options   = container.data('options');
    
    // SNS 연동 상태를 먼저 알아본다.
    PuddingTo.API.call('get user/external/sns', {
        success: onSuccess
    });
    
    function onSuccess(data) {
        var anchorFB = $('.fb', container).closest('a'),
            anchorTW = $('.tw', container).closest('a'),
            textFB   = anchorFB.find('span'),
            textTW   = anchorTW.find('span'),
            facebook,
            twitter;
        
        console.log(data);

        data.forEach(function(item) {
            var siteType = item.site_type;

            if (siteType == 'FB') {
                facebook = item;
            } else if (siteType == 'TW') {
                twitter = item;
            }
        });

        if (facebook) {
            if (!anchorFB.length) {
                $('.fb a', container).addClass('on');
            }
            
            textFB.removeClass('bf')
                  .addClass('af on')
                  .text(facebook.screen_name);
        } else {
            textFB.removeClass('af on')
                  .addClass('bf')
                  .text(PuddingTo.i18n.CONNECT);
        }

        if (twitter) {
            if (!anchorTW.length) {
                $('.tw a', container).addClass('on');
            }

            textTW.removeClass('bf')
                  .addClass('af on')
                  .text(twitter.screen_name);
        } else {
            textTW.removeClass('af on')
                  .addClass('bf')
                  .text(PuddingTo.i18n.CONNECT);
        }

        $(container).on('click', 'a', function(event) {
            var $this = $(this),
                status,
                service,
                siteId,
                url,
                finalUrl,
                params,
                path,
                index,
                file,
                ga_category,
                ga_label,
                ga_action
                ;

            ga_category = $this.closestData('ga-category') || '';
            ga_label = $this.closestData('ga-label') || '';
            ga_action = $this.closestData('ga-action') || '';
            
            if (ga_category && ga_label && ga_action) {
                _gaq.push(['_trackEvent', ga_category, ga_action, ga_label]);
            }
            
            event.preventDefault();

            service = $this.children('strong');
            
            if (service.length) {
                status = service.next('span');
            } else {
                service = $this.parent('span');
                status  = $this;
            }
            
            service = service.get(0).className;
            siteId  = service.toUpperCase();

            if (service == 'fb' || service == 'tw') {
                if (status.hasClass('on')) {
                    if (options == 'search') {
                        if ($.os.android) {
                            finalUrl = PuddingTo.urlFor(PuddingTo.consts.PATH_FIND_FRIENDS_FACEBOOK, {
                                site_id: siteId
                            });
                            finalUrl = PuddingTo.urlFor(PuddingTo.consts.CALL_SNS, {url: encodeURIComponent(finalUrl)});
                        } else {
                            finalUrl = PuddingTo.urlFor(PuddingTo.consts.PATH_FIND_FRIENDS_FACEBOOK, {
                                site_id: siteId
                            });
                        }
                        
                        PuddingTo.API.showLoader();
                        
                        console.log(finalUrl);
                        location.href = finalUrl;
                    } else {
                        if (confirm(PuddingTo.i18n['DISCONNECT_' + siteId])) {
                            // SNS 연결을 해제한다.
                            PuddingTo.API.call('delete user/external/sns', {
                                data: {
                                    site_id: siteId
                                },
                                success: function() {
                                    status.removeClass('on af')
                                          .text(PuddingTo.i18n.CONNECT);
                                    
                                    location.href = 'https://disconnect?site_id=' + service;
                                }
                            });
                        }
                    }
                } else {
                    url    = PuddingTo.urlFor(PuddingTo.consts['URL_' + siteId + '_LINK']),
                    path   = location.pathname,
                    params = encodeURIComponent(location.search),
                    index  = path.lastIndexOf('/'),
                    file   = path.substr(index + 1);
                    
                    if (file == 'friendsMayknow.html') {
                        file   = 'findFriendsFacebook.html';
                        params = encodeURIComponent(location.search + '&site_id=' + siteId);
                    }

                    path = file.replace('.html', '');

                    if ($.os.android) {
                        finalUrl = encodeURIComponent(url + '&redirect_url=' + path + params);
                        finalUrl = PuddingTo.urlFor(PuddingTo.consts.CALL_SNS, {url: finalUrl});
                    } else {
                        finalUrl = url + '&redirect_url=' + path + params;
                    }

                    PuddingTo.API.showLoader();
                        
                    console.log(finalUrl);
                    location.href = finalUrl;
                }
            } else {
                url = 'puddingsns://USERSEARCH';
                console.log(url);
                location.href = url;
            }
        });
    }
})(window);
