(function(global) {
    PuddingTo.templates = {
        // 차단하기
        'user/blocks': {
            text: '<li data-user-id="{{id}}"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn"><strong><a href="/" data-link="profile">{{username}}</a></strong><span>{{realname}}</span></div><div class="bn1"><a href="/" class="ubk" data-link="unblock"><span>{{unblockText}}</span></a></div></li>',
            
            render: function(item) {
                var extra = {
                    unblockText: PuddingTo.i18n.UNBLOCK
                };

                return $.extend(item, extra);
            }
        },
        
        // 아는 친구
        'user/familiar': {
            text: '<li data-user-id="{{id}}"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn"><div class="sp"><strong><a href="/" data-link="profile">{{username}}</a></strong><span>{{realname}}</span></div><p class="{{iconClass}}">{{{mutualFriendsText}}}</p></div><div class="bn2"><strong class="ldg"><a href="/" class="add" data-link="follow"><span>{{followingText}}</span></a></strong><a href="/" class="ban" data-link="ban"><span>Delete</span></a></div></li>',
            
            render: function(item) {
                var following     = !!item.follow,
                    recommend     = item.recommend,
                    recommendType = recommend.recomm_type;
                    extra         = {
                        followingText: PuddingTo.i18n.FOLLOW
                    };
          
                if (recommendType == '01') {
                    extra.iconClass = 'icn3';
                    extra.mutualFriendsText  = recommend.username;
                } else if (recommendType == '02') {
                    extra.iconClass = 'icn2';
                    extra.mutualFriendsText  = recommend.username;
                } else if (recommendType == '11') {
                    extra.iconClass = 'icn1';
                    extra.mutualFriendsText  = Mustache.to_html(PuddingTo.i18n.LINK_MUTUAL_FRIENDS, {count: item.recommend.recomm_count});
                }

                return $.extend(item, extra);
            }
        },
        
        // 함께 아는 친구
        'user/familiar/with': {
            text: '<li data-user-id="{{id}}"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""><strong>{{username}}</strong><span>{{realname}}</span></a></li>',
            
            render: function(item) {
                var following = !!item.follow,
                    extra     = {
                        followingText: PuddingTo.i18n.FOLLOW
                    };

                return $.extend(item, extra);
            }
        },
        
        // 새소식
        'user/feed': {
            text: '<li class="ty1 {{classText}}" data-user-id="{{activity_uid}}" data-photo-id="{{post_id}}"><a href="/" data-link="{{linkType}}"><div class="im"><img src="{{profile_picture}}" alt=""></div><div class="cn"><p>{{{activity}}}</p><span>{{activity_time}}</span></div>{{#post_id}}<div class="tm"><img src="{{photo_link}}" alt=""></div>{{/post_id}}</a></li>',
            
            render: function(item) {
                var extra = {};
                
                if (feedType == 'my' && item.feed_id > lastFeedId) {
                    extra.classText = 'pNew';
                }

                if (parseInt(item.activity_uid)) {
                    extra.linkType = 'profile';
                }

                if (parseInt(item.post_id)) {
                    extra.linkType = 'photo';
                }

                extra.activity = item.activity.replace(/\[(.+?)\]/g, function(source, name) {
                    if (name == item.activity_user_name) {
                        return '<strong>' + name + '</strong>';
                    } else if (name == item.to_user_name) {
                        return '<strong>' + name + '</strong>';
                    } else {
                        return name;
                    }
                });

                if (item.activity_desc) {
                    extra.activity += ' "' + item.activity_desc + '"';
                }
                
                extra.activity_time = PuddingTo.formatTime(item.activity_time);

                return $.extend(item, extra);
            }
        },
        
        // 팔로우
        'user/follows': {
            text: '<li data-user-id="{{id}}"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn"><strong>{{#emotion}}<em>{{emotionText}}</em>{{/emotion}}<a href="/" data-link="profile">{{username}}</a></strong><span>{{realname}}</span></div><div class="bn1"><strong class="ldg">{{^mine}}<a href="/" class="{{followingClass}}" data-link="follow">{{/mine}}<span{{#mine}} class="you"{{/mine}}>{{followingText}}</span>{{^mine}}</a>{{/mine}}</strong></div></li>',
            
            render: function(item) {
                var mine      = item.id == PuddingTo.params.user_id,
                    following = !!item.follow,
                    extra     = {
                        emotionText   : item.emotion ? PuddingTo.i18n.EMOTIONS[item.emotion - 1] : '',
                        following     : following,
                        followingClass: following ? 'ing' : 'add',
                        followingText : PuddingTo.i18n[mine ? 'YOU' : (following ? 'FOLLOWING' : 'FOLLOW')],
                        mine          : mine
                    };
            
                return $.extend(item, extra);
            }
        },
        
        // 친구찾기 결과
        'user/search/email': {
            text: '<li data-user-id="{{id}}"><a href="/" data-link="email-detail"><img src="{{profile_picture}}" alt=""><strong>{{username}}</strong><span>{{realname}}</span></a></li>'
        },
        
        'user/general': {
            text: '<li data-user-id="{{id}}"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn"><strong><a href="/" data-link="profile">{{username}}</a></strong><span>{{realname}}</span></div><div class="bn1"><strong class="ldg">{{^mine}}<a href="/" class="{{followingClass}}" data-link="follow">{{/mine}}<span{{#mine}} class="you"{{/mine}}>{{followingText}}</span>{{^mine}}</a>{{/mine}}</strong></div></li>',

            render: function(item) {
                var mine      = item.id == PuddingTo.params.user_id,
                    following = !!item.follow,
                    extra     = {
                        mine          : item.id == PuddingTo.params.user_id,
                        followingClass: following ? 'ing' : 'add',
                        followingText : PuddingTo.i18n[mine ? 'YOU' : (following ? 'FOLLOWING' : 'FOLLOW')],
                        mine          : mine
                    };

                return $.extend(item, extra);
            }
        },
        
        // 초대하기
        'user/invite': {
            text: '<li data-user-id="{{id}}"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn">{{username}}</div><div class="bn1"><strong class="ldg"><a href="/" class="inv" data-link="invite" data-site="{{site}}"><span>{{inviteText}}</span></a></strong></div></li>',
            
            render: function(item) {
                var extra = {
                        inviteText: PuddingTo.i18n.INVITE
                    };

                return $.extend(item, extra);
            },
        },
        
        // 추천친구
        'user/suggest': {
            text: '<li data-user-id="{{id}}" data-ga-label="{{ga_label}}"><div class="grp1"><div class="im"><a href="/" data-link="profile"><img src="{{profile_picture}}" alt=""></a></div><div class="cn"><strong><a href="/" data-link="profile">{{username}}</a></strong><span>{{realname}}</span></div><div class="bn1"><strong class="ldg"><a href="/" class="add" data-link="follow"><span>{{followingText}}</span></a></strong></div></div><div class="grp2"><p class="{{recommClass}}"><em class="{{tagClass}}">{{recommText}}</em></p><p class="nIm">{{#thumbnails}}<a href="/" data-link="photo" data-photo-id="{{photoId}}"><img src="{{photoUrl}}" alt=""></a>{{/thumbnails}}</p></div><span class="x"><a href="/" data-link="ban"></a></span></li>',
            
            render: function(item) {
                var extra     = {
                        followingText: PuddingTo.i18n.FOLLOW,
                        thumbnails   : item.photos.map(function(photo) {
                            return {
                                photoId : photo.id,
                                photoUrl: photo.thumbnail
                            }
                        })
                    },
                    recommType = item.recommend.recomm_type;

                if (recommType < '51') {    //공통 속성
                    extra.recommClass = 'nTg';
                    extra.recommText  = item.recommend.recomm_name;
                    extra.ga_label = 'same_tag';
                } else {    //인기가 많은 친구들
                    extra.recommClass = 'nUp';
                    extra.ga_label = 'hot_user';
                }
                
                switch (recommType) {
                    case '21':
                        extra.tagClass = 'tg';
                        break;

                    case '22':
                        extra.tagClass = 'mc';
                        break;

                    case '23':
                        extra.tagClass = 'loc';
                        break;

                    case '51':  //팔로워가 급상승한 친구
                        extra.recommText = PuddingTo.i18n.FOLLOWER_SKYROCKETING;
                        break;

                    case '52': //인기사진에 뽑혔어요?
                        extra.recommText = PuddingTo.i18n.POPULAR_PHOTO;
                        break;
                }

                return $.extend(item, extra);
            }
        },
        
        // 프로필 태그
        'user/tags': {
            text: '<li data-id="{{id}}"><a href="/">{{tag}}</a><span>{{count}}</span></li>',
            
            render: function(item) {
                var count = item.photos_count,
                    extra = {
                    count: Mustache.to_html(PuddingTo.i18n[count > 1 ? 'PHOTOS_UNIT' : 'PHOTO_UNIT'], {count: count}),
                    tag  : item.tag || item.poi
                };

                return $.extend(item, extra);
            }
        },

        // 위치 검색
        'photo/location/search': {
            text: '<li data-location-id="{{id}}" data-location-name="{{name}}"><a href="/" data-link="location"><strong>{{name}}</strong><span>{{address}}</span></a></li>'
        },
        
        // 인기사진
        'photo/popular': {
            text: '<li data-photo-id="{{id}}"><a href="/" data-link="photo"><img src="{{image_url}}" alt=""></a></li>'
        }
    };
})(window);
