/**
 * @fileOverview
 * @name kth.puddingto.privacyPolicy.js
 * @author Kim il (blaxtar@kthcorp.com)
 * @version 20120604
 * @lastModified 2012-06-11
 * @created 2012-06-04
 * @description
 * <pre>
 * Pudding.To > 가입하기 > 약관/개인정보 취급방침 > 개인정보 취급방침 전문
 *
 * objects:
 * - {@link kth.puddingto.privacyPolicy} 개인정보 취급방침 전문
 * </pre>
 */
/*jslint browser:true devel:true white:false plusplus:false */
/*global window:true $:true kth:true */
(function(global) {

/**
 * @namespace
 * @name kth.puddingto.privacyPolicy
 * @example
kth.puddingto.privacyPolicy.get('ko');
 */
kth.getPackage('kth.puddingto.privacyPolicy', (function(NAME) {
	var PRIVACY_POLICY = {
			EN: 'Privacy Policy<br><br>Article 1. General Provisions<br>1. KT Hitel Corporation (hereinafter “we” or “KTH”) collects personal information when a user (hereinafter “you” or "Member") registers with KTH. “Personal information” is information which personally identifies you, such as your name, resident registration number, or other data which can be reasonably linked to such information.<br>2. We very much appreciates the importance of your personal information and conforms to the Act on the Protection, Use, etc. of Location Information, Telecommunications Security Protection Act, the Telecommunications Business Act, the Act on Promotion of Information and Communications Network Utilization and Information Protection, and Personal Information Protection Act.<br>3. We do our best to protect your personal information and hereby inform you of the purposes and methods by which we may use your personal information of and of the actions taken to protect your privacy.<br>4. We post this Privacy Policy on the lower part of the website so that you are aware of the information at any time.<br><br>Article 2 [The type of personal information we collect]<br>1. We collect the minimum amount of personal information necessary to provide our services.<br>2. We collect the following types of information about you when you resister in order to properly respond to your questions and inquiries.<br>1) Collected items for a member who registers with his/her email account<br>Email ID, password, profile photo, name, gender, birth of date, mobile device identification numbers (or IMEI), and legal guardian information (if you are not at least 14 year old)<br>2) Collected items for a member who registers with Facebook account or other services<br>Facebook ID, profile photo, name, gender, birth of date, blood type, language, relationship status, family, school, introduction, list of friends, hometown, interests, email address, mobile device identification numbers (device’s ID or IMEI), and legal guardian information (if you are not at least 14 year old)<br>3. We may collect the following types of information when we provide our services to you.<br>1)Service usage information, access information, cookie, IP address, mobile device identification numbers (device ID or IMEI), unauthorized or inappropriate access information<br>2)Location information stored on your device or your location information<br>3)Profile information: SNS registration information (twitter ID or/and Facebook ID), member’s status information, personal introduction, and interests<br>4. Upon your consent, we may also collect following information in case that you use additional services and personalized services or you participate in various events we host.<br>1)In case you win the event: information required to provide a gift and mailing address<br>2)In case you use fee-based services: payment information<br>5. Method of collecting personal information<br>1)through the webpage, paper form, fax, telephone, customer service board, email, promotional event application, logistics service  <br>2)from business partners or other companies <br>3)through an information-collecting tool<br>4)automatically collected from you executing or using Pudding.to <br>5)collected when you voluntarily registers for or use our service<br>6. All personal information received by you is subject to processing by Amazon Web Service on our behalf and we sometimes handle transfers of personal information to countries outside where you reside.<br>Article 3 [Collection of personal information and your agreement]<br>We always aim to get your agreement to our collecting or using your personal information. In terms of colleting your personal data, you are deemed to consent to KTH’s privacy practices once you press the “I Agree” button. However, we may collect and/or use your personal information without your prior consent in any of following cases. <br>1)if it is difficult to get your consent on collecting or using your personal information required to fulfill the contract of providing information communications services for economic or technical reasons <br>2)to collect fees in respect with using information communications services<br>3)if there is any applicable law, regulation, legal process or enforceable governmental request<br><br>Article 4 [Collection of personal information and purpose of usage]<br>We may display or provide targeted advertisements and services based on collected demographic factors (age, gender, and region) and frequency of using services in order to fulfill the contract obligation as service provider. Also, we may collect and store your mobile device identification numbers (or IMEI) to verify identification when you download or use pudding,to. <br>1. We use your personal information for the purposes set out below.<br>1)To perform contractual obligations and process payment regarding service provision <br>To provide contents on the website and mobile devices, to send bills or products, to verify identification, to purchase products or services and make payment, and to collect fees<br>2)To manage members <br>To verify identification for membership services, to distinguish individual, to prevent misbehaving members from using services improperly and prevent unauthorized use of services; to confirm intention of membership application ; to restrict membership application and the numbers of such application ; to confirm legal guardian’s consent to collect information of minors under the age of fourteen (14) and verify identification of such legal guardian; to preserve records for arbitrating disputes; to provide customer services for processing customers’ claims; and, to send notifications <br>3)To develop new services and to use for marketing and advertisement<br>To develop new services and provide personalized services, to provide services and advertisement according to demographic factors; to verify the validity of services, and to execute events and commercial information<br>Article 5 [Personal information collected from cookie]<br>1.  The Company operates cookies which frequently store and access your personal information. A cookie is a small piece of text sent by a web server to your web browser of wire/wireless devices, which is used to run the website. When you log into the website, the company’s server reads the contents of cookies on your browser of wire/wireless device. A cookie may identify wire/wireless devices of users, but does not collect personal information about you.<br>2.  The company may use cookies to use as standard for target marketing or personalized service by understanding preference and areas of interest of the member through analyzing frequencies and durations of visit, tracking usage, and degree or participation in various events.  <br><br>3. You have a choice of whether to install cookies. You may accept all cookies, or confirm whenever cookies are stored, or reject storage of all cookies by setting an option in your web browser by selecting [Internet Option] under [Tools] menu, clicking [Privacy] tab, and adjusting [Privacy] settings. However, if you refuse to reject storage of all cookies, you may experience some difficulties in using services.<br><br>Article 6 [Disclosure of Personal Information]<br>1. Your personal information will be used only for the purposes stated above in the [Collection of personal information and purpose of usage], will not be shared with third parties other than those described above and will not be provided to third parties or organizations beyond the scope set forth in this Privacy Policy.<br>2. We do not entrust your personal information to outside parties without your prior consent. If it is necessary to disclose your personal information to an outside company, we will inform you of the identity of the company, the details of using your personal information, items of personal information provided, retention and using period via website or by email, written document, and telephone, and obtain your prior consent. However, we may disclose or use your personal information without your consent in the following cases;<br>1)If it is necessary to collect fees <br>2)If we provide location information in a non-personal, aggregate format for statistical and research purposes<br>3)if special regulations are set forth in laws<br><br>3.We may disclose your personal information to third parties with your prior consent to do so in following cases.<br>1)When you make a purchase or use fee-based services, your contact information such as your name, address, and phone number, etc, may be provided to the seller, fee-based service provider, and logistics providers in order to collect fees and deliver the services or product. <br>2)When you participate in various events, your personal information may be provided to the host of event hosts.<br>4. We may work with a variety of business partners or service providers who may perform certain functions on our behalf, such as providing personalized services, online advertisement, community service, fee-based contents, and mobile service or performing market research and statistical survey, etc.<br><br>Article 7 . Consignment of personal information<br>In order to improve the quality of our services and to ensure the safety of such personal information, we may consign all or part of the management of personal information we have obtained for the collection, retention, handling, use, provision, management, and disposal of personal information in compliance with relevant laws and regulations.<br>Retention period and details of consigned service provider are as below.<br><br>Consigned agency and details <br>Consigned company Scope of Consignment Retention period of <br>personal information<br>KTIS (ktis.co.kr)Service operations, customer service center supports Until the termination of the outsourcing agreement or membership<br>Amazon Web ServiceSystem operations for providing services <br><br>In case of change in consigned service provider or scope of consignment in the future, we will notify its details to you in accordance with the procedures specified in Article 15. <br><br>Article 8 [Access and Correction of Personal Information]<br>You can access or correct your personal information anytime except for your name, gender and date of birth. You can access or correct your personal information by clicking [profile].<br><br>Article 9. [Withdrawal of consent of collection, use, and provision of personal information]<br>You may withdraw your consent to the collection, use and disclosure of personal information at any time. For withdrawal of consent (cancellation of membership), you can go to [setting]? [management] and withdraw your consent or cancel your membership upon verification of your identity, Or you can request cancellation in writing or e-mail, to the Personal Information Manager, all necessary measures will be promptly taken to delete the personal information of the requesting member Upon verification of your identity. <br><br>Article 10 [Term of Retention and Use of Personal Information]<br>1.We save your personal information you provide until your membership with us is terminated.<br>2.Upon termination, we will delete all personal information relating to the member without delay and will take proper measures so that your personal information cannot be used for any reason.<br>3.We will delete temporarily corrected personal information after completing the purposes of collection and use of them. However, in case that you provide your personal information to participate in various events we host, the personal information you provide will be kept for 6 months after the end of the promotional events. <br>4.We dispose of your personal documents such as a copy of identity card you submitted immediately after confirming your identity.<br>5.We aim to retain documents with parent’s consent for at least 2 years from its submission, but if the member terminates his/her membership with us, we immediately dispose of the evidence document.<br>6.We may exceptions can be made in retaining the personal information based on relevant laws and regulations for more than the retention period set as above.<br>Retention period of personal information <br>Items Retention<br>period Reason for retention<br>Personal information upon registration  30 days To prohibit a member from re-applying for the use of services after having had their membership revoked<br>Records of inappropriate usage 1 year To prohibit a misbehaving member from reapplying for membership, to deal with infringement of the rights, such as defamation, and, to cooperate with investigation<br>Records of identity confirmation 6 months Item 2 of Paragraph 1 of Article 44 of the Act on Promotion of Information and Communication Network Utilization and information Protection (enforcement decree: Article 29-3)<br>History of visits 3 months Item 2 of Paragraph 2 of Article 15 of the Protection of Communications Secrets Act (enforcement decree: item 2 of Paragraph 2 of Article 41)<br>Records of display/advertisement<br> 6 months Item 1 of Article 6 of the Consumer Protection Act on Electronic Transaction (enforcement decree: item 1 of Article 6)<br>Records related to contract or cancellation of membership 5 years Item 1 of Article 6 of The Consumer Protection Act on Electronic Transaction (enforcement decree: item 2 of 6)<br>Records related to payment and supplying goods, etc 5 years Item 1 of Article 6 of the Consumer Protection Act on Electronic Transaction (enforcement decree: item 3 of Article 6)<br><br>Records related to customer complaints and resolution of disputes 3 years Item 1 of Article 6 of the Consumer Protection Act on Electronic Transaction (enforcement decree: item 4 of Article 6)<br><br>Article 11 [Disposal of personal information and method of disposal]<br>We delete and destroy your personal information immediately after the purpose of collection and use of such information is accomplished. The disposal procedures and its method are as below;<br>1. Disposal procedure<br>1) The information that you provide shall be transferred, upon completion of accomplishing the intended purpose, to a separate database (or a separate document storage device or paper-based documents) for storage for a certain period in accordance with the internal regulations and relevant laws and regulations before being disposed of. <br>2) The personal information moved to a separate database shall not be used for purposes other than storage, unless specified otherwise by law.<br>2. Disposal method of Personal Information<br>1) Irreversible termination by systematic technique on personal information on electronic file<br>2) Shredding or incineration for personal information on paper<br><br>Article 12 [Technological and managerial measures for protection of personal information]<br>We take the following safety measures so that personal information will not be lost, stolen, leaked or spoiled.<br>1. Technological measures<br>A. Your password is encrypted with an encryption algorithm for the highest level of protection and even administers cannot know about it.<br>B. We maintain strict safety devices to prevent unauthorized or inappropriate access to personal information by limiting the access or use by its employees to the information.<br>C. We use security device that can safely transmit private information on the network using encrypted algorithm.<br>2. Managerial measure<br>A. We strictly specify that the employee who can handle personal information shall be the person who manages personal information, and who is necessarily required to handle personal information in the course of performing his/her duty.<br>B. Regular internal and external training is conducted for employees who handle personal information, with the said training pertaining to the acquisition of new security technology and on the responsibility for protection of personal information.<br>C. Handover of duties involving personnel who handle personal information is conducted thoroughly while maintaining security. We also set our responsibilities for incidents involving personal information after joining and leaving the company.<br>D.  If there is a loss, leak, alteration or damage of personal information due to the error of an internal manager or a technical or management incident, the Company will notify you immediately, take the appropriate steps, and take proper actions.<br>However, it is your responsibility to ensure the security of your ID and Password and we are not responsible for any leakage of such information resulting from your own mistake or fault.<br><br>Article 13 [Contact details of Personal information manager and Personal Information Administrator]<br>We assign a personal information manager and a personal information administrator to receive suggestions and handle complaints related to personal information. The personal information manager and the personal information administrator are as follows. Please contact to the below Personal Information manager in case that you have any question regarding handling of Personal Information.<br>[Personal information manager ]<br>Name : Yootaek Kim<br>Team : corporate culture<br>Email : helpmaster@paran.com<br>Phone : 1588-5668 [Personal Information Administrator]<br>Name : Yongseon Yoo<br>Team : CVI<br>Email : helpmaster@paran.com<br>Phone : 1588-5668<br><br>You can contact the following agencies if you need to report or consult on matters concerning privacy violation. <br>- Personal Information Infringement Center (www.118.or.kr / +82 2 118)<br>- PRIVACY Mark Certification Committee(http://www.eprivacy.or.kr/ +82 2 580 0533~4)<br>- Supreme Prosecutors\' Office Internet Crime Investigation Center (www.spo.go.kr / +82 2 3480 2000)<br>- Cyber Terror Response Center at the Police Agency (www.spo.go.kr/ +82 2 392 0330)<br><br>Article 14 [Protection of personal information of children under 14] <br>1. Child under age 14 needs to complete agreement process of legal guardian as to the personal information provision. <br>2. Respective legal representatives of children under the age of 14, at any time, may check or modify your registered personal information as well as request to cancel your membership. In case of such requests, we take relevant measures immediately after going through the procedure to confirm his/her identity.<br><br>Article 15 [Duty of Notification]<br>In the event of any material change, addition, or deletion to the privacy policy due to related laws or security technology, we will notify you of all changes in our company privacy policy seven days before the changes take effect on our website (http://pudding.to) or notification menu on pudding.to.<br>Announcement Date : January 17, 2012<br>Enforcement Date : January 17, 2012',
			KO: '개인정보취급방침<br>제1조 [총칙]<br>1. 케이티하이텔주식회사(이하 "회사"라 함)는 서비스를 제공하기 위해 필요한 필수항목을 서비스 이용자(이하 "회원"이라 함)의 동의 하에 수집하고 있습니다. 개인정보란 생존하는 개인에 관한 정보로서 해당 정보에 포함되어 있는 성명, 주민등록번호 등의 사항에 의하여 당해 개인을 식별할 수 있는 정보를 말합니다.<br>2. "회사"는 회원의 개인정보를 소중히 취급하며, 위치정보의 보호 및 이용에 관한 법률(이하 "위치정보보호법"), 통신비밀보호법, 전기통신사업법, 정보통신망 이용촉진 및 정보보호 등에 관한 법률(이하 "정보통신망법") 및 개인정보보호법을 준수하고 있습니다. <br>3. "회사"는 관련 법령에 의거하여 개인정보취급방침을 통해 회원의 권익 보호를 위해 최선을 다하고 있습니다.<br>4. "회사"는 개인정보취급방침을 웹사이트 초기화면 하단에 공개함으로써 회원이 언제나 용이하게 보실 수 있도록 조치하고 있습니다.<br><br>제2조 [수집하는 개인정보 항목]<br>1. "회사"는 회원 가입 시 서비스 제공을 위해 필요한 최소한의 개인정보만을 수집합니다.<br><br>2. "회사"는 회원 가입, 원활한 고객상담을 위해 회원 가입 시 아래와 같은 개인정보를 수집하고 있습니다. <br>① 이메일가입 회원 개인정보 수집 항목<br>이메일 아이디(ID), 비밀번호, 프로필 사진, 이름, 성별, 생년월일, 기기고유번호(디바이스 아이디 또는 IMEI), 만 14세 미만인 경우 법정 대리인 정보<br>② 외부인증(페이스북)연동 회원 개인정보 수집 항목<br>페이스북 ID, 프로필 사진, 이름, 성별, 생년월일, 혈액형, 언어, 결혼/연애상태, 가족, 직장, 학력, 내 소개, 친구목록, 출신지, 관심사, 이메일, 기기고유번호(디바이스 아이디 또는 IMEI), 만 14세 미만인 경우 법정 대리인 정보<br><br>3. 서비스 이용과정이나 사업처리 과정에서 아래와 같은 정보들이 수집될 수 있습니다.<br>① 서비스 이용기록, 접속 로그, 쿠키, 접속 IP 정보, 기기고유번호(디바이스 아이디 또는 IMEI), 불량이용 기록 등 자동생성정보<br>② 회원의 단말기에 저장된 위치정보 혹은 개인위치정보 <br>③ 프로필 정보 : SNS 정보(트위터, 페이스북 ID), 회원 상태정보, 자기소개, 관심사<br><br>4. 부가 서비스 및 맞춤식 서비스 이용 또는 이벤트 응모 과정에서 해당 서비스를 이용하는 회원의 선택에 의해 아래와 같은 정보들이 수집될 수 있습니다.<br>① 이벤트 당첨시 : 경품 제공 및 배송을 위해 필요한 정보<br>② 유료서비스 이용시 : 결제정보<br><br>5. 개인정보 수집방법<br>① 홈페이지, 서면양식, 팩스, 전화, 상담 게시판, 이메일, 이벤트 응모, 배송요청<br>② 협력회사로부터의 제공<br>③ 생성정보 수집 툴을 통한 수집<br>④ 회원이 푸딩푸딩.투 서비스를 실행 또는 사용함으로써 자동으로 수집<br>⑤ 서비스 가입이나 사용 중 회원의 자발적 제공을 통한 수집<br><br>6. "회사"는 미국 및 기타국가의 Amazon Web Serivce 서버에서 개인정보를 처리하고 있으며, 회원의 거주 국가 이외 지역에서 개인정보를 처리하는 경우도 있습니다.<br><br><br>제3조 [개인정보 수집 및 이용에 대한 동의]<br>"회사"는 회원으로부터 개인정보 수집 및 이용에 대한 동의를 받고 있습니다. 회원의 개인정보 수집과 관련하여 회원 가입 시 개인정보취급방침에 대한 동의절차를 마련하여 동의 버튼을 클릭하면 개인정보 수집 및 이용에 대해 동의한 것으로 봅니다. 다만, 아래의 경우에는 개인정보 수집 및 이용에 대한 회원의 사전 동의를 구하지 않을 수 있습니다.<br>1. 정보통신서비스 제공에 관한 계약을 이행하기 위하여 필요한 개인정보로서 경제적ㆍ기술적인 사유로 통상적인 동의를 받는 것이 뚜렷하게 곤란한 경우<br>2. 정보통신서비스 제공에 따른 요금정산을 위하여 필요한 경우<br>3. 다른 법률에 특별한 규정이 있는 경우<br><br><br>제4조 [개인정보의 수집 및 이용목적]<br>"회사"는 회원에게 서비스 제공에 관한 계약을 이행하고 더 나은 서비스를 제공하기 위해 수집한 개인정보를 바탕으로 연령별, 성별, 지역별, 사용유형별, 인구통계학적 특성에 따른 통계를 통하여 맞춤 서비스 제공 및 광고를 제공할 수 있습니다. 또한 "회사"는 회원의 가입ㆍ이용 시에 기기고유번호 (디바이스 아이디 또는 IMEI)를 수집하고 저장하여 회원의 개인식별을 위한 정보로 사용할 수 있습니다. <br><br>1. "회사"는 다음과 같은 목적을 위하여 개인정보를 이용합니다.<br>① 서비스 제공에 관한 계약 이행 및 서비스 제공에 따른 요금정산<br>웹사이트 및 모바일 서비스 이용을 위한 컨텐츠 제공, 물품배송 또는 청구서 등 발송, 본인인증, 구매 및 요금 결제, 요금추심<br>② 회원 관리<br>실명확인, 회원제 서비스 이용에 따른 본인확인, 개인 식별, 개인정보 도용 및 불량회원의 부정 이용 방지와 비인가 사용 방지, 개인정보 및 인격권 보호, 가입 의사 확인, 연령확인, 만14세 미만 아동 개인정보 수집 시 법정 대리인 동의여부 확인, 불만처리 등 민원처리, 각종 이벤트 혜택 제공을 위한 안내, 고지사항 전달<br>③ 신규서비스 개발 및 마케팅ㆍ광고에의 활용<br>신규 서비스 개발 및 맞춤 서비스 제공, 인구 통계학적 특성에 따른 서비스 제공 및 광고 게재, 서비스의 유효성 확인, 이벤트 및 광고성 정보 제공 및 참여<br><br><br>제5조 [쿠키에 의한 개인정보 수집]<br>1. "회사"는 회원의 정보를 저장하고 수시로 찾아내는 \'쿠키(cookie)\'를 운용합니다. 쿠키는 웹사이트가 회원의 유ㆍ무선 단말기의 브라우저(인터넷익스플로러 등)로 전송하는 소량의 정보입니다. 회원이 웹사이트에 로그인(log-in)하면 "회사"의 서버는 회원의 브라우저에 있는 쿠키의 내용을 읽고, 회원의 추가정보를 회원의 유ㆍ무선 단말기에서 찾아 서비스를 제공하게 됩니다. 쿠키의 경우 회원의 유ㆍ무선 단말기는 식별하지만 회원 개개인을 식별하지는 않습니다.<br>2. "회사"는 쿠키를 통해 회원의 접속 빈도나 방문시간을 분석하고 회원의 취향과 관심 분야를 파악하여 타겟(Target)마케팅 및 서비스 개편 등의 척도로 활용합니다. 또한 각종 이벤트에서 회원의 참여 정도 및 방문 횟수를 파악하여 차별적인 응모 기회를 부여하고, 개인의 관심분야에 따라 차별화된 정보를 제공하기 위한 자료로 사용됩니다.<br>3. 회원은 쿠키 설치에 대한 선택권을 가지고 있습니다. 웹 브라우저에서 [도구] > [인터넷 옵션> [보안] > [사용자 정의 수준]을 선택함으로써 모든 쿠키를 허용하거나 쿠키가 저장될 때마다 확인을 거치거나, 아니면 모든 쿠키의 저장을 거부할 수도 있습니다. 다만, 모든 쿠키의 저장을 거부하겠다고 선택하면 쿠키를 통해 "회사"에서 제공하는 서비스를 이용할 수 없게 됩니다.<br><br><br>제6조 [개인정보의 제공]<br><br>1. "회사"는 회원의 동의가 있거나 법령의 규정에 의한 경우를 제외하고는 어떠한 경우에도 [개인정보의 수집목적 및 이용목적]에서 고지한 범위를 넘어 회원의 개인정보를 이용하거나 타인 또는 타기업/기관에 제공하지 않습니다.<br><br>2. 회원의 개인정보를 제공하는 경우에는 개인정보를 제공받는 자, 개인정보를 제공받는 자의 개인정보 이용 목적, 제공하는 개인정보 항목, 개인정보를 제공받는 자의 개인정보 보유 및 이용기간에 대해 개별적으로 인터넷사이트, 전자우편, 서면, 전화 등을 통해 고지한 후 이에 대한 사전 동의를 구합니다. 다만, 다음의 경우에는 회원의 동의 없이 개인정보를 제공할 수 있습니다.<br>① 서비스 제공에 따른 요금 정산을 위하여 필요한 경우<br>② 통계작성, 학술연구 또는 시장조사를 위하여 개인을 식별할 수 없는 형태로 위치정보를 제공하는 경우<br>③ 법령에 특별한 규정이 있는 경우<br><br>3. "회사"는 아래와 같은 경우 회원의 동의 하에 개인정보를 제3자에게 제공할 수 있습니다.<br>① 물품구매, 유료컨텐츠 이용 등의 배송 및 정산을 위해 회원의 이름, 주소, 전화번호 등이 해당 쇼핑몰 업체, 유료컨텐츠 제공자, 배송업자에게 제공될 수 있습니다.<br>② 각종 이벤트 행사에 참여한 회원의 개인정보가 해당 이벤트 주최자에게 제공될 수 있습니다.<br><br>4. "회사"는 회원에게 제공되는 서비스의 질을 향상시키기 위해 맞춤서비스, 온라인광고 서비스, 커뮤니티 서비스, 유료컨텐츠 서비스, 모바일 서비스, 통계작성 또는 시장조사 등 다양한 서비스를 제공할 목적으로 여러 분야의 전문 컨텐츠 사업자 혹은 비즈니스 사업자와 함께 파트너쉽을 맺을 수 있습니다.<br><br><br>제7조 [개인정보의 취급위탁]<br>"회사"는 서비스 향상을 위해서 아래와 같이 개인정보를 수집ㆍ보관ㆍ처리ㆍ이용ㆍ제공ㆍ관리ㆍ파기 등을 할 수 있도록 업무를 위탁하고 있으며, 관계 법령에 따른 위탁 계약시 개인정보가 안전하게 관리될 수 있도록 필요한 사항을 규정하고 있습니다.<br><br>"회사"의 개인정보 위탁처리 기간 및 위탁업무 내용은 아래와 같습니다.<br><br>개인정보 위탁처리 기관 및 위탁업무 내용<br>수탁업체 위탁업무 내용 개인정보의 보유 및 이용기간<br>케이티스(ktis.co.kr) 서비스 운영, 고객상담 지원 회원의 회원 탈퇴 시 혹은 위탁계약 종료 시까지<br>Amazon Web Service 서비스 제공을 위한 시스템 운영 위탁 <br><br>"회사"는 향후 수탁업체, 위탁업무의 내용이 변경되는 경우에 제15조에 명시한 방법에 따라 회원에게 공고합니다. <br><br><br>제8조 [개인정보의 열람ㆍ정정]<br>회원은 언제든지 등록되어 있는 본인의 개인정보를 열람할 수 있습니다. 또한 이름ㆍ성별ㆍ생년월일을 제외한 개인정보 정정이 가능합니다. 개인정보에 대한 열람 또는 정정을 하고자 할 경우에는 [프로필] 메뉴를 클릭하여 열람 또는 정정할 수 있습니다. <br><br><br>제9조 [개인정보 수집ㆍ이용ㆍ제공에 대한 동의 철회]<br>회원은 개인정보 수집, 이용 및 제공에 대해 가입 시 동의하신 내용을 언제든지 철회하실 수 있습니다. 동의철회(회원 탈퇴)는 서비스의 [설정] > [계정관리] 메뉴를 클릭하여 본인 확인 절차를 거치신 후 직접 탈퇴신청을 하시거나, 개인정보관리책임자에게 서면 또는 이메일로 연락하시면 본인확인진행 후 개인정보를 파기하는 등 필요한 조치를 하겠습니다.<br><br><br>제10조 [개인정보의 보유기간 및 이용기간]<br>1. "회사"는 회원이 회원 자격을 유지하고 있는 동안에는 회원이 "회사"에 제공한 개인정보를 계속 보유합니다.<br>2. 개인정보 제공에 대해 동의철회(회원 탈퇴)할 경우 즉시 수집된 개인정보를 즉시 파기하며, 예외 규정을 제외하고 어떠한 목적으로도 사용할 수 없도록 합니다.<br>3. 일시적인 목적에 의해 수집한 개인정보는 그 이용목적을 달성하면 지체 없이 파기합니다. 단, 이벤트응모를 위해 주소 등의 개인정보를 제공한 경우에는 이벤트상품 발송 및 이벤트응모 고객에 대한 고객응대를 위해 해당 이벤트의 종료시점으로부터 6개월간 해당 개인정보를 보유합니다.<br>4. 회원이 본인이 "회사"의 회원임을 증빙하기 위해 "회사"에 발송한 신분증 사본 등 서류일체는 본인확인 후 즉시 파기합니다.<br>5. 법정대리인의 동의여부를 증빙하는 자료는 접수일로부터 최소 2년간 보유함을 원칙으로 하나, 법정대리인의 동의 이후 2년 이내에 회원이 회원 탈퇴를 하는 경우에는 그 즉시 파기합니다.<br>6. 아래의 경우에는 관련 법령 및 지침 등에 근거하여 예외적으로 위에서 정한 개인정보 보유기간을 넘어서 보유할 수 있습니다.<br><br>개인정보 보유기간<br>항목 보존일 보존사유<br>회원 가입정보 30일 회원 탈퇴 후 아이디 재가입지원 및 오용 방지<br>부정이용기록 1년 불량 회원의 재가입 방지, 명예훼손 등 권리침해 분쟁 및 수사 협조<br>본인확인에 관한 기록 6개월 정보통신망 이용촉진 및 정보보호 등에 관한 법률 제44조의5 제1항 제2호, 시행령 제29조 제3호<br>방문에 관한 기록 3개월 통신비밀보호법 제15조의2 제2항, 시행령 제41조 제2항 제2호<br>표시/광고에 관한 기록 6개월 전자상거래 등에서의 소비자보호에 관한 법률 제6조 제1항 시행령 제6조 제1호<br>계약 또는 청약철회 등에 관한 기록 5년 전자상거래 등에서의 소비자보호에 관한 법률<br>제6조 제1항 시행령 제6조 제2호<br>대금결제 및 재화 등의 공급에 관한 기록 5년 전자상거래 등에서의 소비자보호에 관한 법률 제6조 제1항 시행령 제6조 제3호<br>소비자의 불만 또는 분쟁처리에 관한 기록 3년 전자상거래 등에서의 소비자보호에 관한 법률 제6조 제1항 시행령 제6조 제4호<br><br><br>제11조 [개인정보 파기절차 및 방법]<br>"회사"는 회원에게 사전에 고지하고 동의 받은 개인정보의 수집ㆍ이용목적이 달성되면 지체 없이 파기합니다. 파기절차 및 방법은 다음과 같습니다.<br><br>1. 파기절차<br>① 회원이 입력한 개인정보는 수집ㆍ이용목적이 달성되거나 이용기간이 끝나면 별도의 DB로 옮겨져(종이의 경우 별도의 서류함) 내부 방침 및 기타 관련 법령에 의한 정보보호 사유에 따라 제9조에 근거하여 일정기간 저장 후, 재생할 수 없는 방법으로 파기됩니다.<br>② 별도 DB로 옮겨진 회원의 개인정보는 법령에 의한 경우가 아닌 다른 목적으로 이용되지 않습니다.<br><br>2. 파기방법<br>① 전자적 파일형태로 저장된 개인정보는 기록을 재생할 수 없는 기술적 방법을 사용하여 삭제합니다.<br>② 종이에 출력된 개인정보는 분쇄기로 분쇄하거나 소각을 통하여 파기합니다.<br><br><br>제12조 [개인정보보호를 위한 기술적ㆍ관리적 대책]<br>"회사"는 회원의 개인정보를 취급함에 있어 개인정보가 분실ㆍ도난ㆍ누출ㆍ변조ㆍ훼손되지 않도록 아래와 같은 기술적 관리적 대책을 강구하고 있습니다.<br><br>1. 기술적 대책<br>A. 회원의 비밀번호는 암호화 처리되어 운영자도 회원 개개인의 비밀번호를 알 수 없도록 되어 있습니다.<br>B. 허용되지 않은 IP에 대해 접근 권한을 두어 "회사"의 내부 네트워크가 아닌 경우 개인정보가 담겨있는 서버로 접근이 불가능하게 되어 있습니다. 또한 허용되지 않은 포트에 대한 접근 금지 등 시스템 보안에 최선을 다하고 있습니다.<br>C. "회사"는 암호화 통신 등을 통하여 네트워크상에서 개인정보를 안전하게 송ㆍ수신할 수 있도록 하고 있습니다.<br><br>2. 관리적 대책<br>A. 개인정보관리책임자와 최소한의 인원으로 구성된 부서를 마련하여 개인정보에 대한 접근권한을 제한하고 있습니다.<br>B. 개인정보를 취급하는 직원을 대상으로 새로운 보안 기술 습득 및 개인정보 보호의무 등에 관해 정기적인 사내 교육 및 외부 위탁교육을 실시하고 있습니다.<br>C. 개인정보 관련 취급자의 업무 인수인계는 보안이 유지된 상태에서 철저하게 이뤄지고 있으며, 입사 및 퇴사 후 개인정보 사고에 대한 책임을 명확하게 하고 있습니다.<br>D. "회사"는 내부 관리자의 과실이나 기술관리상의 사고로 인해 개인정보가 유출, 변조, 훼손된 경우에는 즉각 귀하에게 그 사실을 알리고 적절한 대책을 강구할 것입니다.<br>그러나 회원의 실수로 개인정보가 유출되는 경우 "회사"는 책임을 지지 않으므로 아이디(ID)와 비밀번호가 타인에게 알려지지 않도록 관리하여야 합니다.<br><br><br>제13조 [개인정보관리책임자 및 담당자의 연락처]<br>회원의 개인정보를 보호하고 개인정보와 관련한 불만을 처리하기 위하여 "회사"는 개인정보관리책임자를 두고 있습니다. 개인정보와 관련된 문의사항이 있으시면 아래의 개인정보관리책임자에게 연락 주시기 바랍니다. 문의하신 사항에 대해서 신속하고 성실하게 답변해드리겠습니다.<br>[개인정보관리 책임자]<br>성명 : 김유택<br>소속 : 기업문화실<br>이메일 : helpmaster@paran.com<br>전화번호 : 1588-5668 [개인정보관리 담당자]<br>성명 : 유용선<br>소속 : CVI팀<br>이메일 : helpmaster@paran.com<br>전화번호 : 1588-5668<br><br>기타 개인정보침해에 대한 신고나 상담이 필요하신 경우에는 아래 기관에 문의하시기 바랍니다.<br>- 개인정보침해신고센터(www.118.or.kr / 118)<br>- 정보보호마크인증위원회(www.eprivacy.or.kr / 02-580-0533~4)<br>- 대검찰정 첨단범죄수사과(www.spo.go.kr / 02-3480-2000)<br>- 경찰청 사이버테러대응센터 (www.ctrc.go.kr / 02-392-0330)<br><br>제14조 [만14세 미만 아동의 개인정보보호]<br>1. "회사"는 회원이 만 14세 미만인 경우 개인정보수집, 이용 등에 관하여는 법정대리인의 동의를 받고 있습니다.<br>2. 만 14세 미만 아동의 법정대리인은 아동의 개인정보의 열람 정정, 동의철회를 요청할 수 있으며, 이러한 요청이 있는 경우 "회사"는 법정대리인 확인 후 지체 없이 필요한 조치를 취합니다. <br><br>제15조 [고지의 의무]<br>법령 정책 또는 보안기술의 변경의 따라 내용의 추가 삭제 수정이 있을 시에는 변경되는 개인정보취급방침을 시행하기 최소7일전에 푸딩.투 웹사이트(http://pudding.to)나, 푸딩.투 서비스 내 "공지사항" 화면을 통해 공고할 것입니다.<br><br>공고일자 : 2012년 1월 17일<br>시행일자 : 2012년 1월 17일<br>',
			JA: '個人情報保護の取扱い<br><br><br>第１条　はじめに<br>1．KT Hitel株式会社(以下「当社」といいます)が本サービス上で提供するために必要な必要項目をサービス利用者(以下「会員」といいます)の同意上で会員から取り扱いします。<br>個人情報とは、特定の個人に関する情報で、当情報に含まれている個人の氏名、生年月日などの事項によって、当年に個人を識別できるものを指します。<br>2．当社は、会員の個人情報の管理に細心の注意を払うものとし、位置情報の保護または利用に関する法律(以下「位置情報法」)、通信秘密保護法、電気通信事業法、情報通信網の利用促進および情報保護に関する法律（以下 「 情報通信網法」）、個人情報保護法を遵守とします。<br>3．当社は、関連法令に準拠し、個人情報保護方針に通じて会員の権益保護に最善を尽くします。<br>4．当社は、 個人情報保護方針をサービスの初期画面に掲示・掲載することにより、会員がいつでも閲覧可能な状態とします。<br><br>第２条　取扱う個人情報の項目<br>1．当社は、会員登録の際、サービス提供のため必要な最小権の個人情報を収集します。<br>3．サービスの利用過程および事業処理過程で以下の情報が収集することがあります。<br>①　サービスの利用記録、接続ログ、接続IP情報、機器固有番号（ディバイスIDおよびIMEI）、不良利用記録などの自動生成情報<br>②　会員の端末機に保存している位置情報および個人位置情報<br>③　プロフィール情報<br>SNS情報（Twitter、Facebook ID）、会員の状態情報、会員の自己招待、会員の感心事<br>4．付加サービス、個人サービスの利用およびイベント応募の過程で会員の選択によって以下の情報が収集することがあります。<br>①　イベント当籤の時：景品提供、配達のため必要な情報<br>②　有料サービス利用の時：決済情報<br>５．個人情報の取得方法<br>①　ホームページ、書面様式、電話、Q/N揭示板、Eメール、イベント応募、配達要請<br>②　協力会社からの提供による収集<br>③　生成情報の収集ツールによる収集<br>④　会員のpudding.toサービスの実行および利用によって自動に収集<br>⑤　会員登録または会員の自発的提供による収集<br>６． 当社は、アメリカおよびその他の国家のAmazon Web Serivceサーバーで個人情報を処理しており、会員の居住以外の地域で会員の個人情報を処理する場合もあります。<br><br>第３条　個人情報収集および利用の同意<br>当社は、個人情報収集および利用について会員からの同意を得た上で行います。会員の個人情報収集に関しては、会員登録の際に個人情報保護方針に関する同意手順を用意し、同意ボタンをクリックする場合、個人情報および利用について同意を得たと認めます。ただし、以下の場合には個人情報および利用について会員の事前同意を要求しない場合があります。<br>1．情報通信サービスの提供に関する契約を履行するために必要な個人情報で、経済的ㆍ技術的な事由で通算的な同意を得ることが困難であるとき。<br>2．情報通信サービスの提供による預金精算のために必要なとき<br>3．その他の法律に特別な規定があるどき<br><br>第４条　 個人情報収集および利用の目的<br>当社は、会員にサービス提供に関する契約を履行し、よりいいサービスを提供するため、収集した個人情報に基づいて年齢別、性別、地域別、使用類型別、人口統計学的な特性によろ統計に通じた個人サービスまたは広告を提供することがあります。また、 当社は会員登録および利用の際に機器固有番号（ディバイスIDおよびIMEI）を収集ㆍ保存し、会員の個人識別に対する情報として使用することがあります。<br>1． 当社は、以下の目的のために個人情報を利用させていただきます。<br>①　サービス提供に関する契約の履行およびサービス提供による預金精算<br>ウェブサイトおよびモバイル利用によるコンテンツ提供、物品配達および請求書などの発送、ご本人の認証、購買および預金決済、預金取立て<br>②　会員管理<br>本名確認、会員制サービス利用によろご本人の確認、個人識別、個人情報の盗用および不良会員の不正利用の防止と否認可利用の防止、個人情報および人権の保護、会員登録の意思確認、年齢確認、14歳未満児童の個人情報収集の際に必要な法定同意人の同意可否確認、不満処理などの取り合わせ、各イベント提供に関する案内、告知事項の伝達<br>③　新規サービス開発およびマーケティングㆍ広告への活用<br>新規サービス開発および個人サービス提供、 人口統計学的な特性によるサービス提供または広告配信、サービス有効性の確認、イベントおよび広告性情報の提供ㆍ参与<br><br>第５条　 クッキーの使用等による個人情報収集<br>1． 当社は、会員情報を保存し随時に利用する、「クッキー（cookie）」を運用します。クッキーとは、ウェブサイトから会員の有ㆍ無線端末機のブラウザ（internet　exploreなと）へ転送する少量の情報です。会員がウェブサイトでログインする場合、当社のサーバーは会員のブラウザにあるクッキーの内容を読み込み、会員の追加情報を会員の有ㆍ無線端末機から検索し、サービスを提供することになります。クッキーの場合、会員の有ㆍ無線端末機を識別しますが、会員個々人を識別することはありません。<br>2． 当社は、クッキーを通じて会員の接触頻度や訪問時間を分析して会員の関心分野を把握し、ターゲットマーケティング、サービス改編等の尺度として活用します。また各イベントから会員参与の程度ㆍ訪問回数を把握して差別的な応募機会を付与したり、個人の好みによる差別的な情報を提供するための資料で使用します。 <br>3．会員はクッキー使用の許可による選択権があります。ウェブブラウザの設定を変更することで、全てのクッキーを許容したり、クッキーが保存するたびに会員確認を経由したり、あるいは全てのクッキーの保存を拒否することができます。ただし、クッキー使用を禁止した場合、クッキーに通じて当社から提供するサービスが正常にご利用できない可能性があります。<br><br>第６条　個人情報の提供<br>1． 当社は、会員の同意がある場合または法律の規定による場合を除外として、どんな場合にも「 個人情報収集および利用の目的」で告知した範囲を超えて、会員の個人情報を利用したり、 第三者、その他の企業ㆍ機関への提供はしません。<br>2．会員の個人情報を提供する場合には個人情報を受ける者、個人情報を受ける者の個人情報に関する利用目的、提供する個人情報の項目、個人情報を受ける者の個人情報の保有および利用期間についてインターネットサイト、電子メール、書面、電話なとを通じで告知し、 あらかじめ会員ご本人の同意を得て行います。ただし、以下の場合はこの限りではありません。<br>①　サービス提供による預金精算のために必要なとき<br>②　統計作成、学術研修または市場調査のために個人を識別できない形で位置情報を提供するこき<br>③　その他の法律に特別な規定があるどき<br>3． 当社は、以下の場合、会員の同意に基づいた個人情報を第三者に提供することがあります。<br>①　物品購買、有料コンテンツの利用などの配達ㆍ精算のため会員の名前、住所、電話番号などを該当ショッピング事業者ㆍ有料コンテンツ提供者ㆍ配達業者に提供するこき<br>②　各イベントに参与した会員の個人情報を該当イベント主体者に提供するこき<br>4． 当社は、会員に提供するサービスの質を高めるため個人サービス、オンライン広告サービス、 コミュニティーサービス、有料コンテンツサービス、モバイルサービス、統計作成および市場調査なとの多様なサービスを提供する目的で、多様な分野の専門コンテンツ事業者およびビジネス事業者と共にパートナーシップを採決することがあります。<br><br>第７条　個人情報の取扱委託<br>当社は、サービスの向上のため、以下のように個人情報の取扱ㆍ保管ㆍ処理ㆍ利用ㆍ提供ㆍ管理ㆍ破棄なとの取扱い業務を委託します。なお、その個人情報の委託に関しては関係法律によって個人情報が安全に管理できるように必要な事項を規定してます。<br>当社の個人情報の委託修理機関および委託業務の内容はご覧になります。<br><br>個人情報の委託修理機関および委託業務の内容<br>受託業体<br>委託内容<br>個人情報の保有および利用期間<br>KTIS(ktis.co.kr) <br>サービス運営、顧客相談支援<br>会員の会員脫退または委託契約の終了まで<br>Amazon Web Service <br>サービス提供によるシステム運営の委託<br>会員の会員脫退または委託契約の終了まで<br><br>当社は、今後受託業体、委託業務の内容に変更がある場合、第15条に明示した方法を通じて会員に公告とします。<br><br>第８条　個人情報の閱覽ㆍ訂正<br>会員は、いつでも登録されているご本人の個人情報の閱覽が可能になります。また、名前ㆍ性別ㆍ生年月日を除く個人情報の訂正が可能になります。個人情報に関した閱覽ㆍ訂正が必要な場合、「プロフィール」メニューをクリックし、情報の閱覽ㆍ訂正が可能になります。<br><br>第９条　個人情報の収集ㆍ利用ㆍ提供に関する同意撤回<br>会員は、個人情報収集、利用および提供について会員登録に同意した内容をいつでも撤回するのが可能になります。同意撤回(会員脱退)はサービスの｢設定｣>｢アカウント管理｣メニューをクリックしてご本人の確認手順を受けた後、直接に脱退申請をしたり、個人情報管理者に書面またはEメールへの連絡を取ることで個人情報の破棄に関した必要な処置が行います。<br><br>第１０条　個人情報の保有期間および利用期間<br>1．当社は、会員が会員資格を維持している間には会員が当社に提供する個人情報を保有します。<br>2．個人情報提供について同意撤回(会員脱退)をする場合、収集した個人情報はすぐ破棄し、例外規定を除いて全ての目的で利用できないように処置します。<br>3．一時的な目的による収集した個人情報はその利用目的が達成した瞬間、即時に破棄します。ただし、イベント応募のための住所などの個人情報を提供した場合、イベント賞品配達およびイベント応募会員に関する会員応対のため、該当イベントの終了時点から６ヶ月間、該当個人情報を保有します。<br>4.　会員のご本人が当社の会員とを証憑するために当社に転送して証明書写本などの書類一切は即時、廃棄します。<br>5.　法定代理人の同意可否を証明する書類は受取日から最小2年間保有するのが原則になします。ただし、 法定代理人の同意以降、2年以内に会員が会員脱退をする場合、即時に廃棄します。<br>6.　以下の場合には関連法令および指針に基づいて例外的に以上に提示した個人情報の保有期間を超えて保有することになります。<br>①　会員登録情報<br>ⅰ 保存日： ３０日<br>ⅱ 保存事由：会員脱退後、ID再登録および誤用防止<br>②　不正利用記録<br>ⅰ 保存日： １年<br>ⅱ 保存事由：不良会員の再登録防止、名誉毀損などの権利侵害紛争および捜査協助<br>③　ご本人確認に関する記録<br>ⅰ 保存日： ６ヶ月<br>ⅱ 保存事由：情報通信網の利用促進および情報保護等に関する法律、第44条の５の第1項の第2号、施行令第29条の第3号<br>④　訪問に関する記録<br>ⅰ 保存日： ３ヶ月<br>ⅱ 保存事由：通信秘密保護法、第15条の2の第2項、施行令第41条の第2項の第2号<br>⑤　表示/広告に関する記録<br>ⅰ 保存日： ６ヶ月<br>ⅱ 保存事由：電子商取引等への消費者保護に関する法律、第6条の第1項、施行令第6条の第1号<br>⑥　契約または応募等に関する記録<br>ⅰ 保存日： ５年<br>ⅱ 保存事由：電子商取引等への消費者保護に関する法律、第6条の第1項、施行令第6条の第2号<br>⑦　代金決済および財貨等の供給に関する記録<br>ⅰ 保存日： ５年<br>ⅱ 保存事由：電子商取引等への消費者保護に関する法律、第6条の第1項、施行令第6条の第3号<br>⑧　消費者の不満または紛争処理に関する記録<br>ⅰ 保存日： ３年<br>ⅱ 保存事由：電子商取引等への消費者保護に関する法律、第6条の第1項、施行令第6条の第4号<br><br>第１１条　個人情報の破棄手順と方法<br>当社は、会員に事前に告知して合意を得た個人情報を収集ㆍ利用の目的が達成した即時に破棄します。破棄手順と方法はご覧になります。<br>1．破棄手順<br>①　会員が入力した個人情報は収集ㆍ利用の目的が達成したり、利用期間が終わる場合、別度のDBに移動し(紙の場合別度の書類箱)、内部方針およびその他の法律による情報保護の事由によって、第９条に基づいて一定期間保存し、再生できない方法で破棄します。<br>②　別度のDBに移動した会員の個人情報は法律によるではない別の目的で利用いたしません。<br>2． 破棄方法<br>①　電子的ファイルの形態で保存された個人情報は、記録を再生できない技術的な方法を使い、 削除します。<br>②　紙で出力された個人情報は、粉砕機で破棄または焼却を通じて破棄します。<br><br>第１２条　個人情報のための技術的ㆍ管理的対策<br>当社は、会員の個人情報の取扱として個人情報が紛失ㆍ盗難ㆍ漏出ㆍ変調ㆍ毀損にならないように、以下のような技術的ㆍ管理的な対策を講究してます。<br>1．技術的な対策<br>①　会員のバスワードは全て暗号化され、運営者も会員個別のパスワードを認識できないように処置してます。<br>②　許容されないIPに関しては接近権限を置き、当社の内部ネットワークではない場合、個人情報が保存されたサーバーへの接近が不可能になります。また、 許容されないポートへの接近禁止などシステム保安に最善を尽くしてます。<br>③　当社は、暗号化通信などを通してネットワーク上に個人情報が安全に送受信できるようにします。<br>2．管理的な対策<br>①　個人情報の管理責任者は最小限の人員で構成された部署を配置し、個人情報に関する接近権限を制限してます。<br>②　個人情報を収集する職員を向いて新たな保安技術の学びまたは個人情報の保護義務などに関する定期的な社内教育および外部委託教育を実施してます。<br>③　個人情報に関する収集者の業務引受引継は保安が維持する状態で徹底的に行い、入社おそび退社の後個人情報に関する事故による責任を明確にしてます。<br>④　当社は、内部管理者の過失や技術管理上の事故による個人情報が漏出ㆍ変調ㆍ毀損した場合には、即時に会員にその事実を報告し、正確な対策を講究してます。ただし、会員の誤りで個人情報が漏出された場合、当社は何らの責任を負いませんのでIDやパスワードが他人に知らされていないように管理が必要です。<br><br>第１３条　個人情報の管理責任者おとび担当者の連絡先<br>会員の個人情報を保護し、個人情報に関する不満を処理するため、当社は個人情報の管理責任者を選任してます。個人情報に関するお問い合わせは以下の管理責任者に連絡してください。お問い合わせの事項については誠実に遅滞なく応じます。<br><br>個人情報の管理責任者<br>名前 : Yootaek Kim				名前 : Yongseon Yoo<br>チーム : corporate culture			チーム  : CVI<br>Email : helpmaster@paran.com			Email : helpmaster@paran.com<br>Phone : 1588-5668				Phone : 1588-5668 <br><br>なお、その他の個人情報侵害に関する申告、相談が必要な時は以下の機関にお問い合わせてください。<br><br>- Personal Information Infringement Center (www.118.or.kr / +82 2 118)<br>- PRIVACY Mark Certification Committee(http://www.eprivacy.or.kr/ +82 2 580 0533~4)<br>- Supreme Prosecutors’ Office Internet Crime Investigation Center (www.spo.go.kr / +82 2 3480 2000)<br>- Cyber Terror Response Center at the Police Agency (www.spo.go.kr/ +82 2 392 0330) <br><br>第１４条　満14歳未満の児童の個人情報保護<br>1．当社は、会員が満14歳未満の場合、個人情報の収集ㆍ利用に関しては法定代理人の同意を得て行います。<br>2．満14歳未満児童の法定代理人は児童の個人情報に関する閲覧ㆍ訂正ㆍ同意撤回を要求することができ、このような要求が発生した場合、当社は法定代理人の確認後、遅滞なく必要な処置を応じます。<br><br>第１５条　告知の義務<br>法律政策または保安技術の変更による内容の追加ㆍ削除ㆍ修正がある場合、変更する個人情報収集方針を施行する最小７日前までpudding.toウェブサイト(http://pudding.to)、およびpudding.toサービス内の告知事項の画面に公告します。<br><br>公告日字：2012年1月17日<br>施行日字：2012年1月17日<br><br>'
		},
		DEFAULT = 'EN';
	
	return {
		get: function(locale) {
			return PRIVACY_POLICY[String(locale).toUpperCase()] || PRIVACY_POLICY[DEFAULT];
		}
	};
})('kth.puddingto.privacyPolicy'));

})(window);