/**
 * @fileOverview
 * @name kth.puddingto.termsOfUseAgreement.js
 * @author Kim il (blaxtar@kthcorp.com)
 * @version 20120604
 * @lastModified 2012-06-11
 * @created 2012-06-04
 * @description
 * <pre>
 * Pudding.To > 가입하기 > 약관/개인정보 취급방침 > 서비스 약관 전문
 *
 * objects:
 * - {@link kth.puddingto.termsOfUseAgreement} 서비스 약관 전문
 * </pre>
 */
/*jslint browser:true devel:true white:false plusplus:false */
/*global window:true $:true kth:true */
(function(global) {

/**
 * @namespace
 * @name kth.puddingto.termsOfUseAgreement
 * @example
kth.puddingto.termsOfUseAgreement.get('ko');
 */
kth.getPackage('kth.puddingto.termsOfUseAgreement', (function(NAME) {
	var TERMS_OF_USE_AGREEMENT = {
			EN: 'Terms of Use Agreement<br><br>Article 1. Purpose<br><br>The purpose of the Terms of Use is to define rights, obligations, responsibilities, and other necessary matters between KT Hitel Co., Ltd. (hereinafter referred to as "Company") and the Member for use of services provided by the Company.<br><br>Article 2. Definitions<br><br>The definitions of terms used in this Agreement are set forth as follows: <br><br>1. "Member" refers to a customer who logs into the Service of the Company, signs an agreement for use with the Company in accordance with this Agreement, and uses the Service provided by the Company.<br><br>2. “ID” refers to a combination of letters and numbers set by the Member and authorized by the Company for the identification of the Member and use of the Service.<br><br>3. “Password” refers to a combination of letters or numbers set by the Member in order to identify whether the Member matches with the given ID and to protect confidentiality.<br><br>4. “Fee-based Service” refers to the various types of online digital content (including various data content and paid item content) and related services that the Company provides for a charge among the Service.<br> <br>5. “Posting” refers to signs, voices, sounds, videos, posts, images, files, and links that are posted or registered by the Member on the Service provided by the Company.<br><br>6. "Location Information" refers to "Location information" of Article 2(1) and "Personal Location Information" of Article 2(2) of "Act on the Protection, Use, etc, of Location Information (hereinafter "Location Privacy Protection Act").  <br><br>Article 3. Posting and Amendment of the Agreement<br><br>1. The Company shall post the Terms of Use on the front page of http://pudding.to/ (hereinafter the "Website”) so that the Member can easily access the contents.<br><br>2. The Company may amend the Agreement within the scope of not violating relevant laws and international conventions, such as the "Location Privacy Protection Act", "Contents Industry Promotion Act", "Regulation of Standardized Contracts Act" and the "Act on Promotion of Information and Communications Network Utilization and Information Protection, etc." (hereinafter “Information and Communications Network Act").<br> <br>3.  In case of revision of this Agreement, the Company shall post a public notice with clear statement of the application date and the reason of amendment as well as the current Terms of Use from thirty (30) days prior to the application to the day before the application in a way set forth in Clause 1. However, if the amendment is unfavorable to the Member, the Company shall use other electronic means, such as the email registered by the Member, other than just putting a public notice, to clearly notify him/her of the modification.<br><br>4. Notwithstanding the clear statement of the Company, when it gives a notification pursuant to the previous Clause, that the Member would be deemed to have agreed with the amended Terms of Use if he/she does not express any opinion within thirty (30) days, if the Member does not show any disagreement explicitly, the Member shall be deemed to have agreed with the amended version of Terms of Use.<br><br>5. When the Member does not agree to the amended Terms of Use, the Company shall not apply the amended provisions, and the Member may terminate the agreement for use. However, if the original Terms of Use cannot be applied due to specific reasons, the Company may terminate the agreement for use. <br><br>Article 4. Working Rules (Besides Agreement)<br><br>1. The Company may have separate Terms of Use and operation policies ("other Terms of Use") for the Fee-based Service and individual services, and if Other Terms of Use conflict with the content hereof, Other Terms of Use control.<br><br>2. Any matters not provided herein shall be handled in accordance with "Other Terms of Use", relevant laws and legislations (i.e. “Location Privacy Protection Act", "Information and Communications Network Act", "Framework Act on Telecommunications", "Telecommunications Business Act") or the commercial customs.<br><br>3. Given the purpose and intent of the Agreement in accordance with Principle of good faith, the content of the Terms of Use shall be interpreted fairly and reasonably but for the understandability of the average customers shall be interpreted objectively and uniformly.<br>Article 5. Entering into the Agreement for Use<br><br>1. The Agreement for use shall be entered into after the person who wishes to become the Member (the “Applicant”) agrees to the Terms of Use, and applies for a membership, and the Company approves the application.<br><br>2. The Member shall apply for a membership via online or in a way designated by the Company by filling the below items in the application form:<br>1) E-mail ID;<br>2) Profile photo;<br>3) Name;<br>4) Others which the Company regards necessary.<br>  <br>3. The Company shall grant the Applicant the right to use the Service. However, the Company may disallow the Applicant from using the Service, or may terminate the agreement for use afterwards in the following cases where: <br>1) The Applicant had lost his/her membership pursuant to the Terms of Use; <br>2) The Applicant used other person\'s name or a name other than his/her real name; <br>3) The Applicant entered false information, or did not enter the information requested by the Company; <br>4) The Applicant under the age of fourteen (14) did not get the approval from his/her legal representative (parents, etc.) when he/she entered Personal Information; <br>5) An approval is impossible due to the user\'s liability, or the Applicant applies for a membership while violating other related regulations; <br>6) In case that the company is in a difficult situation to agree with the use or the Member is incapacitated or unqualified.<br><br>4. Receiving a membership application pursuant to Clause 1, the Company may request a real name authentication or ID certification.<br> <br>5. The Company may delay the approval when the Service-related facilities are not enough, or there are technical or business issues.<br><br>6. In principle, the Company shall give a notification to the Applicant when it does not approve the membership application or delay the approval in accordance with Clause 3 and 5.<br><br>7. The Company may categorize the Member by grade pursuant to the Company policies, and give differential treatment to the Members in using the Service by segmenting the hours and frequency of use, and the Service menus. <br><br>Article 6. Changes to Member’s Information<br><br>1. The Member may access and modify his/her Personal Information anytime through the personal information page. However, it is impossible to revise IDs that are necessary for the Service management. <br><br>2. The Member shall notify the Company of the change by modifying the information online or by emailing to the Company, when his/her registered information has been changed. <br><br>3. The Company shall take no responsibility for the disadvantages that might occur as a result of the Member not informing the Company of the change described in Clause 2. <br><br>Article 7. Obligations to Protect Personal Information<br><br>The Company shall make efforts to protect Personal Information of the Member in accordance with the relevant laws, including the "Information and Communications Network Act." Regarding the protection and use of Personal Information, the privacy policy of the Company and relevant laws shall be applied. <br><br>Article 8. Obligations to manage Member\'s ID and Password<br><br>1. The Member shall be responsible for managing his/her ID and Password, and a third-party shall be disallowed to use the ID and Password. <br><br>2. The Company may restrict the use of ID, if the Member\'s ID is vulnerable to personal information leakage and against the traditional custom, and antisocial, or confused with the Company or the Company\'s operator. <br><br>3. The Member shall immediately notify the Company of the theft and follow the Company\'s guide when he/she recognizes that his/her ID and Password have been stolen, or used by a third party.<br><br>4. In the case of Clause 3, the Company shall not be responsible for the disadvantages that might occur as a result of the Member not notifying the Company of the fact, or the Member not following the Company’s guide even if he/she notified the Company. <br><br>5. Although the Service supports open IDs, the Company shall not be responsible for matters with respect to the authentication of ID and Password provided and managed by a company which issues and authenticates open IDs.<br><br>Article 9. Notification to Member<br><br>1. When the Company sends a notification to the Member, unless described otherwise herein, the Company may send it to the email address designated by the Member, or through electronic memos or notes within the Service. <br><br>2. When giving notifications to all the Members, the Company may replace the notification described in Clause 1 by putting a post on the Company’s Website or Service for more than seven (7) days. <br><br>Article 10. Obligations of the Company<br><br>1. The Company shall not conduct a behavior that violates relevant laws, the Terms of Use, or the traditional custom, and shall make utmost efforts to provide the Service consistently and stably.<br><br>2. The Company shall have a security system to protect Personal Information (including Personal Location Information and credit information) so that the Member can safely use the Service, and the Company shall publicly announce and abide by the privacy policy. <br><br>3. When the Company acknowledges that the opinions or complaints from the Member with respect to the use of the Service are justified, the Company shall handle them. As for the opinions or complaints from the Member, the Company shall inform the Member of the handling process and results through electronic memos or by email.   <br><br>Article 11. Obligations of Member<br><br>1. Members shall not engage in the behavior set forth as follows:<br><br>1) Registering false information when applying for a membership or modifying information;<br>2) Using the Personal Information of others;<br>3) Posting or transmitting information (such as computer programs) other than the information designated by the Company;<br>4) Infringing on intellectual property rights including copyrights of the Company and a third party; <br>5) Damaging the reputation of the Company and a third party, or disrupting their businesses; <br>6) Disclosing or posting obscene or violent messages, videos, voices and other information that violates the traditional custom in the Service; <br>7) Using the Service for a commercial purpose without the Company’s agreement; <br>8) Collecting other members\' Personal Information and account information;<br>9) Copying, dissembling or modifying the Service through the process, such as reverse engineering, decompiling, or dissembling;<br>10) Disrupting the normal operations of the Service by using the Service through illegal programs such as automatic connection program, other than the Service provided by the Company; <br>11) Conducting other illegal or unjust behaviors. <br><br>2. The Member shall abide by the relevant laws, provisions of the Terms of Use, and guide for the use as well as the Company’s notices and notifications with respect to the Service, and shall not conduct behaviors that may interfere with the Company’s businesses. <br><br>Article 12. Provision of Service <br>1. The Company provides the Member with the following services: <br>1) Pudding.to: Posting pictures/ friend suggestions based on location, mood and tags/communication services;<br>2) Pudding facial recognition: When the Member using the Service transmits her/his photos, it allows to find out which celebrity the Member resembles;<br>3) Provision of information using the current Location Information: Based on the current location of the Members using the Service, POI information or photos of neighboring areas or other related services will be provided;<br>4) Any services that the Company provide to the Member through additional developments or partnership with other companies, etc. <br><br>2. The Company may categorize the Service and designate the hours for use by category. However, such cases shall be notified in advance.  <br><br>3. In principle, the Service is provided all year around, 24 hours a day, 7 days a week. However, in cases of Article 13, the Company may change a time and way to provide the Service or stop providing the Service.<br><br>4. The Company may carry out a routine maintenance when it is needed for providing the Service, and the time of the maintenance shall be the time publicly announced on the service screens or pages. <br><br>Article 13. Changes and Suspension of the Service<br><br>1. The Company may change all or part of services in the following cases where:<br>1) Efficiency or profits get worsening due to the decrease in use; <br>2) A flood of use disrupts the Service;<br>3) There is a maintenance check, repair, replacement, breakdown, or communications cutoff of information and communications facilities like computers, and there are other significant operational issues;<br>4) A common carrier designated by Telecommunications Business Act stops providing electronic communication services Telecommunications service;<br>5) The shift to next generation service is required due to technical improvement;<br>6) The policies of the Company related to the providing of the Service or of Location Information providers change;<br>7) Providing all or part of the Service violates the relevant laws;<br>8) The Service is disrupted due to the national emergency, revision of laws, the court\'s ruling and administrative action or orders;<br>9) The Member disrupts the Service on purpose or by gross negligence;<br>10) Providing the Service by the Company is deemed inappropriate due to other reasons.<br> <br>2. If there is a change to the content of the Service or how and when to use the Service, the Company shall give a notification to the Member in a way set forth in Article 9 (Notification to Member). However, if the Company cannot give a notice beforehand due to unavoidable circumstances, it may notify the Member afterwards. <br><br>3. If it is necessary for the Company’s policies or operation, the Company may change, stop, or modify the Token provided for free or a part or all of the services, and shall not compensate the Member for this, unless otherwise stated in the relevant laws. <br><br>Article 14. Providing Information and Posting Advertisement<br><br>1. The Company, through public notices or emails, may provide various types of information recognized as necessary for the Member to use the Service. However, through email, the Member may refuse to receive the information anytime, except answers from the customer center and the trade-related information in accordance with the relevant laws. <br><br>2. If the Company is to send the information described in Clause 1 through telephones or other transmission devices, the Company shall receive the Member’s consent beforehand. <br><br>3. The Company, regarding the Service operation, may post advertisements on the Service screen, homepage and emails. The Member who receives the emails with advertisements may refuse to receive the emails.<br><br>Article 15. Copyright of Posting <br>1. The copyright of a Posting posted by the Member within the Service shall vest in the author of the Posting, and if the Posting of the Member violates intellectual property rights, causing legal disputes, the Member shall take all the responsibilities. The Member shall grant the right for the Posting on the Company as in the following Clauses. <br><br>2. Rights of Company for the Service   <br>The Posting that the Member posts within the Service may be exposed to search results, the Service, and related promotions, and may be posted modified, copied or edited within the scope necessary for the exposure. <br><br>3. Rights of Company and a third company to use Postings for free<br>Agreeing the Terms of Use and posting on the Service means that the Member allows the following rights to the Company and its partners for free. In such cases, the Company and a third company may alter, change, or modify the Posting of the Member to transmit, post or distribute the Posting on a computer network or media: <br>1) Rights of the Company and a third company to nonexclusively and freely use the Posting concerned across the world through existing and any media to be developed;   <br>2) Rights of the Company and a third company to allow the above case to other third party.<br><br>Article 16. Management of Posting<br><br>1. If the Posting of the Member violates relevant laws, such as the “Information and Communications Network Act” and “Copyright Act,” the right-holder may request that the Posting be taken down or be deleted pursuant to the procedures set forth in the relevant laws, and the Company shall take measures in accordance with the relevant laws. <br><br>2. Even without the request from the right-holder as described in the previous Clause, the Company may take temporary measures on the Posting in accordance with the relevant laws if the Posting infringes on rights, or violates policies of the Company or relevant laws.<br> <br>3. The procedures pursuant to this Article shall follow “Notice AND Take Down” of the Company within the scope set forth in the “Information and Communications Network Act” and “Copyright Act.” http://help.paran.com/faq/report/RightReport.jsp<br><br>Article 17. Ownership of Rights<br><br>1. The Company shall own copyrights and intellectual property rights on the Service. However, the Member’s Postings and the works provided in accordance with partnership contracts shall be excluded.<br><br>2. The Company shall own the ownership and right to use for all intellectual property rights such as trademark, service mark, design, logos and slogans concerning the Service such as the design of the Service provided by the Company, text, scripts, graphics and mutual communications and a function of transmission created by the Company.<br><br>3. 3) The Terms of Use shall not grant the right for Service and related copyright to the Member, but the right to use the Service within the scope designated by the Company. The Member may use the Service as it is provided for the purpose of information collection and personal use. <br>  <br>4. The Member shall not use, copy or distribute the status information of the Member gained through the Service, except the content explicitly allowed by the Company for a commercial purpose and shall not copy or distribute texts, scripts, features of mutual communications between the Member and transmission of graphics.<br>  <br>5. The Company shall grant the Member only the right to use account, ID and content as described in the conditions for the use set by the Company, and the Member shall be prevented from transferring or selling the right, or providing it as collateral. <br><br>Article 18. Member’s Termination/Cancellation of Agreement<br><br>1. The Member may request a withdrawal from his/her membership anytime through the personal information management menus, and the Company shall handle it promptly as set forth in the relevant laws. <br><br>2. If the Member terminates the agreement, all the data about the Member shall be deleted except the case where the Company holds the Member’s information following the relevant laws, privacy policy and policies of the competent authorities.<br><br>3. When the Member terminates the agreement, all the Postings registered in his/her account shall be deleted. However, the Posting registered on others\' account and replies posted on others\' Posting shall not be deleted. <br><br>Article 19. Restrictions on Use<br><br>1. In case that the Member conducts behaviors as listed below or the competent authorities such as Korea Communications Standards Commission request, the Company may restrict his/her use of the Service by giving warning, suspending and stopping the use permanently in stages or may cancel the usage contract without a prior notification:<br>1) The behavior violating this Agreement or disrupting normal operation of the Service;<br>2) The behavior running counter to social morals such as posting obscene contents or having obscene websites linked within the Service for the purpose of sharing;<br>3) The behavior distributing information, phrases, figures and voices of the contents which disrupt public order or morals;<br>4) The behavior defaming or insulting;<br>5) The behavior infringing the right of the Company or a third party such as copyrights and intellectual property rights;<br>6) The behavior producing, importing, transmitting or posting technologies, products or information which are banned from producing, importing, transmitting or posting under the relevant laws and regulations;<br>7) The behavior regarded as associated with a crime; <br>8) The behavior hacking, distributing viruses or continuously transmitting the contents such as advertisement against others\' will; <br>9) The behavior falsely using IDs of other Members or impersonating others;<br>10) The behavior collecting, falsely using, storing or distributing other Member\'s Personal Information;<br>11) The behavior stalking or bullying others;<br>12) The behavior gaining financial benefits or disrupting a normal operation of the Service of the Company by joining or withdrawing numerous times without significant reasons; <br>13) The behavior giving, selling or renting his/her ID; <br>14) The behavior disrupting operation of the Service or violating relevant regulations. <br> <br>2. The Company may immediately terminate the Agreement if the Member violates relevant laws, notwithstanding the steps taken as in the previous Clause, as in the cases where he/she illegally uses other\'s name or makes a payment in other person’s name violating the “Resident Registration Act," provides illegal programs and disrupts the operation violating the “Copyright Act” and “Computer Programs Protection Act,” conducts illegal communications and hacking violating the “Information and Communications Network Act,” distributes malicious programs, and exceeds his/her login authority. When the agreement is terminated in accordance with this Article, all the benefits acquired by using the Service shall be lost, and the Company shall not be responsible for any compensation.<br><br>3. The Company may restrict the use for the protection of the Member’s information and the efficiency of operations when the Member has not logged in for more than three (3) months.<br><br>4. Within the scope of restrictions on use set forth in this Article, the Company shall follow policies regarding restrictions on use when it comes to the conditions and details of restrictions. <br><br>5. The Company shall give a notification to the Member as described in Article 9 (Notification to Member), when restricting the use of the Service or terminating the agreement pursuant to this Article.<br><br>6. In accordance with the procedure set forth by the Company, the Member may raise objections on the restrictions on use described in this Article. In this case, when the Company acknowledges the justification of objections, the Company shall immediately resume the use of the Service. <br><br><br>Article 20. Method to collect Location Information<br><br>The Company collects an individual’s Location Information as listed below:<br>1. Real-time collection in the Cell-ID method utilizing a cell phone; <br>2. Through GPS information collected by a cell phone where a GPS chip is embedded;<br>3. Through Wi-Fi information collected by a cell phone where a Wi-Fi chip is embedded. <br><br>Article 21. Use of Location Information<br><br>1. The Company may use the Location Information or Personal Location Information of the Member for the Service when the Member says yes to \'I agree with the company to use Location Information after logging into the Service through mobile terminals.<br><br>2. In case of the Member who does not agree with the use of Location Information, the use of Location Information may be requested whenever he/she is to use the services using Location Information. Such member may have difficulty in using the normal Service with mobile terminals:<br>1) In case that the Member does not choose an automatic log-in feature, the Member may choose whether to agree with the use of Location Information whenever logging into the Service with mobile terminals;<br>2) 2. In case that the Member does not agree with the use of Location Information, the Company shall not use Location Information; <br>3) In case that the Member is less than 14 years, the Company shall go through a procedure for getting an agreement from a legal representative in accordance with Article 23 of Information and Communications Network Act <br><br>3. The Company shall use Location Information to recommend friends based on the current location of the Member<br><br>4. The Member may request a withdrawal from the Service anytime and in such case, the agreement on the use of Location Information by the Member is deemed to be terminated.<br><br>Article 22. Rights of Member for Personal Location Information <br><br>1. The Member as a subject of Personal Location Information may defer his/her consent to part of the scope of collecting Personal Location Information and Terms of Use, or art of the objective to use/provide Personal Location Information, the scope of recipient, and LBS. <br><br>2. The Member may request temporary suspension on the collection/use/provision of Personal Location Information anytime. In such a case, the Company shall not decline the request, and shall be in possession of technical methods to support such a request.<br><br>3. The Member holds the right to require the Company to access or be notified of below data and in case an error is detected in the below document, the Member may request for correction. In this case, the Company may not decline such request unless it has a proper reason:<br>1) Verification document for confirming collection, use and provision of Location Information <br>2) Details and reasons on providing Personal Location Information of the Member to the third party according to the Act on the Protection, Use, etc. of Location Information as well as other rules and regulations. <br>4. In case the Member withdraws all or part of his/her agreement according to this Article, the Company shall not hesitate to destroy collected Personal Location Information and verification document on the collection/use/provision of Personal Location Information. However, in case the Member withdraws only part of his/her agreement, the object for destruction is confined to verification document on Personal Location Information/ Location Information regarding the section the Member withdraws.<br><br>5. The Member may contact the Company using the Company’s contact information stipulated in Article 31 to exercise his/her right set in Clause 1 and 3.<br><br>Article 23. Rights of Legal Representative<br><br>1. In case the Company collects, uses or provides Personal Location Information of a child under the age of fourteen (14), it is mandatory to receive agreement from the child him/herself as well as his/her legal representative. <br><br>2. In case the legal representative agrees on the collection/use/provision of Personal Location Information of minors under the age of fourteen (14), the legal representative may exercise his right to suspend or withdraw agreement as well as temporarily suspend and right to inspect/require for notice. <br><br>Article 24. Use of Location Information to protect Minors under the Age of Eight(8)<br><br>1. In case that persons responsible for protecting the person of the following cases (hereinafter, Minors under the Age of Eight(8) agree with the collection, use or provision of person location information of Minors under the Age of Eight(8) to protect the life and physical body of Minors under the Age of Eight(8), we assume that Minors under the Age of Eight(8) agree:<br>1) Minors under the Age of Eight(8); <br>2) An incompetent;<br>3) Persons who have mental disorder in accordance with Article 2(2(2)) of Welfare of Disabled Persons Act and severely disabled persons in accordance with Article 2 (2) of Act on Employment Promotion and Vocational Rehabilitation for Disabled Persons(only subject to persons registered as a disabled person in accordance with Article 32 of Welfare of Disabled Persons);<br><br>2. Persons responsible for protecting Minors under the Age of eight(8) in accordance with the above Clause 1 refers to persons who in fact protect Minors under the Age of Eight(8) as listed below:<br>1) A legal representative of Minors under the Age of Eight(8) or a guardian in accordance with Article 3 of Act on the Guardianship of Orphans in Protective Facilities;   <br>2) A legal representative of an incompetent;<br>3) A legal representative stated in Clause 1(3) or head of a facility for the disabled(only subject to a facility established/run by a state or local government) in accordance with Article 58(1(1) of Welfare of Disabled Persons Act, head of a social return facility for a mentally handicapped person in accordance with Article 3(4) of Mental Health Act (only subject to a facility established/run by a state or local government) and head of a mental patient sanatorium in accordance with Article 3(5) of Mental Health Act ;<br><br>3. In case that a person responsible for protecting Minors under the Age of Eight(8) agrees to use or provide Personal Location Information of Minors under the Age of Eight(8), the persons may exercise every right of Minor under the Age of Eight(8), a subject of local information.  <br><br>Article 25. Immediate Notification to Member in Case Personal Location Information is Provided to a Third Party<br><br>1. The Company must not reveal Personal Location Information without consent from the Member to the third party. In case such information is to be provided to the third party, the Company should notify of the receiver and purpose of such revelation to the Member prior to application and obtain consent. <br><br>2. In case the Company provides Personal Location Information to the third party indicated by the Member, Company must immediately notify the Member of receiver and date/purpose of receipt every time such provision takes place through appropriate telecommunication device.<br> <br>3. However in below case, the Company should use telecommunication device or e-mail previously set by the Member, a subject of Personal Location Information, for notification. <br><br>1) If regarding telecommunication device which collected Personal Location Information is not support with text/ voice message or image receiving function;<br>2) In case the Member, a subject of Personal Location Information, made a prior request to send such information to telecommunication device or email other than the device/e-mail used for collecting Provider’s Personal Location Information.<br><br>Article 26. Compensation for Damages<br><br>1. The Company shall be responsible for compensating for damages caused by the intention or gross negligence of the Company in the course of using the Service.<br>2. In cases that the Member damages the Company by violating this Agreement or in the course of using the Service, the Member shall compensate for the Company. <br>3. In case the Member, a subject of Personal Location Information, experiences damages due to the Company’s violation of article 15 or 26 of Act on the Protection, Use, etc. of Location Information, the Provider may request the violating party to compensate for damage. In this case the Company cannot be exempt from the burden of all costs and responsibility unless the Company can prove itself that such violation was not the result of intention or fault. <br><br>Article 27. Limitation of Liability<br><br>1. The Company shall be exempt from any responsibility related to providing the Service in the case where the Company is unable to provide the Service due to natural disasters or any force majeure. <br><br>2. The Company shall not be responsible for Service errors occurred due to the Member’s liability.<br> <br>3. The Company shall not be responsible for the credibility and accuracy of the information, documents and facts that the Member posts regarding the Service. <br><br>4. The Company shall be exempt from any responsibility when there was a trade between Members or between the Member and a third party having the Service as a medium. <br><br>5. The Company shall be exempt from any responsibility when there was a trade between Members or between the Member and a third party having the Service as a medium. <br><br>6. The Company shall not be responsible for the content and quality of products or the Service advertised through the page within the Service or a linked website by a third party.<br><br>7. The Company, employees of the Company and representatives shall not be responsible for damages caused by the following cases:<br>1) A damage caused by false or inaccurate status information of the Member;<br>2) An individual damage caused by accessing and using the Service regardless of the feature of and route to the Service;<br>3) A damage caused by every illegal access to servers or illegal use of servers by a third party; <br>4) Damages caused by all illegal hindrance or suspension on transmission from or to servers by a third party;<br>5) Damages caused by all viruses, spywares and other malicious programs illegally transmitted or distributed by a third party using the Service; <br>6) Damages caused by errors, omission, or destruction of transmitted data;      <br>7) Legal responsibilities due to defamation or other illegal actions occurred in the course of registering Member\'s status information and using the Service.<br><br>Article 28. Use in Foreign Countries<br>The Company shall not guarantee equal quality or serviceability of the Service across the world. Thus, in case the Member is to use the Service, he/she shall determine whether to use in his/her judgment or responsibilities. In particular, the responsibility to abide by local regulations in the course of using the Service lies in the Member. <br><br>Article 29. Settlement of Disputes<br>In case a dispute on Personal or Location Information occurs between the Company and the Member, an agreement is recommended to be made to settle the dispute, and in case of a dispute which does not allow agreement or which cannot come to an agreement, the Company may apply for motions to the Personal Information Dispute Mediation Committee according to Article 43 of Personal Information Protection Act.<br><br>Article 30. Governing Law and Jurisdiction<br>Disputes arising between the Company and the Member shall be governed by the laws of the Republic of Korea. <br>Lawsuits regarding the disputes arising between the Company and the Member shall be brought in the competent court according to the code of Civil Procedure. <br><br>Article 31. The Information of the Company<br>The name, address, and contact information of the Company are as follows; <br>1. Name of company : KT Hitel Co., Ltd <br>2. Address : Samsung Boramae Omni Tower KTH, 395-62, Sindaebang-2 dong, Dongjak-gu, Seoul, Republic of Korea  <br>3. Phone number : 1588-5668 <br><br>Supplementary Provision<br>This Terms of Use shall become effective on January 17,2012.',
			KO: '서비스 이용 약관<br>제1조 [목적]<br>이 약관은 케이티하이텔주식회사(이하 "회사")가 제공하는 푸딩.투 서비스 및 관련 제반 서비스(이하 "서비스")의 이용과 관련하여 "회사"와 "회원"과의 권리, 의무 및 책임사항, 기타 필요한 사항을 규정함을 목적으로 합니다.<br><br>제2조 [정의]<br>이 약관에서 사용하는 용어의 정의는 다음과 같습니다.<br>1. "회원"이라 함은 "회사"의 "서비스"에 접속하여 회원 가입 절차를 이행하고 이 약관에 따라 "회사"와 이용계약을 체결한 후 "회사"가 제공하는 "서비스"를 이용하는 고객을 말합니다.<br>2. "아이디"라 함은 "회원"의 식별과 "서비스" 이용을 위하여 "회원"이 정한 것으로서 "회사"가 승인하는 문자와 숫자의 조합을 의미합니다.<br>3. "비밀번호"라 함은 "회원"이 부여 받은 "아이디"와 일치되는 "회원"임을 확인하고 비밀보호를 위해 "회원" 자신이 정한 문자 또는 숫자의 조합을 의미합니다.<br>4. "유료서비스"라 함은 "서비스" 중 "회사"가 유료로 제공하는 각종 온라인디지털콘텐츠(각종 정보 콘텐츠, 아이템 기타 유료 콘텐츠를 포함) 및 제반 서비스를 의미합니다.<br>5. "게시물"이라 함은 "회원"이 "서비스"를 이용함에 있어 "서비스"상에 게시한 부호ㆍ문자ㆍ음성ㆍ음향ㆍ화상ㆍ동영상 등의 정보 형태의 글, 사진, 동영상 및 각종 파일과 링크 등을 의미합니다.<br>6. "위치정보"라 함은 "위치정보의 보호 및 이용 등에 관한 법률(이하 "위치정보보호법") 제2조 제1호의 "위치정보" 및 제2호의 "개인위치정보"를 말합니다.<br><br>제3조 [약관의 게시와 개정]<br>1. "회사"는 이 약관의 내용을 "회원"이 쉽게 알 수 있도록 http://pudding.to/ (이하 "웹사이트") 초기화면에 게시합니다.<br>2.  "회사"는 "위치정보보호법", "콘텐츠산업 진흥법", "전자상거래 등에서의 소비자보호에 관한 법률", "소비자기본법", "약관의규제에관한법률",  "정보통신망이용촉진및정보보호에관한법률(이하 "정보통신망법")"등 대한민국의 법령과 국제조약을 위배하지 않는 범위에서 이 약관을 개정할 수 있습니다.<br>3. "회사"가 약관을 개정할 경우에는 기존약관과 개정약관 및 개정약관의 적용일자와 개정사유를 명시하여 현행 약관과 함께 제1항의 방식에 따라 그 개정약관의 적용일자 30일 전부터 적용일자 전일까지 공지합니다. 다만, "회원"에게 불리한 내용으로 약관을 개정하는 경우에는 공지 외에 회원정보로 등록된 이메일, 전자쪽지, 로그인시 동의 창 등의 전자적 수단을 통해 별도로 명확히 회원에게 개별적으로 통지합니다.<br>4. "회사"가 전항에 따라 공지하면서 "회원"에게 30일 이내에 개정약관에 대한 거부의 의사표지를 하지 않으면 승인하는 것으로 본다는 뜻을 명확하게 공지하였음에도 "회원"이 명시적으로 거부의 의사표시를 하지 아니한 경우에는 "회원"이 개정약관에 동의한 것으로 봅니다.<br>5. "회원"이 개정약관에 동의하지 않는 경우 "회사"는 당해 "회원"에 대해 개정약관의 내용을 적용할 수 없으며, 이 경우 "회원"은 이용계약을 해지할 수 있습니다. 다만, 당해 "회원"에 대해 기존 약관을 적용할 수 없는 특별한 사정이 있을 경우에는 "회사"는 이용계약을 해지할 수 있습니다.<br><br>제4조 [약관 외 준칙 등]<br>1. "회사"는 "유료서비스" 및 개별 서비스에 대해서 별도의 이용약관 및 정책("기타 약관 등" 이라 함)을 둘 수 있으며, 해당 내용이 이 약관과 상충할 경우에는 "기타 약관 등"이 우선하여 적용됩니다.<br>2. 이 약관에서 명시되지 아니한 사항에 대해서는 회사의 "기타 약관 등" 및 "위치정보보호법", "정보통신망법", "전기통신기본법", "전기통신사업법"등 관계법령 또는 상관례에 따릅니다.<br>3. 약관의 내용은 신의성실의 원칙에 따라 당해 약관의 목적과 취지를 고려하여 공정하고 합리적으로 해석하되 평균적 고객의 이해가능성을 기준으로 객관적, 획일적으로 해석합니다.<br><br>제5조 [이용계약 체결]<br>1. 이용계약은 "회원"이 되고자 하는 자(이하 "가입신청자")가 약관 내용에 대하여 동의를 한 다음 "회원"가입신청을 하고 "회사"는 이러한 신청에 대하여 승낙함으로써 체결됩니다.<br>2. "회원" 가입신청은 온라인 또는 회사가 정한 별도의 가입방법으로 다음 사항을 정해진 양식 및 방법에 의하여 기록하여 신청합니다.<br>① 이메일 아이디<br>② 프로필 사진<br>③ 이름<br>④ 기타 회사가 필요하다고 인정하는 사항<br>3. "회사"는 "가입신청자"의 "회원" 가입신청이 있는 경우 "서비스" 이용을 승낙함을 원칙으로 합니다. 다만, "회사"는 다음 각 호의 1에 해당하는 신청에 대해서는 승낙을 하지 않거나 사후에 다음 각 호의 1에 해당하는 사유가 있었음을 인지하게 되는 경우 "서비스" 이용을 제한하거나 승낙을 철회할 수 있습니다.<br>① "가입신청자"가 이 약관에 의하여 이전에 "회원" 자격을 상실한 적이 있는 경우<br>② 타인의 명의를 이용한 "회원" 가입 신청의 경우<br>③ 허위의 정보를 기재하거나, "회사"가 요구하는 내용을 기재하지 않은 경우<br>④ 14세 미만 아동이  "개인정보" 입력 시 법정대리인(부모 등)의 동의를 얻지 아니한 경우<br>⑤ "가입신청자"의 귀책사유로 인하여 승인이 불가능하거나 기타 규정한 제반 사항을 위반하며 신청하는 경우<br>⑥ 기타 "회사"의 여건상 이용승낙이 곤란하거나 가입결격 사유에 해당하는 경우<br>4. 제1항에 따른 신청에 있어 "회사"는 "가입신청자"의 종류에 따라 전문기관을 통한 실명확인 및 본인인증을 요청할 수 있습니다.<br>5. "회사"는 "서비스" 관련 설비의 여유가 없거나, 기술상 또는 업무상 문제가 있는 경우에는 승낙을 유보할 수 있습니다.<br>6. 제3항과 제5항에 따라 "회원"가입신청의 승낙을 하지 아니하거나 유보한 경우, "회사"는 원칙적으로 이를 "가입신청자"에게 알리도록 합니다.<br>7. "회사"는 "회원"에 대해 회사정책에 따라 등급별로 구분하여 이용시간, 이용횟수, 서비스 메뉴 등을 세분하여 이용에 차등을 둘 수 있습니다.<br><br>제6조 ["회원"정보의 변경]<br>1. "회원"은 프로필 화면을 통하여 언제든지 본인의 개인정보를 열람하고 수정할 수 있습니다. 다만, "서비스" 관리를 위해 필요한 이메일 아이디는 수정이 불가능합니다.<br>2. "회원"은 "회원"가입신청 시 기재한 사항이 변경되었을 경우 온라인으로 수정을 하거나 전자우편 기타방법으로 "회사"에 대하여 그 변경사항을 알려야 합니다.<br>3. "회원"이 제2항의 변경사항을 "회사"에 알리지 않아 발생한 불이익에 대하여 "회사"는 책임지지 않습니다.<br><br>제7조 [개인정보보호 의무]<br>"회사"는 "정보통신망법"등 관계 법령이 정하는 바에 따라 "회원"의 "개인정보"를 보호하기 위해 노력합니다. "개인정보"의 보호 및 사용에 대해서는 관련법 및 "회사"의 "개인정보취급방침"이 적용됩니다.<br><br>제8조 ["회원"의 "아이디" 및 "비밀번호"의 관리에 대한 의무]<br>1. "회원"의 "아이디"와 "비밀번호"에 관한 관리책임은 "회원"에게 있으며, 이를 제3자가 이용하도록 하여서는 안 됩니다.<br>2. "회사"는 "회원"의 "아이디"가 개인정보 유출의 우려가 있거나, 반사회적 또는 미풍양속에 어긋나거나 "회사" 및 "회사"의 운영자로 오인할 우려가 있는 경우, 해당 "아이디"의 이용을 제한할 수 있습니다.<br>3. "회원"은 "아이디" 및 "비밀번호"가 도용되거나 제3자가 사용하고 있음을 인지한 경우에는 이를 즉시 "회사"에 통지하고 "회사"의 안내에 따라야 합니다.<br>4. 제3항의 경우 해당 "회원"이 "회사"에 그 사실을 통지하지 않거나, 통지한 경우에도 "회사"의 안내에 따르지 않아 발생한 불이익에 대하여 "회사"는 책임지지 않습니다.<br>5. 본 "서비스"는 오픈아이디를 지원하나 오픈아이디의 발급, 인증서비스 업체가 제공 및 관리하는 "아이디", "비밀번호" 인증 등과 관련된 부분에 대해서는 "회사"는 책임지지 않습니다.<br><br>제9조 ["회원"에 대한 통지]<br>1. "회사"가 특정 "회원"에 대해 개별적으로 통지를 하는 경우 이 약관에 별도 규정이 없는 한 "서비스"에 "회원"이 등록한 전자우편주소, "서비스" 내의 전자쪽지 등으로 할 수 있습니다.<br>2. "회사"는  "회원" 전체에 대한 통지의 경우 7일 이상 "회사"의 "웹사이트" 또는 "서비스" 내 화면에 게시함으로써 제1항의 통지에 갈음할 수 있습니다.<br><br>제10조 ["회사"의 의무]<br>1. "회사"는 관련 법령과 본 약관이 금지하거나 미풍양속에 반하는 행위를 하지 않으며, 계속적이고 안정적으로 "서비스"를 제공하기 위하여 최선을 다하여 노력합니다.<br>2. "회사"는 "회원"이 안전하게 "서비스"를 이용할 수 있도록 개인정보(개인위치정보 및 신용정보 포함)보호를 위해 보안시스템을 갖추어야 하며 개인정보취급방침을 공시하고 준수합니다.<br>3. "회사"는 "서비스"이용과 관련하여 "회원"으로부터 제기된 의견이나 불만이 정당하다고 인정할 경우에는 이를 처리하여야 합니다. "회원"이 제기한 의견이나 불만사항에 대해서는 전자쪽지 또는 전자우편 등을 통하여 "회원"에게 처리과정 및 결과를 전달합니다.<br><br>제11조 ["회원"의 의무]<br>1. "회원"은 다음 각 호의 1에 해당하는 행위를 하여서는 안 됩니다.<br>① 신청 또는 변경 시 허위내용의 등록<br>② 타인의 정보도용<br>③ "회사"가 정한 정보 이외의 정보(컴퓨터 프로그램 등)등의 송신 또는 게시<br>④ "회사"와 기타 제3자의 저작권 등 지적재산권에 대한 침해<br>⑤ "회사" 및 기타 제3자의 명예를 손상시키거나 업무를 방해하는 행위<br>⑥ 외설 또는 폭력적인 메시지, 화상, 음성, 기타 공서양속에 반하는 정보를 "서비스"에 공개 또는 게시하는 행위<br>⑦ "회사"의 동의 없이 영리를 목적으로 "서비스"를 사용하는 행위<br>⑧ 다른 "회원"의 개인정보 및 계정정보를 수집하는 행위<br>⑨ 리버스엔지니어링, 디컴파일, 디스어셈블 및 기타 일체의 가공행위를 통하여 "서비스"를 복제, 분해 또는 모방 기타 변형하는 행위<br>⑩ "회사"가 제공하는 "서비스" 이외의 다른 방법으로 "서비스"를 이용(자동 접속 프로그램 등)하여 "회사"의 정상적인 "서비스" 제공을 방해하는 행위<br>⑪ 기타 불법적이거나 부당한 행위<br>2. "회원"은 관계법령, 본 약관의 규정, 이용안내 및 "서비스"와 관련하여 공지한 주의사항, "회사"가 통지하는 사항 등을 준수하여야 하며, 기타 "회사" 업무에 방해되는 행위를 하여서는 안 됩니다.<br><br>제12조 ["서비스"의 제공 등]<br>1. "회사"는 "회원"에게 다음 각 호의 1과 같은 "서비스"를 제공합니다.<br>① 푸딩.투 : 사진 게시 / 비슷한 장소, 감정상태, 태그 기반으로 친구 추천 / 대화하기의 커뮤니케이션 서비스<br>② 푸딩 얼굴인식 : "서비스"를 이용하는 "회원"이 촬영한 얼굴사진을 "서비스"에 전송하면 회원의 얼굴사진을 인식하여 닮은꼴 연예인을 매칭 시켜주는 서비스.<br>③ 현재 위치를 활용한 정보 제공 : "서비스"를 이용하는 "회원"의 현재 위치를 활용하여 주변 지역의 POI정보 또는 주변의 사진정보를 제공하는 행위 및 그에 관계된 부수적 행위<br>④ 기타 "회사"가 추가 개발하거나 다른 "회사"와의 제휴계약 등을 통해 "회원"에게 제공하는 일체의 서비스<br>2. "회사"는 "서비스"를 일정 범위로 분할하여 각 범위 별로 이용가능시간을 별도로 지정할 수 있습니다. 다만 이러한 경우에는 그 내용을 사전에 공지합니다.<br>3. "서비스"는 연중무휴, 1일 24시간 제공함을 원칙으로 합니다. 단, "회사"는 제13조["서비스"의 변경 및 중단] 사유가 발생한 경우 각 서비스 별로 제공일정 및 제공방법을 변경하거나 서비스를 제공하지 아니할 수 있습니다.<br>4. "회사"는 "서비스"의 제공에 필요한 경우 정기점검을 실시할 수 있으며, 정기점검시간은 "서비스" 제공화면에 공시한 바에 따릅니다.<br><br>제13조 ["서비스"의 변경 및 중단]<br>1. "회사"는 다음 각 호의 1에 해당하는 사유가 발생하는 경우 "서비스"의 전부 또는 일부를 제한, 변경 또는 중단할 수 있습니다.<br>① 이용량 감소로 인한 효율이나 수익성 악화의 경우<br>② 이용량 폭주로 인해 원활한 "서비스" 제공에 지장이 있는 경우<br>③ 컴퓨터 등 정보통신설비의 보수점검, 교체 및 고장, 통신두절 또는 운영상 상당한 이유가 있는 경우<br>④ 전기통신사업법에 규정된 기간통신사업자가 전기통신 서비스를 중단했을 경우<br>⑤ 기술 진보에 따른 차세대 서비스로의 전환 필요성<br>⑥ "서비스" 제공과 관련한 "회사" 또는 위치정보사업자의 정책 변경<br>⑦ 관련 법령의 해석상 "서비스"의 전부나 일부를 이행하는 것이 위법의 요소가 있는 경우<br>⑧ 국가비상사태, 법령의 재개정, 법원의 판결, 행정기관의 처분, 명령 등으로 "서비스"제공에 지장이 있는 경우<br>⑨ "회원"이 "서비스" 운영을 고의 또는 중과실로 방해하는 경우<br>⑩ 기타 사유로 인하여 "회사"가 "서비스" 제공을 지속하는 것이 부적당하다고 인정하는 경우<br>2. "회사"는 "서비스"의 내용, 이용방법, 이용시간에 대하여 변경이 있거나 "서비스"의 중단이 있는 경우에는 "회원"에게 제9조["회원"에 대한 통지]에 정한 방법으로 변경 및 중단 사유, 변경되는 "서비스"의 내용과 제공일자 등을 통지합니다. 다만, "회사"가 사전에 통지할 수 없는 부득이한 사유가 있는 경우 사후에 통지할 수 있습니다.<br>3. "회사"는 무료로 제공되는 "서비스"의 일부 또는 전부를 "회사"의 정책 및 운영의 필요상 수정, 중단, 변경하는 경우와 관련하여 관련법에 특별한 규정이 없는 한 "회원"에게 별도의 보상을 하지 않습니다.<br><br>제14조 [정보의 제공 및 광고의 게재]<br>1. "회사"는 "회원"이 "서비스" 이용 중 필요하다고 인정되는 다양한 정보를 "웹사이트"나 전자우편 등의 방법으로 "회원"에게 제공할 수 있습니다. 다만, "회원"은 관련법에 따른 거래관련 정보, 고객센터 답변 등을 제외하고 언제든지 전자우편 등을 통하여 수신 거부를 할 수 있습니다.<br>2. 제1항의 정보를 전화 및 모사전송 기기에 의하여 전송하려고 하는 경우에는 "회원"의 사전 동의를 받아서 제공합니다.<br>3. "회사"는 "서비스"의 운영과 관련하여 "서비스" 화면, "웹사이트", 전자우편 등에 광고를 게재할 수 있습니다. 광고가 게재된 전자우편을 수신한 "회원"은 수신거부의 의사를 "회사"에 표시할 수 있습니다.<br><br>제15조 ["게시물"에 대한 "회원"의 권리와 "회사"의 이용권한]<br>1. "회원"이 "서비스" 내에 게시한 "게시물"의 권리는 원칙적으로 해당 "게시물"의 권리자에게 귀속되며, "회원"의 "게시물이 제3자의 저작권 등 지적재산권을 침해함으로써 발생하는 민ㆍ형사상의 책임은 전적으로 "회원"이 부담하여야 합니다. "회원"은 "회사"에게 아래 각 항과 같이 "게시물"에 관한 권리를 부여합니다.<br>2. "회사"의 "서비스" 관련 사용 권한<br>"회사"는 "회원"의 "게시물"을 검색결과, "서비스" 관련 프로모션 등에 노출할 수 있으며, 해당 노출을 위해 필요한 범위 내에서는 일부 수정, 복제, 편집하여 게시할 수 있습니다.<br>3. "회사" 및 제3업체의 게시물 무상 이용권<br>"회원"이 본 약관에 동의한 후 "서비스" 상에 게시물을 게재하는 것은, 아래와 같은 권리를 "회사"나 "회사"가 제휴한 제3업체에 대해 무상으로 허락하는 것으로 간주합니다. 이 때 "회사"나 제3업체는 컴퓨터 네트워크나 미디어 상에서 전송, 게시 또는 배포하기 위해 "회원"의 "게시물"을 변경, 수정, 변형할 수 있습니다.<br>①  "회사"나 제3업체가 현재 존재하거나 장래에 개발될 수 있는 어떠한 매체를 통해서라도, 당해 "게시물"을 전세계에 걸쳐 비독점적으로 자유롭게 이용(복사, 복제, 처리, 각색, 변경, 공표, 전송, 게재 또는 배포 등을 포함)할 수 있는 권리<br>② "회사"나 제3업체가 위 ①호의 권리를 다른 제3자에게 재허락할 수 있는 권리<br><br>제16조 ["게시물"의 관리]<br>1. "회원"의 "게시물"이 "정보통신망법", "저작권법", "청소년보호법" 등 현행 법령이나 공서양속에 위반되는 내용을 포함하여 피해자나 권리자가 관련 법령이 정한 절차에 따라 해당 게시물의 게시중단 및 삭제 등을 요청하는 경우, "회사"는 관련 법령에 따른 조치를 취할 수 있습니다.<br>2. "회사"는 전항에 따른 권리자의 요청이 없는 경우라도 권리침해가 인정될 만한 사유가 있거나 공서양속 기타 "회사" 정책 및 관련 법령에 위반된다고 판단하는 경우에는 관련 법령에 따라 해당 게시물에 대해 삭제나 열람금지 등의 임시 조치 등을 취할 수 있습니다.<br>3. 본 조에 따른 세부절차는 "정보통신망법",  "저작권법" 등 관련 법령이 규정한 범위 내에서 "회사"가 정한 방침에 에 따릅니다. http://help.paran.com/faq/report/RightReport.jsp<br><br>제17조 [권리의 귀속]<br>1. "서비스"에 대한 저작권 및 지적재산권은 "회사"에 귀속됩니다. 단, "회원"의 "게시물" 및 제휴계약에 따라 제공된 저작물은 제외합니다.<br>2. "회사"가 제공하는 "서비스"의 디자인, "회사"가 만든 텍스트, 스크립트(script), 그래픽, "회원" 상호간 커뮤니케이션 및 전송 기능 등 "회사"가 제공하는 "서비스"에 관련된 모든 상표, 서비스표, 디자인, 로고, 슬로건 등에 관한 저작권 등 모든 지적재산권은 대한민국 법령과 국제조약에 기하여 "회사"에게 소유권 또는 사용권이 있습니다.<br>3. "회원"은 본 이용약관으로 인하여 "서비스" 및 그에 관한 저작권 기타 권리를 취득하는 것은 아니며, "회사"가 정한 범위 내에서의 "서비스" 이용권만을 허락받게 되는바, "회원"은 "서비스"를 정보취득 또는 개인적 사용 용도 하에서 "회사"로부터 "제공되는 형태 그대로만 이용할 수 있습니다.<br>4. "회원"은 "회사"로부터 명시적으로 허락된 내용을 제외하고는, "서비스"를 통해 얻어지는 "회원" 상태정보를 영리목적으로 사용, 복사, 유통하지 못하고 "회사"가 만든 텍스트, 스크립트, 그래픽의 "회원" 상호간 커뮤니케이션 및 전송기능 등을 복사하거나 유통할 수 없습니다.<br>5. "회사"는 "서비스"와 관련하여 "회원"에게 "회사"가 정한 이용조건에 따라 계정, "아이디", 콘텐츠 등을 이용할 수 있는 이용권만을 부여하며, "회원"은 이를 타인에게 양도ㆍ판매ㆍ담보제공ㆍ이용허락 할 수 없습니다.<br><br>제18조 ["회원"의 이용계약 해지 등]<br>1. "회원"은 언제든지 계정관리 메뉴를 통하여 "서비스" 탈퇴 신청을 하는 방법으로 이용계약을 해지할 수 있으며, "회사"는 관련 법령과 내부기준이 등이 정하는 바에 따라 이를 즉시 처리하여야 합니다.<br>2. "회원"이 이용계약을 해지할 경우, "회사"는 관련 법령 및 개인정보취급방침, 관계 당국의 방침 등에 따라 "회사"가 기록ㆍ보존하여야 하는 경우를 제외하고는 해지 즉시 "회원"에 관련된 모든 정보를 삭제합니다.<br>3. "회원"이 이용계약을 해지하는 경우 "회원" 계정에 등록한 게시물 일체는 삭제됩니다. 단, 타인 계정에 등록한 "게시물", 타인의 "게시물"에 달은 댓글 등의 "게시물"은 삭제되지 않습니다.<br><br>제19조 [이용제한 등]<br>1. "회사"는 "회원"이 다음 각 호의 1에 해당하는 행위를 하거나 방송통신심의위원회 등 관계기관의 요청이 있는 경우, 사전통지 없이 당해 "회원"과의 이용계약을 해지하거나 경고, 일시정지, 영구정지등으로 "서비스" 이용을 단계적으로 제한할 수 있습니다.<br>① 본 약관의 의무를 위반하거나 "서비스"의 정상적인 운영을 방해하는 행위<br>② "서비스"의 저장공간에 음란물을 게재하거나 음란사이트를 링크하거나, 이를 배포하는 등 공서양속을 해치는 행위<br>③ 공공질서 또는 미풍양속에 위배되는 내용의 정보, 문장, 도형, 음성 등을 유포하는 행위<br>④ 타인의 명예를 훼손 또는 모욕하는 행위<br>⑤ "회사" 또는 제 3자의 저작권, 지적재산권 등 기타 권리를 침해하는 행위 또는 "서비스"에 게재된 자료 및 저작물의 발신인을 위조하는 행위<br>⑥ 관계 법령에 의하여 그 제조, 수입, 전송 또는 게시가 금지되는 기술, 제품, 정보의 제조, 수입, 전송 또는 게시 행위<br>⑦ 범죄와 결부된다고 판단되는 행위<br>⑧ 해킹 또는 컴퓨터 바이러스를 유포하거나 타인의 의사에 반하여 광고성 정보 등 일정한 내용을 지속적으로 전송하는 행위<br>⑨ 다른 "회원"의 "아이디"를 부정 사용하거나 타인을 사칭하는 행위<br>⑩ 다른 "회원"의 개인 정보를 수집, 도용, 저장하거나 이를 유포하는 행위<br>⑪ 타인을 스톡(stalk)하거나, 괴롭히는 행위<br>⑫ 정당한 사유 없이 "회원" 가입과 탈퇴를 수차례 반복하여 금전적 이득을 취하거나 "회사"의 "서비스" 운영에 지장을 초래하는 행위<br>⑬ 본인의 "아이디"를 타인에게 양도ㆍ매매하거나 이용하게 하는 행위<br>⑭ 기타 "서비스"의 운영에 지장을 주거나 줄 우려가 있는 일체의 행위 및 관계 법령에 위배되는 행위<br>2. "회사"는 전항에도 불구하고, "주민등록법"을 위반한 명의도용 및 결제도용, "저작권법" 을 위반한 불법프로그램의 제공 및 운영방해, "정보통신망법"을 위반한 불법통신 및 해킹, 악성프로그램의 배포, 접속권한 초과행위 등과 같이 관련법령을 위반한 경우에는 즉시 이용계약을 해지할 수 있습니다. 본 항에 따른 이용계약 해지시 "회원"이 "서비스" 이용을 통해 획득한 혜택 등도 모두 소멸되며, "회사"는 이에 대해 별도로 보상하지 않습니다.<br>3. "회사"는 "회원"이 계속해서 3개월 이상 로그인하지 않는 경우, "회원" 정보의 보호 및 운영의 효율성을 위해 이용을 제한할 수 있습니다.<br>4. 본 조의 이용제한 범위 내에서 제한의 조건 및 세부내용은 "회사"가 정한 이용제한정책 등에서 정한 바에 의합니다.<br>5. 본 조에 따라 "서비스" 이용을 제한하거나 계약을 해지하는 경우에는 "회사"는 제9조 ["회원"에 대한 통지]의 방법에 따라 통지합니다.<br>6. "회원"은 본 조에 따른 이용제한 등에 대해 "회사"가 정한 절차(이용제한 등 조치에 대한 통지메일에서 안내함)에 따라 이의신청을 할 수 있습니다. 이 때 이의가 정당하다고 "회사"가 인정하는 경우 "회사"는 즉시 "서비스"의 이용을 재개합니다.<br><br>제20조 [위치정보 수집방법]<br>"회사"는 위치정보사업자가 아래의 방법 중 하나 혹은 이들을 조합하여 수집한 위치정보를 "서비스"의 데이터로 사용할 수 있습니다.<br>1. 휴대폰 단말기를 이용한 기지국 기반(Cell ID방식)의 실시간 위치정보 수집<br>2. GPS칩이 내장된 전용 단말기를 통해 수집되는 GPS 정보를 통한 위치정보 수집<br>3. Wi-Fi칩이 내장된 전용 단말기를 통해 수집되는 Wi-Fi정보를 통한 위치정보 수집<br><br>제21조 [위치정보의 이용]<br>1. "회사"는 "회원"이 모바일 단말기에서 "서비스"에 접속한 후 최초 1회 "위치정보 이용에 동의한다"는 의사를 표시하면 그 이후부터 해당 "회원"의 위치정보 혹은 개인위치정보를 "서비스"에 이용할 수 있습니다.<br>2. "서비스" 접속 후 "위치정보이용"에 동의하지 않은 "회원"인 경우 위치정보를 사용하는 기능을 이용하려고 할 때마다 "위치정보이용"에 관한 동의 요청을 할 수 있습니다. 동의하지 않은 "회원"의 경우 모바일 단말기에서 정상적인 "서비스" 이용이 어려울 수 있습니다.<br>① "회원"이 모바일단말기에서 자동 로그인 기능을 선택하지 않는 경우, "회원"은 모바일단말기에서 "서비스"에 로그인할 때마다 "위치정보이용" 동의 여부를 선택할 수 있습니다.<br>② "회사"는 "회원"이 "위치정보이용"에 동의하지 않은 경우에는 위치정보를 이용하지 않습니다.<br>③ "회원"이 만14세 미만의 아동인 경우 "회사"는 정보통신망법 제23조에 따라 법정대리인의 동의를 얻는 절차를 거칩니다.<br>3. "회사"는 "회원"의 현재 위치를 기반으로 친구를 추천하기 위하여 "위치정보"를 이용합니다.<br>4. "회원"은 원하는 경우 언제든지 "서비스" 탈퇴를 할 수 있으며, "서비스" 탈퇴의 경우 위치정보 이용에 대한 "회원"의 동의를 철회하는 것으로 간주합니다.<br><br>제22조 ["회원"의 개인위치정보에 대한 권리]<br>1. "회원"은 개인위치정보의 주체로서 개인위치정보 수집범위, 이용약관, 개인위치정보의 수집ㆍ이용ㆍ제공목적에 대한 동의, 제공받는 자의 범위 또는 위치기반서비스 등의 전부 또는 일부에 대하여 동의를 유보할 수 있습니다.<br>2. "회원"은 언제든지 개인위치정보의 수집ㆍ이용ㆍ제공의 일시적인 중지를 요구할 수 있습니다. "회사"는 이와 같은 요구를 거절하지 아니하며, 이를 위한 기술적 수단을 갖추고 있습니다.<br>3. "회원"은 "회사"에 대하여 다음 각 호와 같은 자료의 열람 또는 고지를 요구할 수 있고, 당해 자료에 오류가 있는 경우에는 그 정정을 요구할 수 있습니다. 이 경우 "회사"는 정당한 이유 없이 요구를 거절하지 아니합니다.<br>① 위치정보의 수집ㆍ이용ㆍ제공사실 확인자료<br>② 개인위치정보가 "위치정보보호법" 기타 다른 법령의 규정에 의하여 제3자에게 제공된 이유 및 내용<br>4. "회사"는 "회원"이 본 조에 따라 동의의 전부 또는 일부를 철회한 경우에는 지체 없이 수집된 개인위치정보 및 위치정보 수집ㆍ이용ㆍ제공사실 확인자료를 파기합니다. 단, 동의의 일부를 철회하는 경우에는 철회하는 부분의 개인위치정보 및 위치정보 수집ㆍ이용ㆍ제공사실 확인자료에 한합니다.<br>5. "회원"은 제1항 내지 제3항의 권리행사를 위하여 이 약관 제31조의 연락처를 이용하여 "회사"에 요구할 수 있습니다.<br><br>제23조 [법정대리인의 권리]<br>1. "회사"는 만14세 미만 아동으로부터 개인위치정보를 수집ㆍ이용ㆍ제공하고자 하는 경우에는 만14세 미만 아동과 그 법정대리인의 동의를 받아야 합니다.<br>2. 법정대리인은 만14세 미만 아동의 개인위치정보를 수집ㆍ이용ㆍ제공에 대한 동의권, 동의유보권, 동의철회권 및 일시중지권, 열람ㆍ고지요구권을 행사할 수 있습니다.<br><br>제24조 ["8세 이하 아동 등"의 보호를 위한 위치정보 이용]<br>1. 다음 각 호의 1에 해당하는 자(이하 "8세 이하 아동 등")의 보호의무자가 "8세 이하 아동 등"의 생명 또는 신체의 보호를 위하여 "8세 이하 아동 등"의 개인위치정보에 대한 수집ㆍ이용 또는 제공에 동의하는 경우에는 본인의 동의가 있는 것으로 봅니다.<br>① 8세 이하의 아동<br>② 금치산자<br>③ 장애인복지법 제2조 제2항 제2호 규정에 의한 정신적 장애를 가진 자로서 장애인고용촉진 및 직업재활법 제2조 제2호의 규정에 의한 중증장애인에 해당하는 자(장애인복지법 제32조의 규정에 의하여 장애인 등록을 한 자에 한함)<br>2. 제1항 규정에 의한 "8세 이하 아동 등"의 보호의무자는 "8세 이하 아동 등"을 사실상 보호하는 자로서 다음 각 호의 1에 해당하는 자를 의미합니다.<br>① "8세 이하의 아동의 법정대리인 또는 보호시설에 있는 미성년자의 후견직무에 관한 법률 제3조의 규정에 의한 후견인<br>② 금치산자의 법정대리인<br>③ 제1항 제3호의 자의 법정대리인 또는 장애인복지법 제58조 제1항 제1호의 규정에 의한 장애인생활시설(국가 또는 지방자치단체가 설치ㆍ운영하는 시설에 한함)의 장, 정신보건법 제3조 제4호의 규정에 의한 정신질환자 사회복귀시설(국가 또는 지방자치단체가 설치ㆍ운영하는 시설에 한함)의 장, 정신보건법 제3조 제5호의 규정에 의한 정신요양시설의 장<br>3. 보호의무자는 "8세 이하 아동 등"의 개인위치정보 이용 또는 제공에 동의하는 경우, 위치정보의 주체인 "8세 이하 아동 등"의 권리 전부를 행사할 수 있습니다.<br><br>제25조 [개인위치정보 제3자 제공시 즉시 통보]<br>1. "회사"는 "회원"의 동의 없이 "회원"의 개인위치정보를 제3자에게 제공하지 아니하며, 만약 제3자에게 이를 제공하는 경우에는 제공 받는 자와 제공목적을 사전에 "회원"에게 고지하고 동의를 받습니다.<br>2. "회사"는 "회원"의 개인위치정보를 당해 "회원"이 지정하는 제3자에게 제공하는 경우에는, 제공 시마다 개인위치정보를 수집한 당해 "회원"의 통신단말장치로 개인위치정보를 제공받는 자, 제공일시 및 제공목적을 즉시 통보합니다.<br>3. 다만, 각 호의 1에 해당하는 경우에는 개인위치정보의 주체인 "회원"이 미리 특정하여 지정한 통신단말장치 또는 전자우편주소 등으로 통보합니다.<br>① 개인위치정보를 수집한 당해 통신단말장치가 문자, 음성 또는 영상의 수신기능을 갖추지 아니한 경우<br>② 개인위치정보의 주체인 "회원"이 개인위치정보를 수집한 당해 통신단말장치 외의 통신단말장치 또는 전자우편주소 등으로 통보할 것을 미리 요청한 경우<br><br>제26조 [손해배상]<br>1. "회사"는 "회원"이 "서비스"를 이용함에 있어 "회사"의 고의 또는 중대한 과실로 인하여 입은 손해를 배상할 책임을 부담합니다.<br>2. "회원"이 본 약관의 의무를 위반함으로 인하여 "회사"에 손해를 입힌 경우 또는 "회원"이 "서비스"를 이용함에 있어 "회사"에 손해를 입힌 경우에 "회원"은 "회사"에 대하여 그 손해를 배상하여야 합니다.<br>3. 개인위치정보의 주체인 "회원"이, "회사"가 "위치정보보호법" 제15조 내지 제26조의 규정을 위반하는 행위로 인하여 손해를 입은 경우에는, "회사"에 대하여 손해배상을 청구할 수 있습니다. 이 경우 "회사"는 고의 또는 과실이 없음을 입증하지 아니하면 책임을 면할 수 없습니다.<br><br>제27조 [책임제한]<br>1. "회사"가 천재지변 또는 이에 준하는 불가항력으로 인하여 "서비스"를 제공할 수 없는 경우에는 "서비스" 제공 의무 위반책임이 면제됩니다.<br>2. "회사"는 "회원"의 귀책사유로 인한 "서비스" 이용의 장애에 대하여는 책임을 지지 않습니다.<br>3. "회사"는 "회원"이 "서비스"와 관련하여 게재한 정보, 자료, 사실의 신뢰도, 정확성 등의 내용에 관하여는 책임을 지지 않습니다<br>4. "회사"는 "회원" 상호간 또는 "회원"과 제3자 상호간에 "서비스"를 매개로 하여 거래 등을 함으로써 "회원" 또는 거래상대방인 제3자에게 발생한 손해에 대하여 책임을 지지 않습니다.<br>5. "회사"는 "서비스" 중 무료로 제공되는 영역에 관하여는 그 이용과 관련하여 관련 법령에 특별한 규정이 없는 한 책임을 지지 않습니다.<br>6. "회사"는 제3자가 "서비스" 내 화면 또는 링크된 웹사이트를 통하여 광고한 제품 또는 "서비스"의 내용과 품질에 대하여 감시할 의무 기타 어떠한 책임도 지지 아니합니다.<br>7. "회사" 및 "회사"의 임직원 그리고 대리인은 다음 각 호의 1과 같은 사항으로부터 발생하는 손해에 대해 책임을 지지 아니합니다.<br>① "회원"의 상태정보의 허위 또는 부정확성에 기인하는 손해<br>② 그 성질과 경위를 불문하고 "서비스"에 대한 접속 및 "서비스"의 이용과정에서 발생하는 개인적인 손해<br>③ 서버에 대한 제3자의 모든 불법적인 접속 또는 서버의 불법적인 이용으로부터 발생하는 손해<br>④ 서버에 대한 전송 또는 서버로부터의 전송에 대한 제3자의 모든 불법적인 방해 또는 중단행위로부터 발생하는 손해<br>⑤ 제3자가 "서비스"를 이용하여 불법적으로 전송, 유포하거나 또는 전송, 유포되도록 한 모든 바이러스, 스파이웨어 및 기타 악성프로그램으로 인한 손해<br>⑥ 전송된 데이터의 오류 및 생략, 누락, 파괴 등으로 발생되는 손해<br>⑦ "회원" 간의 "회원" 상태정보 등록 및 "서비스" 이용 과정에서 발생하는 명예훼손 기타 불법행위로 인한 각종 민형사상 책임<br><br>제28조 [해외이용]<br>"회사"는 전세계 모든 국가에서의 "서비스"의 동일한 품질 또는 사용성을 보장하지 않습니다. 따라서 "회원"은 "서비스"를 이용하고자 하는 경우 스스로의 판단과 책임에 따라서 이용 여부를 결정하여야 하고, 특히 "서비스"의 이용과정에서 현지 법령을 준수할 책임은 "회원"에게 있습니다.<br><br>제29조 [분쟁의 조정 등]<br>"회사"와 "회원" 사이에 개인정보나 위치정보에 관한 분쟁이 발생한 경우 쌍방 간에 분쟁의 해결을 위해 성실히 협의하도록 하고, 협의가 이루어지지 아니하거나 협의를 할 수 없는 경우에는 개인정보보호법 제43조에 따라 개인정보분쟁조정위원회에 조정을 신청할 수 있습니다.<br><br>제30조 [준거법 및 재판관할]<br>1. "회사"와 "회원"간 제기된 소송은 대한민국법을 준거법으로 합니다.<br>2. "회사"와 "회원"간 발생한 분쟁에 관한 소송은 민사소송법에 따라 관할권을 갖는 법원에 제기합니다.<br><br>제31조 [사업자정보]<br>"회사"의 상호, 주소, 전화번호 그 밖의 연락처는 다음과 같습니다.<br>1. 회사명: 케이티하이텔 주식회사<br>2. 주소: 서울시 동작구 신대방2동 395-62 삼성보라매옴니타워 KTH<br>3. 전화번호 : 1588-5668<br><br><br>부칙<br>본 약관은 2012년 1월 17일부터 적용됩니다.',
			JA: 'サービス利用規約<br><br><br>第１条　目的<br>この規約は KT Hitel株式会社(以下｢当社｣といいます)が提供するpudding.toサービスおよび関連諸般サービス(以下｢サービス｣といいます)の利用に関する、当社と会員への権利、義務、責任事項、この他に必要な事項を規定するのを目的とします。<br><br>第２条　定義<br>本利用規約において使用する用語の意義は、次の各号に定めるとおりとします。<br>１．会員とは、当社のサービスに接触して会員登録の手順を移行し、この規約による当社との利用 規約を締結した後、当社が提供するサービスを利用する者をいいます。<br>２．IDとは、会員の識別とサービス利用のために会員が決めたものとして、当社が承認する文字と数字の組合をいいます。<br>３．パスワードとは、会員が付与されたIDと一致した会員を確認し、秘密保護のために会員のご本人が決めた 文字と数字の組合をいいます。<br>４．有料コンテンツとは、サービスの中で当社が有料で提供する各種オンラインデジタルコンテンツ(各種情報コンテンツ、アイテム、その他の有料コンテンツを含めた)および諸般サービスをいいます。<br>５．掲示物とは、会員がサービスの利用によってサービス上に掲示した部号、文字、音声、音響、画面、動面なとの情報形態の文章、写真、動画および各種ファイルとリンクをいいます。<br>６．位置情報とは、位置情報の保護および利用等に関する法律(以下｢位置情報保護法｣といいます) 第2条の第1号の個人位置情報をいいます。<br><br>第３条　規約揭示と改正<br>１．当社は、この規約の内容をがいつでも閲覧可能な状態になるようにhttp://pudding.to/(以下｢ウェブサイト｣といいます)の初期画面に掲示します。<br>２．当社は、 位置情報保護法、コンテンツ振興法、電子商取引等の消費者保護に関する法律、消費者基本法、規約規制に関する法律、情報通信網の利用促進および情報保護に関する法律(以下｢情報通信網法｣といいます)などの韓国の法律を国際条約を違背しない範囲でこの規約を改正することができます。<br>３．当社が、規約を改正する場合のには、既存規約と改正規約および改正規約の適用日字と改正事由を明示し、現行規約と共に第１項の方式に通じて、その改正規約の適用日字の30日前から適用日字の前日まで公示します。ただし、会員に不利な内容で規約を改正する場合、告知の以外に会員情報で登録されたEメール、電子文字、ログイン際の同意欄などの電子的な手段を通じて別度で明確に会員の個人に告知します。<br>４．当社が、前項によって告知しながら、会員が30日以内に改正規約に関する拒否意思をしない場合にはその改正規約の内容を承認したものとみなされます。<br>５．会員が、改正規約に同意できない場合、当社は当年、会員に改正規約の内容を適用することはできません。その場合、会員は利用規約を解約することができます。ただし、当年会員に対する既存規約を適用できない特殊な事情がある場合、当社は利用規約を解約することができます。<br><br>第４条　規約外の準則等<br>１．当社は、有料サービスおよび個人サービスについて別度の利用規約および政策(｢その他の規約｣といいます)を置くことができます。その内容がこの規約に反なる場合はその他の規約が優先に適用します。<br>２．この規約に明示しない事項については当社のはその他の規約、位置情報保護法、情報通信網法、電気通信基本法、電気通信事業法などの関係法律または商慣例に従います。<br>３．規約の内容は信義誠実の原則によって当年規約の目的と趣旨を考慮し、公正・合理的に解析して平均的な顧客の理解可能性を基準で、客観的、画一的に解析します。<br><br>第５条　利用規約の締結<br>１．利用規約は、会員になる者(以下｢会員登録者｣といいます)が利用規約の内容について同意を得た後に会員登録を行い、当社はこの申請しついて承認することで締結になります。<br>２．会員の会員登録申請はオンラインまた当社が決めた別度の会員登録の方法で、以下に事項が決められている様式と方法によって記録し、申請が行います。<br>①　EメールID<br>②　プロフィール写真<br>③　名前<br>④　その他の当社が必要を認める事項<br>３．当社は、会員登録者の会員登録申請がある場合、サービス利用を承認するのを原則とします。ただし、当社は次の各①項に該当する申請に通じては承認しない場合もあり、事後に次の各①項に該当する事由があるのを認知した場合、サービスの利用を制限したり、承認を撤回することができます。<br>①　会員登録者が、この規約によって以前に会員資格を喪失したことがあるとき<br>②　他人の名義を利用して会員登録をしたとき<br>③　虚位情報を掲示したり、当社が要求する内容を掲示しないとき<br>④　14歳未満の児童が個人情報を入力する時、法定代理人(両親)の同意を得ないとき<br>⑤　会員登録者が、帰責事由によって承認が不可能になったり、その他の規定した諸般事項を違反して申請をするとき<br>⑥　その他に当社の与件上、利用承認が困難になったり、登録の欠格事由に該当するとき<br>４． 第1項による申請について当社は、会員登録者の週類によって専門機関を通じた実名確認とご本人の認証を要求することができます。<br>５．当社は、サービス関連設備の余裕がない場合、または技術および業務上の問題がある場合、承認を留保することができます。<br>６． 第3項と第5項によって会員の登録申請の承認しない、また留保する場合、当社は原則的のその内容を会員登録者に告知します。<br>７．当社は、会員について当社政策によって等級別に区分し、利用時間、利用回数、サービスメニューなどを細分化し、利用に差等を置くことができます。<br><br>第６条　会員情報の変更<br>１．会員は、プロフィール画面を通じていつでもご本人の個人情報を閲覧、修正ができます。ただし、サービスの管理として必要なEメールIDの修正は不可能になります。<br>２．会員は、会員登録の申請時に掲示した事項が変更する場合、オンラインで修正したり、電子郵便またはその他の方法で当社にその変更事項を告知しなければならないです。<br>３．会員が、 第2項の変更事項を当社に告知しないまま、発生した不利益について当社の責任はありません。<br><br>第７条　個人情報保護の義務<br>当社は、情報通信網法などの関係法律が決めたことによって、会員の個人情報を保護するため最善を尽くします。個人情報の保護および利用に関しては関連法または当社の個人情報保護の取扱いが適用とします。<br><br>第８条　会員のIDおよびパスワードの管理に関する義務<br>１．会員のIDやパスワードに関する管理責任は会員にあり、この管理を第3者が利用することはできませ。<br>２．当社は、会員のIDが個人情報の流出の憂慮があったり、反社会的または美風良俗に反したり、当社または当社の運営者から誤認する憂慮がある場合、該当IDの利用を制限することができます。<br>３．会員は、IDおよびパスワードが盗用されたり、第3者が利用することを認知する場合、即時に当社へその事実を通知し、当社の案内に従わなければなりません。<br>４．第3項の場合、該当会員が当社にその事実を通知しなたり、通知した場合にも当社に案内に従わないまま、発生した不利益について当社の責任はありません。<br>５．本サービスは、オープンIDを支援するが、オープンIDの発給、認証サービス会社が提供および管理するID,パスワード認証等と関する部分については、当社の責任はありません。<br><br>第９条　会員に対する通知<br>１．当社が、特定会員について個別的に通知する場合、この規約で別度の規定がない限りサービスで会員が登録したEメールアドレス、サービス内の電子文字などで通知できます。<br>２． 当社は、会員全員に通知をする場合、7日以上当社のウェブサイトまたはサービス画面に掲示することで第1項の通知に取り替えることができます。<br><br>第１０条　当社の義務<br>１．当社は、関連法律を本規約が禁止または美風良俗に反する行為はしないし、継続的、安定的なサービス提供に最善を尽くします。<br>２．当社は、会員が安全にサービスの利用ができるように個人情報(個人位置情報および信用情報を含む)保護のため保安システムを構築し、個人情報保護の取扱い方針を公知、遵守とします。<br>３．当社は、サービス利用に関して会員からの提起られた意見、不満事項については電子文字またはEメールなどを通じて会員に処理過程および結果を伝達します。<br><br>第１１条　会員の義務<br>１．会員は、次の各号1に該当する行為を行ってはならないものとします。<br>①　申請または変更の時、虚位内容を登録<br>②　他人の情報を盗用<br>③　当社が決めた情報以外の情報(コンピュータプログラム等)等の送信または掲示<br>④　当社とその他の第3者の著作権等の知的財産権に関する侵害<br>⑤　当社およびとその他の第3者の名誉を毀損、または業務に妨害する行為<br>⑥　猥褻または暴力的なメッセージ、画面、音声およびその他の公序良俗に反する情報をサービスに公開または掲示する行為<br>⑦　当社の同意なく営利的な目的でサービスを利用する行為<br>⑧　他の会員の個人情報およびアカウント情報を収集する行為<br>⑨　リバース・エンジニアリング、ディコンパイル、アセンブルまたは一切の加工行為を通じてサービスをコピー、分解または模倣、その他に変更する行為<br>⑩　当社が提供するサービス以外の他の方法でサービスを利用(自動接触プログラム等)して当社の正常的なサービス提供を妨害する行為<br>⑪　その他の不法的または不当的な行為<br>２．会員は関係法律、本規約の規定、利用案内およびサービスに関して公示した注意事項、当社が通知した事項等を遵守し、その他の当社の業務に妨害する行為を行ってはならないものとします。<br><br>第１２条　サービスの提供等<br>１．当社は、会員に次の各1号のようなサービスを提供とします。<br>①　pudding.to ：写真掲示、似通う場所や感情状態、タグを基盤に友たちを推薦、会話のコミュニケーションサービス<br>②　顔マッチング：サービスを利用する会員の顔写真から、サービスに転送する場合、会員の顔写真を認識し、似ている芸能人をマッチングするサービス<br>③　位置情報を活用した情報提供：サービスを利用する会員の現在位置を活用し、周辺地域のPOI情報または周辺の写真情報を提供する行為およびそれに関係した付随的な行為<br>④　その他の当社が追加開発したり、他の会社との契約によって会員に提供するすべてのサービス<br>２．当社は、サービスを一定範囲で分割し、その範囲別に利用時間を別度に指定できます。ただし、その場合にはその内容を事前に公知とします。<br>３．サービスは、年中無休、1日24時間の提供を原則とします。ただし、当社は第13条の“サービスの変更と中断”の事由が発生した場合、各サービス別に提供日字および提供方法を変更したり、サービスの提供を中断することができます。<br>４．当社は、サービスの提供が必要になる場合、定期点検を行います。また定期点検の時間にはサービスの提供画面に告知した内容を従うとします。 　<br><br>第１３条　サービスの変更と中断<br>１．当社は、次の各項の1に該当する事項が発生した場合、サービスの全部または一部を制限、変更および中断することができます。<br>①　利用量の減少による効率と収益性の悪化の場合<br>②　利用量の暴走による円滑なサービス提供に支障がある場合<br>③　コンピュータ等の情報通信設備の補修点検、交代、故障、通信途絶または運営上の相当な事項がある場合<br>④　電気通信事業法で規定させた機関通信事業者が電気通信サービスを中断する場合<br>⑤　技術進歩による次世代サービスへの転換が必要な場合<br>⑥　サービス提供に関する当社または位置情報事業者の政策変更の場合<br>⑦　関連法律の解析上、サービスの全部または一部を移行するのが違法の恐れがある場合<br>⑧　国家非常状態、法律の再改定、裁判所の判決、行政機関の処分および命令等でサービス提供に支障がある場合<br>⑨　会員がサービスの運営を故意または重過失で妨害を行う場合<br>⑩　その他の事由よる当社がサービス提供を維持するのが不適当と認定する場合<br>２．当社は、サービスの内容、利用方法、利用時間について変更があったり、サービスの中断がある場合には会員に第9条の“会員に対する通知”に決めた方法で変更および中断の事由、変更するサービスの内容と提供日字等を通知します。ただし、当社が事前に通知できない事項がある場合には事後に通知することができます。<br>３．当社は、無料で提供するサービスの一部または全部を、当社の政策および運営の必要上に修正、中段、変更することに関して関連法に決めされた特別な規定がある限り、会員に別の補償を行ってはならないものとします。<br><br>第１４条　情報の提供と広告の配信<br>１．当社は、会員がサービスの利用中に必要だと認定する多様な情報をウェブサイトや電子郵便等の方法で会員に提供することができます。ただし、会員は関連法による取引情報、ヘルプテスクの返答を除き、いつでも電子郵便に通じて受信拒否ができます。<br>２．第1項の情報を電話または模写電送機器を使って転送する場合、会員の事前同意を得て行います。<br>３．当社は、サービスの運営に関してサービス画面、ウェブサイト、電子郵便等に掲示することができます。広告が掲示された電子郵便を受信された会員が受信拒否意思を当社に表示することができます。<br><br>第１５条　掲示物に関する会員の権利と当社の利用権限<br>１．会員が、サービス内に掲示した掲示物の権利は原則的に該当掲示物の権利者に帰属し、会員の掲示物が第3者の著作権等の知的財産権侵害によって発生する民事、刑事上の責任は以下の各項による掲示物に関する権利を付与とします。<br>２．当社のサービスに関する利用権限<br>当社は、会員の掲示物を検索結果、サービス関連プロモーション等に露出することができ、該当露出のために必要な範囲で一部を修正、コピー、編集して掲示することができます。<br>３．当社および第3業者への掲示物の無償利用権<br>会員は本規約に同意をした後、サービス上に掲示物を掲示するのは、以下と同じの権利を当社と提携した第3業者に対して無償に承認するみなされます。その時、当社や第3業者はコンピュータネットワク、 メディア上への転送、掲示または配信のため会員の掲示物を変更、修正、変形することができます。<br>①　当社および第3業者が現在、存在したり、将来に開発されるどのような媒体を通じても、当年掲示物を全世界に渡って非独占的に利用(コピー、複製、処理、アレンジ、変更、公表、転送、掲示または配信)ができる権利<br>②　当社および第3業者以上の①号の権利をその他の第3者に再承諾できる権利<br> 　<br>第１６条　掲示物の管理<br>１．会員の掲示物が譲歩通信網法、著作権法、青少年保護法等の現行法律または 公序良俗に反する内容を含めて、被害者と権利者が、関連法律が決めた手順による該当の掲示物の掲示中段または削除等を要請した場合、当社は関連法律による処置を行います。<br>２．当社は前項に対する権利者の要請がなくても、権利侵害が認める事由があったり、公序良俗またはその他の当社の政策および関連法律に反するものだと判断する場合、関連法律による該当掲示物の削除、閲覧禁止等の臨時処置等を行います。<br>３．本条に対する細部手順は情報通信網法、著作権法等の関連法律が規定した範囲で当社が規定した方針を従うとします。<br>http://help.paran.com/faq/report/RightReport.jsp<br><br>第１７条　権利の帰属<br>１．サービスに関する著作権および知的財産権は、当社に帰属とします。ただし、会員の掲示物および 提携契約によって提供された著作物は除くとします。<br>２．当社が、提供するサービスのデザイン、当社が制作したTEXT、SCRIPT、グラフィック、会員お互い間コミュニケーションおよび伝送機能等、当社が提供するサービスに関したすべての商標、サービス票、デザイン、ロゴ、スローガン等の全ての知的財産権は韓国法律と国際条約期して当社に所有権または使用権があるとします。<br>３．会員が、本利用規約によってサービスおよびその他に関する著作権、権利の取得を行ってはならないものとします。また当社が決めた範囲へのサービス利用権のみを承諾されるので、会員はサービスを情報取得または個人用度下で、当社から提供された形態のみ利用できます。<br>４．会員は、当社から明視的に承諾された内容を除いては、サービスを通じて受けられる会員状態情報を営利的な目的で利用、コピー、流通するのを行ってはならないものとします。また当社が制作したSCRIPT、TEXT、グラフィック、 会員お互い間コミュニケーションおよび伝送機能等をコピーしたり、流通するのを行ってはならないものとします。<br>５．当社は、サービスに関して会員に当社が規定した利用兆件によってアカウント、ID、コンテンツ等を利用できる利用権のみを付与し、会員はそれを他人に 譲り渡し、販売、 担保提供、 利用承諾するのは行ってはならないものとします。<br><br>第１８条　個人情報保護の義務<br>１．会員は、いつでもアカウント管理メニューを通じて、サービスの脱退申し込みをすることによって利用規約を解約することができ、当社は関連法律と内部基準等が規定した内容を通して、即時に勝利を行うとします。<br>２．会員が、利用規約を解約する場合、当社は関連法律または個人情報収集方針、関係当国の方針によって当社が記録、保存を行ってはならないもを除き、解約の即時に会員に関する全ての情報を削除とします。<br>３．会員が、利用規約を解約する場合、会員アカウントで登録された掲示物も一体を削除とします。ただし、他人のアカウントに登録した掲示物、他人の掲示物の残したコメント等の掲示物は削除をしないとします。<br><br>第１９条　利用制限等<br>１．当社は、会員に次の各項1に該当する行為をしたり、放送通信審議委員会等の関連機関の要請がある場合、事前通知なく、当年会員との利用規約を削除したり、警告、一時停止、永久停止等でサービスの利用を段階的に制限することができます。<br>①　本規約の義務を違反したり、サービスの正常的な運営を妨害する行為<br>②　サービスの保存空間に淫乱物を掲示したり、淫乱サイトをリンクりたり、配信するなどの公序良俗に反する行為<br>③　公序良俗または美風良俗に反する内容の情報、文章、図形、音声等を配信する行為<br>④　他人の名誉を毀損、侮辱する行為<br>⑤　当社または第3者の著作権、知的財産権等のその他の権利を侵害する行為または、サービスに掲示された資料および著作物の発信人を偽造する行為<br>⑥　関係法律による製造、収入、転送または掲示が禁止された技術、製品、情報の製造、収入、転送および掲示の行為<br>⑦　犯罪に関連があると反端される行為<br>⑧　ハッキング、コンピュータウイルスを流布したり、他人の意思に反した広告性に情報等の一定な情報を持続的に転送する行為<br>⑨　他の会員のIDを不正利用したり、他人を詐称する行為<br>⑩　他の会員の個人情報を収集、盗用、保存したり、流布する行為<br>⑪　他人をSTALKしたり、虐める行為<br>⑫　正当な事由がなく、会員登録と脱退を繰り返し金全的な利益を得たり、当社のサービス運営に支障を与える行為<br>⑬　ご本人のIDを他人に譲渡、販売したり、利用させたりする行為<br>⑭　その他のサービスの運営に支障を与えたり、与える可能性がある一切の行為および関係法律に反する行為<br>２．当社は、前項にも関らず住民登録法に反する名義盗用、決済盗用、著作権法を違反する不法プログラムの提供と運営妨害、情報通信網法を違反する不法通信、ハッキング、悪性プログラムの配信、接触権限の超過行為などの関連法律を違反する場合、即時に利用規約を解約することができます。本項による利用規約の解約時、会員がサービス利用に通じて獲得した恵沢等も全て消滅し、当社はそれに関して別度補償の責任はありません。<br>３．当社は、会員が継続に3ヶ月以上にログインしない場合、会員情報の保護と運営の効率性のため利用制限をすることができます。<br>４．本条の利用制限の範囲内での制限兆件および細部内容は当社が規定した利用制限制作を従うとします。<br>５．本条によってサービスの利用を制限したり、規約を解約する場合には、当社は第9条“会員に対する通知”の方法によって告知とします。<br>６．会員は、 本条による利用制限等について当社が規定した手順(利用制限等の処置に対する告知メール案内)を通じて異議申し立てをすることができます。異議が正当だと当社が認定する場合、当社は即時にサービスの利用を再開とします。<br><br>第２０条　位置情報の収集方法<br>当社は、位置情報事業者が以下の方法中のひとつ、またはその方法を組合した位置情報をサービスのデータとして利用することができます。<br>１．携帯端末機を利用した基地局(Cell ID方式)のリアルタイムの位置情報の収集<br>２．GPSチップが内臓した専用端末機を通じて収集されるGPS情報の位置情報の収集<br>３．Wi-Fiチップが内臓した専用端末機を通じて収集される位置情報の収集<br><br>第２１条　位置情報の利用<br>１．当社は、会員がモバイル端末機でからサービスを接触した後、最初1回“位置情報利用に同意する。”の意思を表示した場合にはその後に該当会員の位置情報または個人位置情報をサービスに利用することができます。<br>２．サービス接触後、位置情報利用に同意しない会員の場合、位置情報を使用する機能を利用する際に位置情報利用に関する同意要請をすることができます。同意しない会員の場合、モバイル端末機からの正常的なサービス利用が混乱になる場合もあります。<br>①　会員が、モバイル端末機から自動ログイン機能を選択しない場合、会員はモバイル端末機からログインをする際位置情報利用の同意可否を選択することができます。<br>②　当社は、会員が位置情報利用に同意しない場合、該当の会員の位置情報を利用しません。<br>③　会員が、満14歳未満の児童の場合、当社は情報通信網法の第23条によって法定代理人の同意を得る手順を行うとします。<br>３．当社は、会員の現在位置を基盤でユーザをおすすめするために位置情報を利用することができます。<br>４．会員が欲しい場合、いつでもサービスへの脱退ができ、サービス脱退の場合には位置情報利用に対する会員の同意が撤回したものとみなされます。<br><br>第２２条　会員の個人位置情報に対する権利<br>１．会員は、個人位置情報の主体として個人位置情報の収集範囲、利用規約、個人位置情報の収集、利用、提供目的に関する同意、提供される者の範囲または位置基盤サービス等の全部または一部についた同意の留保ができます。<br>２．会員は、いつでも個人位置情報の収集、利用、提供の一時的な中断を要求することができます。当社はその要求を拒否することはありません。また、このような技術的な手段を備えでいます。<br>３．会員は、当社について次の各1項のような資料の閲覧または告知を要求することができ、当年資料に誤謬がある場合、その訂正を要求することができます。この場合当社は正当な事由なしに要求を拒否することはできません。<br>①　位置情報の収集、利用、提供事実の確認資料<br>②　個人位置情報が位置情報保護法、その他の法律の規定によって第3者に提供された理由および内容<br>４．当社は、会員が本条によって同意の全部または一部を撤回した場合には地帯なく収集した個人位置情報および位置情報の収集、利用、提供事実の確認資料を破棄します。ただし、同意の一部を撤回する場合には、撤回する部分の個人位置情報または位置情報の収集、利用、提供の事実資料に限ります。<br>５．会員は第1項または第3項の権利行事のため、この規約第31条の連絡先を利用し、当社に要求することができます。<br><br>第２３条　個人情報保護の義務<br>１．当社は、満14歳未満の児童からへの位置情報を収集、利用、提供する場合、満14歳未満の児童とその法定代理人の同意を得なければなりません。<br>２．法定代理人は、満14歳未満の児童の個人位置情報を収集、利用、提供に関する同意権、同意留保権、同意撤回権および一時中止権、閲覧と告知要求権を行事することができます。<br><br>第２４条　8歳以下の児童保護のために位置情報の利用<br>１．次の各項1に該当する者(以下｢8歳以下の児童等｣)の保護義務者が個人位置情報についた収集、利用または提供に同意した場合にはご本人の同意したものとみなされます。<br>①　8歳以下の児童<br>②　禁治産者<br>③　障害人福祉法の第2条の第2項の第2号の規定による精神的な障害を持つ者として、障害人雇用の促進法および職業再活法の第2条の第2号の規定による重症障害人に該当する者(障害人福祉法の第32条の規定によって障害人登録の完了した者に限り)<br>２．第1項の規定による8歳以下の児童等の保護義務者は、8歳以下の児童等を事実上に保護する者として次の各項の1に該当する者といいます。<br>①　8歳以下の児童の法定代理人または保護施設にいる未成年者の後見職務に関する法律の第3条の規定による後見人<br>②　禁治産者の法定代理人<br>③　第1項の第3号の者の法定代理人または障害人福祉法の第58条の第1項の第1号の規定による障害人生活施設(国家および地方自治団体が設置、運営する施設に限り)の長、精神健康法の第3条の第4項の規定による精神疾患者の社会復帰施設(国家および地方自治団体が設置、運営する施設に限り)の長、精神保健法の第3条の第5号の規定による精神療養施設の長<br>３．保護義務者は、8歳以下の児童等の個人位置情報の利用または提供に同意した場合、位置情報の主体である8歳以下の児童等の権利全てを行事することができます。<br><br>第２５条　個人位置情報を第3者に提供する場合の即時通知<br>１．当社は、会員の同意なく会員の個人情報を第3者に提供することはできず、もし、第3者にその情報を提供する場合には提供される者と提供目的を事前に会員に告知し、同意を得ることにします。<br>２．当社は、会員の個人位置情報を当年に会員が規定した第3者に提供する場合には、提供時に個人位置情報を収集した当年の会員の通信端末機で提供される者と提供目的を即時に告知します。<br>３．ただし、各項の１に該当する場合には個人位置情報の主体である会員が事前に特定して、指定した通信端末機または電子郵便住所等に告知します。<br>①　個人位置情報を収集した当年の通信端末機が文字、音声または動面の受信機能が備えない場合<br>②　個人位置情報の主体である会員が、個人位置情報を収集された当年の通信端末装置外の通信端末装置または電子郵便住所等に告知するのを事前に要求した場合<br><br><br>第２６条　損害賠償<br>１．当社は、会員がサービスを利用することによって当社の故意、重大な過失を通じた損害を賠償する責任を負担します。<br>２．会員が本規約の義務を違反することによって当社に損害を与えた場合、または会員がサービスの利用することによって当社に損害を与えた場合、会員は当社に対するその損害を賠償する責任があります。<br>３．個人位置情報の主体である会員が、当社が位置情報法第15条または第26条の規定を違反する行為として損害を与えた場合、当社に対して損害賠償を請求することができます。その場合、当社は故意または過失がないのを立証しないと、その責任を負うものとします。 　 　<br><br>第２７条　責任制限<br>１．当社が、天災地変またはそれに準じる不可抗力でサービスの提供ができない場合、サービス提供の義務違反の責任を負いません。<br>２．当社が、会員の帰責事由で発生したサービス利用の障害については責任を負いません。<br>３．当社が、会員のサービスと関連して掲示した情報、資料、事実の信頼度、正確性等の関することには責任を負いません。<br>４．当社が、会員お互いのまたは会員が第3者お互いにサービスを媒介として売買等をしてから会員または取引の相手である第3者に発生した損害の責任を負いません。<br>５．当社は、サービス中で無料に提供する領域に関しては、その利用と関する法律に特別な規定がない限り責任を負いません。<br>６．当社は、第3者がサービス内の画面またはリンクされたウェブサイトを通じて広告した製品またはサーヒスの内容と品質について監視する義務、その他のどのような責任も負いません。<br>７．当社および当社の役職員そして代理人は次の各項の1と該当する事項から発生する損害について責任を負いません。<br>①　会員の状態情報を虚位または不正確性で起因する損害<br>②　その性質、経緯を不問してサービスへの接触またはサービスの利用過程で発生した個人的な損害<br>③　サーバーに関する第3者の全ての不法的な接触または不法的な利用から発生した損害<br>④　サーバーへの転送またはサーバーからの転送に関する第3者の不法的な妨害および中断行為から発生した損害<br>⑤　第3者がサービスを利用して、不法的に転送、流布したり、または転送、流布するようにする全てのウイルス、スパイウェアおよび悪性プログラムから発生した損害<br>⑥　転送したデータの誤謬、省略、抜け落ち、破壊等で発生した損害<br>⑦　会員同士への会員状態情報の登録およびサービス利用過程で発生する名誉毀損、その他の不法行為での各種民事、刑事上の責任<br><br>第２８条　海外利用<br>当社は、全世界全ての国家へのサービスの同一な品質または使用姓を保障しません。なお、会員はサービスを利用とする場合、自らの判断と責任によって利用可否を決める責任があり、特にサービスの利用過程で現地法律を遵守する責任は会員にあります。<br><br>第２９条　紛争と調停<br>当社と会員間で個人情報や位置情報に関する紛争が発生した場合、両方間の紛争解決のために誠実に協議し、協議を得ない場合または協議ができない場合には個人情報法の第43条による個人情報紛争調停委員会に調停申請をすることがせきます。<br><br>第３０条　準拠法及び管轄裁判所<br>１．当社と会員の間に提起した訴訟の準拠法は、韓国法とします。<br>２．当社と会員の間に発生した紛争に関する訴訟は民事訴訟法によって管轄権を持つ裁判所が提起とします。<br><br>第３１条　事業者情報<br>当社の商号、住所、電話番号および他の連絡先はご覧になります。<br>１．会社名：KT　Hitel株式会社<br>２．住所：: Samsung Boramae Omni Tower KTH, 395-62, Sindaebang-2 dong, Dongjak-gu, Seoul, Republic of Korea<br>３．電話番号：1588-5668<br><br>附則<br>本規約は2012年1月17日から適用とします。<br>'
		},
		DEFAULT = 'EN';
	
	return {
		get: function(locale) {
			return TERMS_OF_USE_AGREEMENT[String(locale).toUpperCase()] || TERMS_OF_USE_AGREEMENT[DEFAULT];
		}
	};
})('kth.puddingto.termsOfUseAgreement'));

})(window);